<?php
defined('ABSPATH') or die("No direct script access!");

// Ajax load products into tab for theme eleven
add_action('wp_ajax_get_products_by_cat_theme_eleven', 'get_products_by_cat_theme_eleven');
add_action('wp_ajax_nopriv_get_products_by_cat_theme_eleven', 'get_products_by_cat_theme_eleven');


function get_products_by_cat_theme_eleven()
{
    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids    = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }
    
    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        /* $args =  array_merge($args, array( 'tax_query' => array(
                            array(
                                'taxonomy' => 'product_visibility',
                                'field'    => 'name',
                                'terms'    => 'exclude-from-catalog',
                                'operator' => 'NOT IN',
                            ),
                    )));*/


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $product_query = new WP_Query($args);
    $number_of_product = $product_query->post_count;
    $wc_pf = new WC_Product_Factory();
    $html = '';

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        
        $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).' qc_'.esc_attr($product_stock_status).'"><div class="product-box">';

               if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<a href="#" class="woo_tab_product_details too_tab_single_link" product-id="'.$product->get_id().'">';
                 }else{ 
            $html .= '<a href="' . $product->get_permalink() . '">';
                }

        $html .= '<div class="product-img">';
        if ( has_post_thumbnail() ):
        $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
        elseif(empty(has_post_thumbnail()) && empty(get_the_excerpt(get_the_ID()))):
        $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
        else:
        $html .= ''. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>') .'';
        endif;
        $html .= '<div class="eleven-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div></a>';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):

               if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
        endif;

        if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
        $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
        } 
              
                                         
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_one">';

        if(get_option('qc_quick_view_on_off') != 'off'): 
        $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
        endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'): 
                      $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                    $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text(get_the_ID(),0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];

                $html .= '<input class="qc_minus" type="button" value="-">
                <input type="text" class="qc_product_quantity"
                       name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                <input class="qc_plus" type="button" value="+">';
            }else{

                $html .= '<input class="qc_minus" type="button" value="-">
                <input type="text" class="qc_product_quantity"
                       name="qcld_quantity" value="1">
                <input class="qc_plus" type="button" value="+">';

            }
                endif;
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                if ($product->get_type() != 'variable'): 

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';

                    endif;

                else:
                $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                endif;
            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i
                            class="fa"
                            aria-hidden="true"></i></a>';
            }
        endif;


        $html .= '</div >';

        $html .= '</div><div class="clear"></div></div>';

            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';

    endwhile;
    $html .= '</li>';
    wp_reset_query();
    $response = array(
        'cat_id'          => $cat_id,
        'html'            => $html,
        'offset'          => $offset,
        'product_number'  => $number_of_product
    );
    echo wp_send_json($response);
    wp_die();
}

// Ajax products sorting theme eleven
add_action('wp_ajax_get_products_by_cat_short_theme_eleven', 'get_products_by_cat_short_theme_eleven');
add_action('wp_ajax_nopriv_get_products_by_cat_short_theme_eleven', 'get_products_by_cat_short_theme_eleven');

function get_products_by_cat_short_theme_eleven()
{
    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];
    $sorting_val    = $_POST['sorting_val'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids    = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    
    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', 
            array(
                array(
                    'taxonomy' => 'product_visibility',
                    'field' => 'name',
                    'terms' => 'featured',
                    'operator' => 'IN'
                )
            )
        );


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }


         if($sorting_val == 'popularity'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                //'orderby_meta_key'  => 'total_sales',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'rating'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'date'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price-desc'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else{

            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => $sorting,
                'orderby'           => $orderBy,
                'order'             => get_option('qc_product_sort_order'),
                'tax_query'         => array(
                    'relation'      => 'OR',
                    array(
                        'taxonomy'  => 'product_cat',
                        'field'     => 'term_id',
                        'terms'     => $categories_all,
                        'operator'  => 'IN'
                    ),
                )
            );

        }


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

           /* $args =  array_merge($args, array( 'tax_query' => array(
                                array(
                                    'taxonomy' => 'product_visibility',
                                    'field'    => 'name',
                                    'terms'    => 'exclude-from-catalog',
                                    'operator' => 'NOT IN',
                                ),
                        )));*/


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', 
            array( // Simple products type
                'key' => '_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            )
        );

        if($sorting_val == 'popularity'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                //'orderby_meta_key'  => 'total_sales',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $cat_id,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'rating'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $cat_id,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'date'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $cat_id,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $cat_id,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price-desc'){
            $args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'posts_per_page'    => $post_per_page,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $cat_id,
                        'operator' => 'IN'
                    ),
                )
            );
        }else{

            $sorting = '';
            $orderBy = get_option('qc_product_sort_type');
            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                $sorting = '_price';
            }
            if( get_option('qc_product_sort_type') == 'total_sales' ){
                $sorting = 'total_sales';
                $orderBy = 'meta_value_num';
            }

          $args = array(
              //  'post_type'             => 'product',
                'post_type'             => array('product', 'product_variation'),
                'post_status'           => 'publish',
                'posts_per_page'        => $post_per_page,
                'meta_key'              => $sorting,
                'orderby'               => $orderBy,
                'order'                 => get_option('qc_product_sort_order'),
                'tax_query'             => array(
                                        'relation' => 'OR',
                                        array(
                                            'taxonomy' => 'product_cat',
                                            'field' => 'term_id',
                                            'terms' => $cat_id,
                                            'operator' => 'IN'
                                ),
                            )
                        );
        }
        
        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));

    }


    $product_query = new WP_Query($args);
    $number_of_product = $product_query->post_count;
    $wc_pf = new WC_Product_Factory();
    $html = '';

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        
        $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).' qc_'.esc_attr($product_stock_status).'"><div class="product-box">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<a href="#" class="woo_tab_product_details too_tab_single_link" product-id="'.$product->get_id().'">';
            }else{ 
            $html .= '<a href="'. $product->get_permalink() .'">';
            }
        $html .= '<div class="product-img">';
        if ( has_post_thumbnail() ):
        $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
        elseif(empty(has_post_thumbnail()) && empty(get_the_excerpt(get_the_ID()))):
        $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
        else:
        $html .= ''. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>') .'';
        endif;
        $html .= '<div class="eleven-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div></a>';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
               if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }

        endif;
        
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                  
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_one">';

        if(get_option('qc_quick_view_on_off') != 'off'): 
        $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
        endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'): 
                

                $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                    $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text(get_the_ID(),0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];

                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                    <input class="qc_plus" type="button" value="+">';
                }else{

                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="1">
                    <input class="qc_plus" type="button" value="+">';
                    
                }


                endif;
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                if ($product->get_type() != 'variable'): 

                            

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';

                    endif;



                else:
                $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                endif;
            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
            }
        endif;


        $html .= '</div >';

        $html .= '</div><div class="clear"></div></div>';                         
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';
    endwhile;
    $html .= '</li>';
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $offset,
        'product_number' => $number_of_product
    );
    echo wp_send_json($response);
    wp_die();
}