<?php

if (!defined('ABSPATH')) {
    exit;
}

/**
 * QC Product Category Widget
 *
 */
class Woo_tabbed_WC_Widget_Product_Categories2 extends WC_Widget
{

    /**
     * Category ancestors
     *
     * @var array
     */
    public $cat_ancestors;

    public $qc_selected_theme;


    /**
     * Current Category
     *
     * @var bool
     */
    public $current_cat;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->widget_cssclass = 'woocommerce widget_product_categories';
        $this->widget_description = __('A list or dropdown of product categories.', 'woo-tabbed-category');
        $this->widget_id = 'woocommerce_product_categories2';
        $this->widget_name = __('Woo Tab Product Category Dropdown', 'woo-tabbed-category');
        $this->settings = array(
            'title' => array(
                'type' => 'text',
                'std' => __('Product Categories Selection', 'woo-tabbed-category'),
                'label' => __('Title', 'woo-tabbed-category')
            ),
            'orderby' => array(
                'type' => 'select',
                'std' => 'name',
                'label' => __('Order by', 'woo-tabbed-category'),
                'options' => array(
                    'order' => __('Category Order', 'woo-tabbed-category'),
                    'name' => __('Name', 'woo-tabbed-category')
                )
            ), 
            'qc_theme' => array(
                'type' => 'select',
                'std' => 'qc_theme_one',
                'label' => __('Select a theme', 'woo-tabbed-category'),
                'options' => array(
                    'qc_theme_one' => __('Colorized', 'woo-tabbed-category'),
                    'qc_theme_bubba' => __('Bubba', 'woo-tabbed-category'),
                    'qc_theme_skinny' => __('Skinny', 'woo-tabbed-category'),
                    'qc_theme_transit' => __('Transit', 'woo-tabbed-category'),
                    'qc_theme_jet' => __('Jet', 'woo-tabbed-category'),
                    'qc_theme_nix' => __('Nix', 'woo-tabbed-category'),
                )
            ),
            'qc_exclude' => array(
                'type' => 'text',
                'std' => __('', 'woo-tabbed-category'),
                'label' => __('<p>Exclude Category by Category ID </p> <p>You can add multiple Category ID as coma(,) seperated value. </p><p><i>Example: exclude="15,16,17" </i></p>', 'woo-tabbed-category')
            ),
            'dropdown' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Show as dropdown', 'woo-tabbed-category')
            ),
            'count' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Show product counts', 'woo-tabbed-category')
            ),
            'hierarchical' => array(
                'type' => 'checkbox',
                'std' => 1,
                'label' => __('Show hierarchy', 'woo-tabbed-category')
            ),
            'show_children_only' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Only show children of the current category', 'woo-tabbed-category')
            ),
            'show_single_page_children_only' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Single Page Only show children of the current category', 'woo-tabbed-category')
            ),
            'show_single_page_product_list' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Show Single Page product List according to category', 'woo-tabbed-category')
            ),
            'show_product_cat_page_product_list' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Show Product Cateogry Page product List according to category', 'woo-tabbed-category')
            ),

            'expand_collapse' => array(
                'type' => 'checkbox',
                'std' => 0,
                'label' => __('Show as Expand/Collapse', 'woo-tabbed-category')
            ),
        );

        //add_action('wp_enqueue_scripts', array(&$this, 'woo_tabbed_wa_wcc_load_scripts'));

        parent::__construct();
    }

    /**
     * widget function.
     *
     * @see WP_Widget
     *
     * @param array $args
     * @param array $instance
     *
     * @return void
     */
    public function widget($args, $instance)
    {
        //error_reporting(E_ALL ^ E_NOTICE);
        global $wp_query, $post, $wpdb, $woocommerce, $wp_session;


        $c = isset($instance['count']) ? $instance['count'] : $this->settings['count']['std'];
        $h = isset($instance['hierarchical']) ? $instance['hierarchical'] : $this->settings['hierarchical']['std'];
        $s = isset($instance['show_children_only']) ? $instance['show_children_only'] : $this->settings['show_children_only']['std'];
        $show_single_page_children_only = isset($instance['show_single_page_children_only']) ? $instance['show_single_page_children_only'] : $this->settings['show_single_page_children_only']['std'];
        $show_single_page_product_list = isset($instance['show_single_page_product_list']) ? $instance['show_single_page_product_list'] : $this->settings['show_single_page_product_list']['std'];
        $show_product_cat_page_product_list = isset($instance['show_product_cat_page_product_list']) ? $instance['show_product_cat_page_product_list'] : $this->settings['show_product_cat_page_product_list']['std'];
        $d = isset($instance['dropdown']) ? $instance['dropdown'] : $this->settings['dropdown']['std'];
        $o = isset($instance['orderby']) ? $instance['orderby'] : $this->settings['orderby']['std'];
        $qc_theme = isset($instance['qc_theme']) ? $instance['qc_theme'] : $this->settings['qc_theme']['std'];
        $e_c = isset($instance['expand_collapse']) ? $instance['expand_collapse'] : $this->settings['expand_collapse']['std'];

        $qc_exclude = isset($instance['qc_exclude']) ? $instance['qc_exclude'] : $this->settings['qc_exclude']['std'];

        


        $this->qc_selected_theme = $qc_theme;

        $keysR = $arrr = array();
        //all categories
        $cats = array();
        $q = 'SELECT tt.term_id term_id
		FROM ' . $wpdb->term_taxonomy . ' tt
		WHERE tt.taxonomy = "product_cat"';
        $all_cats = $wpdb->get_results($q);

        if (count($all_cats) > 0) {

            foreach ($all_cats as $ac) {
                $cats[] = $ac->term_id;
            }
        }
        if (isset($instance['panels_info'])) {
            $postid = get_the_ID();
        } else {
            $postid = '';
        }
        //

        // echo "<pre>"; print_r($instance['panels_info']); echo "</pre>";
        //selected categories
        $query = 'SELECT option_value
		FROM ' . $wpdb->options . '
		WHERE option_name LIKE "taxonomy_' . str_replace(" ", "_", $instance['title']) . $postid . '"';

        $res = $wpdb->get_results($query);

        $n = array();

        if ($cats && $keysR) $arrr = array_diff($cats, $keysR);
        $excl = implode(",", $arrr);

        $dropdown_args = array('hide_empty' => false, 'exclude' => $excl);
        $list_args = array('show_count' => $c, 'hierarchical' => $h, 'taxonomy' => 'product_cat', 'hide_empty' => false);

        // Menu Order
        $list_args['menu_order'] = false;
        if ($o == 'order') {
            $list_args['menu_order'] = 'asc';
        } else {
            $list_args['orderby'] = 'title';
        }

        // Setup Current Category
        $this->current_cat = false;
        $this->cat_ancestors = array();

        if (is_tax('product_cat')) {

            $this->current_cat = $wp_query->queried_object;
            $this->cat_ancestors = get_ancestors($this->current_cat->term_id, 'product_cat');


        } elseif (is_singular('product')) {

            $product_category = wc_get_product_terms($post->ID, 'product_cat', array('orderby' => 'parent'));

            if ($product_category) {
                $this->current_cat = end($product_category);
                $this->cat_ancestors = get_ancestors($this->current_cat->term_id, 'product_cat');
            }

        }

        // Show Siblings and Children Only
        if ($s && $this->current_cat) {

            // Top level is needed
            $top_level = get_terms(
                'product_cat',
                array(
                    'fields' => 'ids',
                    'parent' => 0,
                    'hierarchical' => true,
                    'hide_empty' => false,
                    'exclude' => $excl
                )
            );



            // Direct children are wanted
            $direct_children = get_terms(
                'product_cat',
                array(
                    'fields' => 'ids',
                    'parent' => $this->current_cat->term_id,
                    'hierarchical' => true,
                    'hide_empty' => false,
                    'exclude' => $excl
                )
            );

            // Gather siblings of ancestors
            $siblings = array();
            if ($this->cat_ancestors) {
                foreach ($this->cat_ancestors as $ancestor) {
                    $ancestor_siblings = get_terms(
                        'product_cat',
                        array(
                            'fields' => 'ids',
                            'parent' => $ancestor,
                            'hierarchical' => false,
                            'hide_empty' => false
                        )
                    );
                    $siblings = array_merge($siblings, $ancestor_siblings);
                }
            }

          

            if ($h) {

                if(is_singular('product') && ($show_single_page_children_only == 1)){ 
                    $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent') );
                    $current_cat            = end($product_category);


                    $category_parent        = $current_cat->parent;
                    $current_category_item = get_terms(
                        'product_cat',
                        array(
                            'fields' => 'ids',
                            'parent' => $category_parent,
                            'hierarchical' => true,
                            'hide_empty' => false,
                            'exclude' => $excl
                        )
                    );

                    $include = array_merge($current_category_item);


                }else{
                $include = array_merge($top_level, $this->cat_ancestors, $siblings, $direct_children, array($this->current_cat->term_id));
                    
                }


            } else {
                $include = array_merge($direct_children);
            }

            // var_dump($h);
            // die();

            $dropdown_args['include'] = implode(',', $include);
            $list_args['include'] = implode(',', $include);

            if (empty($include)) {
                return;
            }

        } elseif ($s) {
            $dropdown_args['depth'] = 1;
            $dropdown_args['child_of'] = 0;
            $dropdown_args['hierarchical'] = 1;
            $list_args['depth'] = 1;
            $list_args['child_of'] = 0;
            $list_args['hierarchical'] = 1;
        }

        $this->widget_start($args, $instance);

        // Dropdown
        if ($d) {
            $dropdown_defaults = array(
                'show_counts' => $c,
                'hierarchical' => $h,
                'show_uncategorized' => 0,
                'orderby' => $o,
                'selected' => $this->current_cat ? $this->current_cat->slug : ''
            );
            $dropdown_args = wp_parse_args($dropdown_args, $dropdown_defaults);

            // Stuck with this until a fix for http://core.trac.wordpress.org/ticket/13258
            wc_product_dropdown_categories(apply_filters('woocommerce_product_categories_widget_dropdown_args', $dropdown_args));

            wc_enqueue_js("
				jQuery('.dropdown_product_cat').change(function(){
					if(jQuery(this).val() != '') {
						location.href = '" . home_url() . "/?product_cat=' + jQuery(this).val();
					}
				});
			");

            // List
        } else {

            include_once(WC()->plugin_path() . '/includes/walkers/class-product-cat-list-walker.php');
            $this->woo_tabbed_wa_wcc_load_scripts();
            if ($e_c) {

               
                ?>

                <script>

                    jQuery(document).ready(function ($) {

                        $("li.current-cat-parent").addClass('current-cat');
                        var mtree = $('ul.mtree');
                        mtree.addClass('default');

                    });

                </script>

                <?php
            
                $list_args['walker'] = new WC_Product_Cat_List_Walker;
                $list_args['title_li'] = '';
                $list_args['pad_counts'] = 1;
                $list_args['show_option_none'] = __('No product categories exist.', 'woo-tabbed-category');
                $list_args['current_category'] = ($this->current_cat) ? $this->current_cat->term_id : '';
                $list_args['current_category_ancestors'] = $this->cat_ancestors;
                $list_args['echo'] = false;

                if(!empty($qc_exclude)){
                    $exclude_category =  explode(',', $qc_exclude);
                    $list_args['exclude'] = $exclude_category;
                }else{

                    $list_args['exclude'] = $excl;
                }

                $list_args['heiararchical'] = true;

                echo '<div class="wcc_block">';
                echo '<ul class="mtree">';

             if(is_singular('product') && ($show_single_page_children_only == 1) && ($show_single_page_product_list == 1)){ 

                    $default_cat = $_SERVER['HTTP_REFERER'];

                    $default_cat = explode('/', $default_cat);

                    $default_cat_slug = $default_cat[count($default_cat)-2];


                    $default_cat_array = get_term_by( 'slug', $default_cat_slug, 'product_cat' );

                    $default_cat_term_id = '';
                    if(!empty($default_cat_array)){
                        $default_cat_term_id = $default_cat_array->term_id;
                       
                    }


                    if(!empty($default_cat_term_id)){

                        $product_category       =  get_term_by( 'id', absint( $default_cat_term_id ), 'product_cat' );
                        $current_cat            = $product_category;

                        if(!empty($current_cat->parent)){

                            $category_parent        = $current_cat->parent;
                            $woo_category_obj       = get_term_by( 'id', absint( $category_parent ), 'product_cat' ); 
                            $category_parent_name   = $woo_category_obj->name;

                        }


                    }else{
                        
                        $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent', 'fields' => 'all' ) );
                        $current_cat            = end( $product_category );
                        $category_parent        = $current_cat->parent;
                        $woo_category_obj       = get_term_by( 'id', absint( $category_parent ), 'product_cat' ); 
                        $category_parent_name   = $woo_category_obj->name;
                        
                    }

                    $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent') );
                    $current_cat            = end($product_category);

                    $current_post_id = $post->ID;

                    //check if current cat has children
                    if( ! empty( $current_cat ) )
                        $current_cat_children = 
                            get_terms( 
                                'product_cat', 
                                array( 
                                    'parent' => $current_cat->term_id, 
                                    'fields' => 'all', 
                                    'hide_empty' => 0 
                                ) 
                            );
                    
                    if( ! empty( $current_cat_children ) ){
                        
                        $terms_to_include = 
                            array_merge( 
                                array( $current_cat->term_id ), 
                                $current_cat_children 
                            );
                        
                    }else{
                        
                        if( ! empty( $category_parent ) ){
                            $terms_to_include = 
                                array_merge( 
                                    array( $category_parent ), 
                                    get_terms( 'product_cat', array( 'parent' => $category_parent, 'fields' => 'all', 'hide_empty' => 0 ) )
                                 );
                        }
                            
                    }



                    $html = '';

                     if( ! empty( $terms_to_include ) )
                        $include = $terms_to_include;

                    foreach ($include  as $term  ) {

                        if (is_object($term)){
                            $product_cat_name = $term->name;

                               if($current_post_id == $term->term){
                                        $active = 'qcld_active';
                                    }else{
                                        
                                        $active = '';
                                    }
                                
                            $html .= '<li class="cat-item cat-item-'.$term->term_id.'"><a href="'.esc_url(get_term_link( $term->term_id ,'product_cat')).'">'. esc_html($product_cat_name).'</a></li>';
                            $sorting = '';
                            $orderBy = get_option('qc_product_sort_type');
                            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                                $sorting = '_price';
                            }
                            if( get_option('qc_product_sort_type') == 'total_sales' ){
                                $sorting = 'total_sales';
                                $orderBy = 'meta_value_num';
                            }

                            $args = array(
                                'post_type'         => 'product',
                                'meta_key'          => $sorting,
                                'orderby'           => $orderBy,
                                'order'             => get_option('qc_product_sort_order'),
                                'tax_query'         => array(
                                    'relation'      => 'OR',
                                    array(
                                        'taxonomy'  => 'product_cat',
                                        'field'     => 'term_id',
                                        'terms'     => $term->term_id,
                                        'operator'  => 'IN'
                                    ),
                                )
                            );

                            $product_query = new WP_Query($args);
                            $wc_pf = new WC_Product_Factory();

                            if($product_query){
                                $html .= '<ul class="qcld_cat_pro_list">';
                            
                                while ($product_query->have_posts()) : $product_query->the_post();
                                $product = wc_get_product(get_the_ID());
                                    if($current_post_id == get_the_ID()){
                                        $active = 'qcld_active';
                                    }else{
                                        
                                        $active = '';
                                    }

                                    $html .= '<li><a href="' . $product->get_permalink() . '" class="'.$active.'">' . $product->get_title() . '</a></li>';
                                endwhile;
                                 $html .= '</ul>';
                            }



                        }
                    
                    }
                   
                    print $html;

                }else{

                    $wcc_categories = wp_list_categories(apply_filters('woocommerce_product_categories_widget_args', $list_args));

                    $wcc_categories = preg_replace('/<\/a> <span class="count">\(([0-9]+)\)<\/span>/', ' (\\1)</a>', $wcc_categories);
                    print $wcc_categories;

                    $this->woo_tabbed_wa_wcc_load_scripts();
                    $this->woo_tabbed_wa_wcc_mtree_script();

                }

                echo '</ul>';
                echo '</div>';



            } else {

                $list_args['walker'] = new WC_Product_Cat_List_Walker;
                $list_args['title_li'] = '';
                $list_args['pad_counts'] = 1;
                $list_args['show_option_none'] = __('No product categories exist.', 'woo-tabbed-category');
                $list_args['current_category'] = ($this->current_cat) ? $this->current_cat->term_id : '';
                $list_args['current_category_ancestors'] = $this->cat_ancestors;
               // $list_args['exclude'] = $excl;

                //var_dump($qc_exclude);
                //wp_die();
                if(!empty($qc_exclude)){
                    $exclude_category =  explode(',', $qc_exclude);
                    $list_args['exclude'] = $exclude_category;
                }else{

                    $list_args['exclude'] = $excl;
                }


                $list_args['heiararchical'] = true;
                $list_args['echo'] = false;
                echo '<div class="wcc_block statics">';
                echo '<ul class="mtree">';

                if(is_singular('product') && ($show_single_page_children_only == 1) && ($show_single_page_product_list == 1)){ 

                    $default_cat = $_SERVER['HTTP_REFERER'];

                    $default_cat = explode('/', $default_cat);

                    $default_cat_slug = $default_cat[count($default_cat)-2];


                    $default_cat_array = get_term_by( 'slug', $default_cat_slug, 'product_cat' );

                    $default_cat_term_id = '';
                    if(!empty($default_cat_array)){
                        $default_cat_term_id = $default_cat_array->term_id;
                       
                    }


                    if(!empty($default_cat_term_id)){

                        $product_category       =  get_term_by( 'id', absint( $default_cat_term_id ), 'product_cat' );
                        $current_cat            = $product_category;

                        if(!empty($current_cat->parent)){

                            $category_parent        = $current_cat->parent;
                            $woo_category_obj       = get_term_by( 'id', absint( $category_parent ), 'product_cat' ); 
                            $category_parent_name   = $woo_category_obj->name;

                        }


                    }else{
                        
                        $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent', 'fields' => 'all' ) );
                        $current_cat            = end( $product_category );
                        $category_parent        = $current_cat->parent;
                        $woo_category_obj       = get_term_by( 'id', absint( $category_parent ), 'product_cat' ); 
                        $category_parent_name   = $woo_category_obj->name;
                        
                    }

                    $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent') );
                    $current_cat            = end($product_category);

                    $current_post_id = $post->ID;
                    $current_cat_term_id = $current_cat->term_id;

                    //check if current cat has children
                    if( ! empty( $current_cat ) )
                        $current_cat_children = 
                            get_terms( 
                                'product_cat', 
                                array( 
                                    'parent' => $current_cat->term_id, 
                                    'fields' => 'all', 
                                    'hide_empty' => 0 
                                ) 
                            );
                    
                    if( ! empty( $current_cat_children ) ){
                        
                        $terms_to_include = 
                            array_merge( 
                                array( $current_cat->term_id ), 
                                $current_cat_children 
                            );
                        
                    }else{
                        
                        if( ! empty( $category_parent ) ){
                            $terms_to_include = 
                                array_merge( 
                                    array( $category_parent ), 
                                    get_terms( 'product_cat', array( 'parent' => $category_parent, 'fields' => 'all', 'hide_empty' => 0 ) )
                                 );
                        }
                            
                    }



                    $html = '';

                     if( ! empty( $terms_to_include ) )
                        $include = $terms_to_include;


                    foreach ($include  as $term  ) {

                        if (is_object($term)){
                            $product_cat_name = $term->name;

                            if($current_cat_term_id == $term->term_id){
                                    $active = 'qcld_active';
                                }else{
                                    $active = '';
                                    
                                }
                                
                            $html .= '<li class="cat-item cat-item-'.$term->term_id.'"><a href="'.esc_url(get_term_link( $term->term_id ,'product_cat')).'" class="'.$active.'">'. esc_html($product_cat_name).'</a></li>';


                            $sorting = '';
                            $orderBy = get_option('qc_product_sort_type');
                            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                                $sorting = '_price';
                            }
                            if( get_option('qc_product_sort_type') == 'total_sales' ){
                                $sorting = 'total_sales';
                                $orderBy = 'meta_value_num';
                            }

                            $args = array(
                                'post_type'         => 'product',
                                'meta_key'          => $sorting,
                                'orderby'           => $orderBy,
                                'order'             => get_option('qc_product_sort_order'),
                                'tax_query'         => array(
                                    'relation'      => 'OR',
                                    array(
                                        'taxonomy'  => 'product_cat',
                                        'field'     => 'term_id',
                                        'terms'     => $term->term_id,
                                        'operator'  => 'IN'
                                    ),
                                )
                            );

                            $product_query = new WP_Query($args);
                            $wc_pf = new WC_Product_Factory();

                            if($product_query){
                                $html .= '<ul class="qcld_cat_pro_list">';
                            
                                while ($product_query->have_posts()) : $product_query->the_post();
                                $product = wc_get_product(get_the_ID());
                                    if($current_post_id == get_the_ID()){
                                        $active = 'qcld_active';
                                    }else{
                                        
                                        $active = '';
                                    }
                                    $html .= '<li><a href="' . $product->get_permalink() . '" class="'.$active.'">' . $product->get_title() . '</a></li>';
                                endwhile;
                                 $html .= '</ul>';
                            }



                        }
                    
                    }
                   
                     print $html;

                }else if(is_tax('product_cat') && ($show_product_cat_page_product_list == 1)){ 

 
                        
                        $product_category       = wc_get_product_terms( $post->ID, 'product_cat', array( 'orderby' => 'parent', 'fields' => 'all' ) );
                        $current_cat            = end( $product_category );
                        $current_cat_term_id = $current_cat->term_id;
                        $category_parent        = $current_cat->parent;
                        $woo_category_obj       = get_term_by( 'id', absint( $category_parent ), 'product_cat' ); 
                        $category_parent_name   = $woo_category_obj->name;

                        

                        
                        $current_cat_term_id = $current_cat->term_id;
                        
                        $current_post_id = $post->ID;

                    //check if current cat has children
                    if( ! empty( $current_cat ) )
                        $current_cat_children = 
                            get_terms( 
                                'product_cat', 
                                array( 
                                    'parent' => $current_cat->term_id, 
                                    'fields' => 'all', 
                                    'hide_empty' => false 
                                ) 
                            );
                    
                    if( ! empty( $current_cat_children ) ){
                        
                        $terms_to_include = 
                            array_merge( 
                                array( $current_cat->term_id ), 
                                $current_cat_children 
                            );
                        
                    }else{
                        
                        if( ! empty( $category_parent ) ){
                            $terms_to_include = 
                                array_merge( 
                                    array( $category_parent ), 
                                    get_terms( 'product_cat', array( 'parent' => $category_parent, 'fields' => 'all', 'hide_empty' => 0 ) )
                                 );
                        }
                            
                    }



                    $html = '';

                     if( ! empty( $terms_to_include ) )
                        $include = $terms_to_include;

                    foreach ($include  as $term  ) {

                        if (is_object($term)){
                            $product_cat_name = $term->name;

                               if($current_cat_term_id == $term->term_id){
                                    $active = 'qcld_active';
                                }else{
                                    $active = '';
                                    
                                }
                                
                            $html .= '<li class="cat-item cat-item-'.$term->term_id.'"><a href="'.esc_url(get_term_link( $term->term_id ,'product_cat')).'" class="'.$active.'">'. esc_html($product_cat_name).'</a></li>';

                
                            $sorting = '';
                            $orderBy = get_option('qc_product_sort_type');
                            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                                $sorting = '_price';
                            }
                            if( get_option('qc_product_sort_type') == 'total_sales' ){
                                $sorting = 'total_sales';
                                $orderBy = 'meta_value_num';
                            }

                            $args = array(
                                'post_type'         => 'product',
                                'meta_key'          => $sorting,
                                'orderby'           => $orderBy,
                                'order'             => get_option('qc_product_sort_order'),
                                'tax_query'         => array(
                                    'relation'      => 'OR',
                                    array(
                                        'taxonomy'  => 'product_cat',
                                        'field'     => 'term_id',
                                        'terms'     => $term->term_id,
                                        'operator'  => 'IN'
                                    ),
                                )
                            );

                            $product_query = new WP_Query($args);
                            $wc_pf = new WC_Product_Factory();

                            if($product_query){
                                $html .= '<ul class="qcld_cat_pro_list">';
                            
                                while ($product_query->have_posts()) : $product_query->the_post();
                                    $product = wc_get_product(get_the_ID());

                                    if($current_post_id == get_the_ID()){
                                        $active = 'qcld_active';
                                    }else{
                                        
                                        $active = '';
                                    }
                                    $html .= '<li><a href="' . $product->get_permalink() . '" class="'.$active.'">' . $product->get_title() . '</a></li>';
                                endwhile;
                                 $html .= '</ul>';
                            }



                        }
                    
                    }
                   
                     print $html;

                }else{

                    $wcc_categories = wp_list_categories(apply_filters('woocommerce_product_categories_widget_args', $list_args));

                    $wcc_categories = preg_replace('/<\/a> <span class="count">\(([0-9]+)\)<\/span>/', ' (\\1)</a>', $wcc_categories);
                    print $wcc_categories;

                }

                


                echo '</ul>';

                echo '</div>';

            }

        }

        $this->widget_end($args);
    }

    public function woo_tabbed_wa_wcc_mtree_script()
    {

        wp_register_script('wa_wcc_mtree', plugins_url('/assets/js/mtree.js', __FILE__), array('jquery'), '');
        wp_enqueue_script('wa_wcc_mtree');


    }

    /* insert css files js files */
    public function woo_tabbed_wa_wcc_load_scripts()
    {


        if ($this->qc_selected_theme == 'qc_theme_one') {
            wp_register_style('wa_wcc_mtree_css_file', plugins_url('/assets/css/mtree.css', __FILE__));
            wp_enqueue_style('wa_wcc_mtree_css_file');

        } else if ($this->qc_selected_theme == 'qc_theme_bubba') {
            wp_register_style('qc_theme_bubba', plugins_url('/assets/css/bubba.css', __FILE__));
            wp_enqueue_style('qc_theme_bubba');

        } else if ($this->qc_selected_theme == 'qc_theme_skinny') {
            wp_register_style('qc_theme_skinny', plugins_url('/assets/css/skinny.css', __FILE__));
            wp_enqueue_style('qc_theme_skinny');

        } else if ($this->qc_selected_theme == 'qc_theme_transit') {
            wp_register_style('qc_theme_transit', plugins_url('/assets/css/transit.css', __FILE__));
            wp_enqueue_style('qc_theme_transit');

        } else if ($this->qc_selected_theme == 'qc_theme_jet') {
            wp_register_style('qc_theme_jet', plugins_url('/assets/css/jet.css', __FILE__));
            wp_enqueue_style('qc_theme_jet');

        } else if ($this->qc_selected_theme == 'qc_theme_nix') {
            wp_register_style('qc_theme_nix', plugins_url('/assets/css/nix.css', __FILE__));
            wp_enqueue_style('qc_theme_nix');

        }


        wp_register_style('qc_theme_fontawesome', plugins_url('/assets/css/font-awesome.css', __FILE__));
        wp_enqueue_style('qc_theme_fontawesome');


    }


}
