<?php

defined('ABSPATH') or die("No direct script access!");

/* admin settings page */
require_once('minify/minifier-settings.php');

/* all minify function page */
require_once('minify/src/Minify.php');
require_once('minify/src/CSS.php');
require_once('minify/src/JS.php');

require_once('minify/src/Exception.php');
require_once('minify/src/Exceptions/BasicException.php');
require_once('minify/src/Exceptions/FileImportException.php');

require_once('minify/path-converter/src/ConverterInterface.php');
require_once('minify/path-converter/src/Converter.php');

use Quantumcloud_wootabbed\Minify;


add_filter( 'script_loader_tag', 'qcld_woo_tabbed_script_load', 100, 3 );
if (!function_exists('qcld_woo_tabbed_script_load')) {
function qcld_woo_tabbed_script_load( $tag, $handle, $src ) {
    //$defer_load_js = true;

    $defer_load_js = get_option('qcld_woo_tabbed_defer_load_js');
    $qcld_woo_tabbed_optimize_js_code = get_option('qcld_woo_tabbed_optimize_js_code');
    $woo_tabbed_do_activation_optimize_js = get_option('woo_tabbed_do_activation_optimize_js');


    if ( (isset($defer_load_js) && ($defer_load_js == 1) ) || ( isset($qcld_woo_tabbed_optimize_js_code) && ($qcld_woo_tabbed_optimize_js_code == 1) ) ) {

        $handles = array(  
                        'wtcpl-scroll-to-js', 
                        'jquery-id-tabs', 
                        'magnific-popup-js', 
                        'lightslider-js', 
                        'slick-js', 
                        'masonry-js', 
                        'wtcpl-product-details-js', 
                        'wtcpl-product-cat-js',  
                        'sweetalert2-js',  
                        'modernizr',  
                        'catslider',  
                        'sticky-js',  
                        'floating-cart-js',  
                        'qcld-wootab-script',  
                        'qcld-wootab-ajax-script' 
                    );
     
        if ( ! wp_is_mobile() && in_array( $handle, $handles ) ) {


            if ( isset($qcld_woo_tabbed_optimize_js_code) && ($qcld_woo_tabbed_optimize_js_code == '1') ) {

                $name       = basename(parse_url($src, PHP_URL_PATH));
                $ext        = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_EXTENSION);
                $name2      = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_FILENAME);

                $min_file_path = $name2.".min.".$ext;

                if ( isset($woo_tabbed_do_activation_optimize_js) && ($woo_tabbed_do_activation_optimize_js == 'on') ){


          
                    $arrContextOptions=array(
                        "ssl"=>array(
                            "verify_peer"=>false,
                            "verify_peer_name"=>false,
                        ),
                    );  
                  
                    $sourcePath = file_get_contents($src, false, stream_context_create($arrContextOptions));
              
                    //$sourcePath = file_get_contents($src);
                    $minifier = new Minify\JS($sourcePath);

                    /*$fileLocation = dirname(__FILE__)  . "/js/".$min_file_path;
                    $file = fopen($fileLocation,"w");
                    $content = $minifier;
                    fwrite($file,$content);
                    fclose($file);*/
                   
                    // save minified file to disk
                    $minifiedPath = dirname(__FILE__) ."/js/".$min_file_path;
                    $minifier->minify($minifiedPath);

                    if ( 'qcld-wootab-ajax-script' == $handle  ){
                        update_option('woo_tabbed_do_activation_optimize_js', 'off');
                    }

                }

                $minifiedurl = $min_file_path;

                $tag = str_replace(
                    $name,
                    $minifiedurl,
                    $tag
                );

            }

            if ( $defer_load_js == 1 ){
                return str_replace(' src', ' defer src', $tag);
            }

        }
    }

    return $tag;

}
}


add_filter( 'style_loader_tag', 'qcld_woo_tabbed_style_min_load', 199, 3 );
if (!function_exists('qcld_woo_tabbed_style_min_load')) {
function qcld_woo_tabbed_style_min_load( $tag, $handle, $src ){
    //$defer_load_js = true;

    $qcld_woo_tabbed_optimize_css_code = get_option('qcld_woo_tabbed_optimize_css_code');
    $woo_tabbed_do_activation_optimize_css = get_option('woo_tabbed_do_activation_optimize_css');


    if ( isset($qcld_woo_tabbed_optimize_css_code) && ($qcld_woo_tabbed_optimize_css_code == 1) ) {

        $handles = array( 
                        'sweetalert2', 
                        'flickity',
                        'slick-css',
                        'qcld-font-awesomes',
                        'animate-css',
                        'lightslider-css',
                        'magnific-popup-css',
                        'quick-view-css',
                        'floating-cart-css',
                        'frontend-style-css',
                        'fancy-style',
                        'mobile-product-column-css',
                        'qcld-font-awesome',
                        'qcld-wootab-stylesheet'
                    );
     
        if ( ! wp_is_mobile() && in_array( $handle, $handles ) ) {

            $name       = basename(parse_url($src, PHP_URL_PATH));
            $ext        = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_EXTENSION); // to get extension
            $name2      = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_FILENAME);

            $min_file_path = $name2.".min.".$ext;

            if( isset($woo_tabbed_do_activation_optimize_css) && ($woo_tabbed_do_activation_optimize_css == 'on') ){


          
                $arrContextOptions=array(
                    "ssl"=>array(
                        "verify_peer"=>false,
                        "verify_peer_name"=>false,
                    ),
                );  
              
                $sourcePath = file_get_contents($src, false, stream_context_create($arrContextOptions));
          
                //$sourcePath = file_get_contents($src);
                $minifier = new Minify\CSS($sourcePath);

                /*$fileLocation = dirname(__FILE__)  . "/css/".$min_file_path;
                $file = fopen($fileLocation,"w");
                $content = $minifier;
                fwrite($file,$content);
                fclose($file);*/
               
                // save minified file to disk
                $minifiedPath = dirname(__FILE__) ."/css/".$min_file_path;
                $minifier->minify($minifiedPath);

                //delete_option('woo_tabbed_do_activation_optimize_css');
                //add_option('woo_tabbed_do_activation_optimize_css_js', false);

                if ( 'qcld-wootab-stylesheet' == $handle  ){
                    update_option('woo_tabbed_do_activation_optimize_css', 'off');
                }

            }

            $minifiedurl = $min_file_path;

            $tag = str_replace(
                $name,
                $minifiedurl,
                $tag
            );

        }
    }

    return $tag;

}
}


if (!function_exists('qcld_woo_tabbed_upgrade_completed')) {
    function qcld_woo_tabbed_upgrade_completed( $upgrader_object, $options ) {
        
        // The path to our plugin's main file
        $our_plugin = plugin_basename( __FILE__ );
        // If an update has taken place and the updated type is plugins and the plugins element exists
        if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
            // Iterate through the plugins being updated and check if ours is there
            foreach( $options['plugins'] as $plugin ) {
                if( $plugin == $our_plugin ) {
                    // Your action if it is your plugin
                    update_option('woo_tabbed_do_activation_optimize_css', 'on');
                    update_option('woo_tabbed_do_activation_optimize_js', 'on');
                }
            }
        }

    }
}
add_action( 'upgrader_process_complete', 'qcld_woo_tabbed_upgrade_completed', 10, 2 );

// regenerate min css and js
add_action('wp_ajax_qcld_woo_tabbed_regenerate_css_js', 'qcld_woo_tabbed_regenerate_css_js_code');
add_action('wp_ajax_nopriv_qcld_woo_tabbed_regenerate_css_js', 'qcld_woo_tabbed_regenerate_css_js_code');
if (!function_exists('qcld_woo_tabbed_regenerate_css_js_code')) {
    function qcld_woo_tabbed_regenerate_css_js_code(){

        check_ajax_referer( 'qcld_woo_tabbed_security_nonce', 'security');

        update_option('woo_tabbed_do_activation_optimize_css', 'on');
        update_option('woo_tabbed_do_activation_optimize_js', 'on');


        $response = esc_html('Minified JavaScript and CSS files Re-genarated');
        echo wp_send_json($response);
        wp_die();
    }
}

// delete wp cache
add_action('wp_ajax_qcld_woo_tabbed_regenerate_cache', 'qcld_woo_tabbed_regenerate_cache_code');
add_action('wp_ajax_nopriv_qcld_woo_tabbed_regenerate_cache', 'qcld_woo_tabbed_regenerate_cache_code');
if (!function_exists('qcld_woo_tabbed_regenerate_cache_code')) {
    function qcld_woo_tabbed_regenerate_cache_code(){

        check_ajax_referer( 'qcld_woo_tabbed_security_nonce', 'security');

        $cache_key = 'qcld_express_template_results_cache_one';
        delete_transient( $cache_key );

        $cache_key_two = 'qcld_express_template_results_cache_two';
        delete_transient( $cache_key_two );
        
        $cache_key_three = 'qcld_express_template_results_cache_three';
        delete_transient( $cache_key_three );
        
        $cache_key_four = 'qcld_express_template_results_cache_four';
        delete_transient( $cache_key_four );
        
        $cache_key_five = 'qcld_express_template_results_cache_five';
        delete_transient( $cache_key_five );
        
        $cache_key_six = 'qcld_express_template_results_cache_six';
        delete_transient( $cache_key_six );
        
        $cache_key_seven = 'qcld_express_template_results_cache_seven';
        delete_transient( $cache_key_seven );
        
        $cache_key_eight = 'qcld_express_template_results_cache_eight';
        delete_transient( $cache_key_eight );
        
        $cache_key_nine = 'qcld_express_template_results_cache_nine';
        delete_transient( $cache_key_nine );
        
        $cache_key_ten = 'qcld_express_template_results_cache_ten';
        delete_transient( $cache_key_ten );
        
        $cache_key_eleven = 'qcld_express_template_results_cache_eleven';
        delete_transient( $cache_key_eleven );
        
        $cache_key_twelve = 'qcld_express_template_results_cache_twelve';
        delete_transient( $cache_key_twelve );
        
        $cache_key_default = 'qcld_express_template_results_cache_default';
        delete_transient( $cache_key_default );
        

        $response = esc_html('Successfully cache cleared');
        echo wp_send_json($response);
        wp_die();
    }
}

//Loading admin panel's requried Style & scripts
function qcld_woo_tabbed_pro_minify_load_admin_scripts(){

    wp_enqueue_script( 'qcld_woo_tabbed_minify_admin_js', plugin_dir_url(__FILE__) . "/minify/qcld-express-minify-admin.js", array('jquery'), '', true);

    $qcld_ajax = array(
                'admin_url'                     => admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
                'qcld_woo_tabbed_security_nonce'   => wp_create_nonce('qcld_woo_tabbed_security_nonce'),
            );
    wp_localize_script( 'qcld_woo_tabbed_minify_admin_js', 'qcld_minify_ajax', $qcld_ajax );
}
add_action( 'admin_enqueue_scripts', 'qcld_woo_tabbed_pro_minify_load_admin_scripts');