<?php 

defined('ABSPATH') or die("No direct script access!");

/*
* Post Type settings area
*/
class qcld_woo_tabbed_Performance_Area_Controller {
    
    function __construct(){

        add_filter( 'qcld_woo_tabbed_performance_settings', array($this,'qcld_woo_tabbed_performance_settings_page') );
        //add_action( 'admin_init', array($this, 'qcld_woo_tabbed_performance_register_plugin_settings') );

        //apply_filters('qcld_woo_tabbed_performance_settings',10  );

    }

    public function qcld_woo_tabbed_performance_admin_menu(){

        add_submenu_page( 'express-shop', 
                        __('Performance','woo-tabbed-category'), 
                        __('Performance','woo-tabbed-category'), 
                        'manage_options',
                        'qcld-express-performance', 
                        array($this, 'qcld_woo_tabbed_performance_settings_page') );
        
    }
    
    public function qcld_woo_tabbed_performance_register_plugin_settings(){    


        $args = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field',
            'default' => NULL,
        );  

        $args_email = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_email',
            'default' => NULL,
        );      
        
        register_setting( 'woo-tabbed-performance-settings-group', 'qcld_woo_tabbed_defer_load_js', $args );

        register_setting( 'woo-tabbed-performance-settings-group', 'qcld_woo_tabbed_optimize_js_code', $args );
        register_setting( 'woo-tabbed-performance-settings-group', 'qcld_woo_tabbed_optimize_css_code', $args );

        register_setting( 'woo-tabbed-performance-settings-group', 'qcld_woo_tabbed_enable_cache', $args );
        register_setting( 'woo-tabbed-performance-settings-group', 'qcld_woo_tabbed_regenerate_cache_time', $args );

        
    }
    
    
    public function qcld_woo_tabbed_performance_settings_page(){
        
    ?>
    <style type="text/css">
        .form-table-performance{
            margin-top: 15px;
            background: #fff;
            border-radius: 2px;
            box-shadow: 0 0 0 1px rgb(0 0 0 / 7%), 0 1px 1px rgb(0 0 0 / 4%);
        }
        .form-table-performance tr{
            border-bottom: 1px solid #eee;
            display: block;
        }
        .form-table-performance th{
            padding: 20px 10px 20px 20px;
        }
        .form-table-performance td{
            padding: 20px 10px 20px 20px;
        }
    </style>
    <div class="wrapsdfs">
        <h3><?php esc_html_e('Performance Settings','woo-tabbed-category') ?></h3>
        <p><?php esc_html_e('Change for Performance','woo-tabbed-category') ?></p>
            <div >
                <table class="form-table form-table-performance" >
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Defer/delay loading Javascript files','woo-tabbed-category') ?></th>
                        <td>
                            <input type="checkbox" name="qcld_woo_tabbed_defer_load_js" size="100" value="<?php echo (get_option('qcld_woo_tabbed_defer_load_js')!=''? esc_attr( get_option('qcld_woo_tabbed_defer_load_js')) : '1' ); ?>" <?php echo (get_option('qcld_woo_tabbed_defer_load_js') == '' ? esc_attr( get_option('qcld_woo_tabbed_defer_load_js')): esc_attr( 'checked="checked"' )); ?>  />  
                            <i><?php esc_html_e(' This can help improve PageSpeed Score. No need to enable this if your server supports HTTP2.','woo-tabbed-category') ?></i>                           
                        </td>
                    </tr>
                    
                    <tr valign="top" style="border-bottom: 1px solid #eee;display: block;">
                        <th scope="row"><?php esc_html_e('Minify JavaScript Files','woo-tabbed-category') ?></th>
                        <td>
                            <input type="checkbox" name="qcld_woo_tabbed_optimize_js_code" size="100" value="<?php echo (get_option('qcld_woo_tabbed_optimize_js_code')!=''? esc_attr( get_option('qcld_woo_tabbed_optimize_js_code')) : '1' ); ?>" <?php echo (get_option('qcld_woo_tabbed_optimize_js_code') == '' ? esc_attr( get_option('qcld_woo_tabbed_optimize_js_code')): esc_attr( 'checked="checked"' )); ?>  />   
                            <i><?php esc_html_e('Minify JavaScript files to increase PageSpeed Score.','woo-tabbed-category') ?></i>                            
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Minify CSS Files','woo-tabbed-category') ?></th>
                        <td>
                            <input type="checkbox" name="qcld_woo_tabbed_optimize_css_code" size="100" value="<?php echo (get_option('qcld_woo_tabbed_optimize_css_code')!=''? esc_attr( get_option('qcld_woo_tabbed_optimize_css_code')) : '1' ); ?>" <?php echo (get_option('qcld_woo_tabbed_optimize_css_code') == '' ? esc_attr( get_option('qcld_woo_tabbed_optimize_css_code')): esc_attr( 'checked="checked"' )); ?>  />   
                            <i><?php esc_html_e('Minify CSS files to increase PageSpeed Score.','woo-tabbed-category') ?></i>                            
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Regenerate minified files','woo-tabbed-category') ?></th>
                        <td>
                            <button type="button" class="qcld_woo_tabbed_regenerate_css_js button button-primary" size="100" value="1"> <?php esc_html_e('Regenerate','woo-tabbed-category') ?></button>  
                            <i style="line-height: 30px;"><?php esc_html_e('Do this to manually regenerate the files. Maybe required for debugging or after a plugin update.','woo-tabbed-category') ?></i>                          
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Enable cache','woo-tabbed-category') ?></th>
                        <td>
                            <input type="checkbox" name="qcld_woo_tabbed_enable_cache" size="100" value="<?php echo (get_option('qcld_woo_tabbed_enable_cache')!=''? esc_attr( get_option('qcld_woo_tabbed_enable_cache')) : '1' ); ?>" <?php echo (get_option('qcld_woo_tabbed_enable_cache') == '' ? esc_attr( get_option('qcld_woo_tabbed_enable_cache')): esc_attr( 'checked="checked"' )); ?>  />  
                            <i><?php esc_html_e(' This can help improve PageSpeed Score.','woo-tabbed-category') ?></i>                           
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Cache Time','woo-tabbed-category') ?></th>
                        <td>
                            <input type="number" name="qcld_woo_tabbed_regenerate_cache_time" style="width:100px" size="100" value="<?php echo (get_option('qcld_woo_tabbed_regenerate_cache_time')!=''?esc_attr( get_option('qcld_woo_tabbed_regenerate_cache_time')):''); ?>"  /> <b><i><?php esc_html_e('seconds','woo-tabbed-category') ?></i></b>
                            
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th scope="row"><?php esc_html_e('Clear Cache','woo-tabbed-category') ?></th>
                        <td>
                            <button type="button" class="qcld_woo_tabbed_regenerate_cache button button-danger" size="100" value="1"> <?php esc_html_e('Clear Cache','woo-tabbed-category') ?></button>  
                            <i style="line-height: 30px;"><?php esc_html_e('Do this to manually clear cache. Maybe required for debugging or after a plugin update.','woo-tabbed-category') ?></i>                          
                        </td>
                    </tr>
                    
                    
                </table>
            </div>
        
    </div>

    <?php
    }
    
    
}
new qcld_woo_tabbed_Performance_Area_Controller();