<?php
/*
* QuantumCloud Promo + Support Page
* Revised On: 06-01-2017
*/

/*******************************
 * Add Ajax Object at the head part
 *******************************/
add_action('wp_head', 'qc_process_support_form_ajax_header');

if( !function_exists('qc_process_support_form_ajax_header') )
{
	function qc_process_support_form_ajax_header() 
	{

	   echo '<script type="text/javascript">
	           var ajaxurl = "' . admin_url('admin-ajax.php') . '";
	         </script>';

	} //End of qc_process_support_form_ajax_header

} //End of function_exists

/*******************************
 * Handle Ajex Request for Form Processing
 *******************************/
add_action( 'wp_ajax_process_qc_promo_form', 'process_qc_promo_form' );

if( !function_exists('process_qc_promo_form') )
{
	function process_qc_promo_form()
	{
		
		$data['status'] = 'failed';
		$data['message'] = __('Problem in processing your form submission request! Apologies for the inconveniences.<br> 
Please email to <span style="color:#22A0C9;font-weight:bold !important;font-size:14px "> quantumcloud@gmail.com </span> with any feedback. We will get back to you right away!', 'woo-tabbed-category');

		$name = trim(sanitize_text_field($_POST['post_name']));
		$email = trim(sanitize_email($_POST['post_email']));
		$subject = trim(sanitize_text_field($_POST['post_subject']));
		$message = trim(sanitize_text_field($_POST['post_message']));
		$plugin_name = trim(sanitize_text_field($_POST['post_plugin_name']));

		if( $name == "" || $email == "" || $subject == "" || $message == "" )
		{
			$data['message'] = 'Please fill up all the requried form fields.';
		}
		else if ( filter_var($email, FILTER_VALIDATE_EMAIL) === false ) 
		{
			$data['message'] = 'Invalid email address.';
		}
		else
		{

			//build email body

			$bodyContent = "";
				
			$bodyContent .= "<p><strong>Support Request Details:</strong></p><hr>";

			$bodyContent .= "<p>Name : ".$name."</p>";
			$bodyContent .= "<p>Email : ".$email."</p>";
			$bodyContent .= "<p>Subject : ".$subject."</p>";
			$bodyContent .= "<p>Message : ".$message."</p>";

			$bodyContent .= "<p>Sent Via the Plugin: ".$plugin_name."</p>";

			$bodyContent .="<p></p><p>Mail sent from: <strong>".get_bloginfo('name')."</strong>, URL: [".get_bloginfo('url')."].</p>";
			$bodyContent .="<p>Mail Generated on: " . date("F j, Y, g:i a") . "</p>";			
			
			$toEmail = "quantumcloud@gmail.com"; //Receivers email address
			//$toEmail = "qc.kadir@gmail.com"; //Receivers email address

			//Extract Domain
			$url = get_site_url();
			$url = parse_url($url);
			$domain = $url['host'];
			

			$fakeFromEmailAddress = "wordpress@" . $domain;
			
			$to = $toEmail;
			$body = $bodyContent;
			$headers = array();
			$headers[] = 'Content-Type: text/html; charset=UTF-8';
			$headers[] = 'From: '.$name.' <'.$fakeFromEmailAddress.'>';
			$headers[] = 'Reply-To: '.$name.' <'.$email.'>';

			$finalSubject = "From Plugin Support Page: " . $subject;
			
			$result = wp_mail( $to, $finalSubject, $body, $headers );

			if( $result )
			{
				$data['status'] = 'success';
				$data['message'] = __('Your email was sent successfully. Thanks!', 'woo-tabbed-category');
			}

		}

		ob_clean();

		
		echo json_encode($data);
	
		die();
	}
}





/*******************************
 * Main Class to Display Support
 * form and the promo pages
 *******************************/


	if ( ! function_exists( 'qcld_seo_include_promo_page_scripts' ) ) {	
		function qcld_seo_include_promo_page_scripts( )
		{                                 
		   
		   wp_enqueue_script( 'jquery' );
		   wp_enqueue_script( 'jquery-ui-core');
		   wp_enqueue_script( 'jquery-ui-tabs' );
		   wp_enqueue_script( 'jquery-custom-form-processor', plugin_dir_url( __FILE__ ) . '/js/support-form-script.js',  array('jquery', 'jquery-ui-core','jquery-ui-tabs') );
		   
		}
		add_action('admin_enqueue_scripts', 'qcld_seo_include_promo_page_scripts');
		
	}
		
	/*******************************
	 * Callback function to show the HTML
	 *******************************/
	if ( ! function_exists( 'qcld_woo_tabbed_promo_support_page_callback_func' ) ) {

		function qcld_woo_tabbed_promo_support_page_callback_func()
		{
			
			?>
				
			<div class="qc_support_container"><!--qc_support_container-->
	
    <div class="qc_tabcontent clearfix-div">
    	<div class="qc-row">
            <div class="support-btn-main clearfix-div">
                
                <div class="qc-column-12">
					<h4><?php esc_html_e( 'All our Pro Version users get Premium, Guaranteed Quick, One on One Priority Support.', 'woo-tabbed-category' ); ?></h4>
                    <div class="support-btn">
                        <a class="premium-support" href="<?php echo esc_url( 'https://www.quantumcloud.com/priority-support/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'GET PRIORITY SUPPORT', 'woo-tabbed-category' ); ?></a>
						<a style="width:282px" class="premium-support" href="<?php echo esc_url( 'https://www.quantumcloud.com/resources/kb-sections/woo-tabbed-category-products/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Online KnowledgeBase', 'woo-tabbed-category' ); ?></a>
                    </div>
					
                </div>

            </div>
			<h2 class="plugin-title" style="text-align: center;margin-bottom: 60px;"><?php esc_html_e( 'Check Out Some of Our Other Works that Might Make Your Website Better', 'woo-tabbed-category' ); ?></h2>
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/infographic-maker-ilist/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/iList-icon-256x256.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/infographic-maker-ilist/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'InfoGraphic Maker – iList', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'iList is first of its kind ', 'woo-tabbed-category' ); ?><strong><?php esc_html_e( 'InfoGraphic maker', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( 'WordPress plugin to create Infographics and elegant Lists effortlessly to visualize data. It is a must have content creation and content curation tool.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/slider-hero', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/slider-hero-icon-256x256.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/slider-hero', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Slider Hero', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'Slider Hero is a unique slider plugin that allows you to create', 'woo-tabbed-category' ); ?> <strong> <?php esc_html_e( 'Cinematic Product Intro Adverts', 'woo-tabbed-category' ); ?> </strong> <?php esc_html_e( 'and', 'woo-tabbed-category' ); ?>  <strong> <?php esc_html_e( 'Hero sliders', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( 'with great Javascript animation effects.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/chatbot-for-wordpress/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/chatbot.jpg" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/chatbot-for-wordpress/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'ChatBot', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'ChatBot is a stand alone Chat Bot plugin for WordPress with artificial intelligent powered by Dialogflow . You can also use this Chat Bot without DialogFlow integration and simply install and get it to work as a floating HelpDesk or Floating Contact form.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/simple-link-directory/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/sld-icon-256x256.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/simple-link-directory/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Simple Link Directory', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'Directory plugin with a unique approach! Simple Link Directory is an advanced WordPress Directory plugin for One Page 
                        directory and Content Curation solution.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/simple-business-directory/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/icon.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/simple-business-directory/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Simple Business Directory', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'This innovative and powerful, yet', 'woo-tabbed-category' ); ?><strong> <?php esc_html_e( 'Simple & Multi-purpose Business Directory', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( 'WordPress PlugIn allows you to create comprehensive Lists of Businesses with maps and tap to call features.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woocommerce-chatbot-woowbot/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/logo (1).png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woocommerce-chatbot-woowbot/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'WoowBot WooCommerce ChatBot', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'WooWBot is a stand alone WooCommerce Chat Bot with zero configuration or bot training required. This plug and play chatbot also does not require 
                        any 3rd party service integration like Facebook.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woocommerce-shop-assistant-jarvis/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/jarvis-icon-256x256.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woocommerce-shop-assistant-jarvis/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'WooCommerce Shop Assistant', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'WooCommerce Shop Assistant – ', 'woo-tabbed-category' ); ?><strong> <?php esc_html_e( 'JARVIS', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( 'shows recent user activities, provides advanced search, floating cart, featured products, store notifications, order notifications – all in one place for easy access by buyer and make quick decisions.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/portfolio-x-plugin/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/portfolio-x-logo-dark-2.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/portfolio-x-plugin/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Portfolio X', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'Portfolio X is an advanced, responsive portfolio with streamlined workflow and unique designs and templates to show your works or projects.', 'woo-tabbed-category' ); ?><strong>
                        <?php esc_html_e( 'Portfolio Showcase', 'woo-tabbed-category' ); ?></strong>  <?php esc_html_e( 'and', 'woo-tabbed-category' ); ?><strong> <?php esc_html_e( 'Portfolio Widgets', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( 'are included.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woo-tabbed-category-product-listing/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/woo-tabbed-icon-256x256.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/woo-tabbed-category-product-listing/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Woo Tabbed Category Products', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'WooCommerce plugin that allows you to showcase your products category wise in tabbed format. This is a unique woocommerce plugin that lets dynaimically 
                        load your products in tabs based on your product categories .', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/knowledgebase-helpdesk/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/knowledgebase-helpdesk.jpg" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/knowledgebase-helpdesk/', 'woo-tabbed-category' ); ?>" target="_blank" rel="noopener noreferrer"><?php esc_html_e( 'KnowledgeBase HelpDesk', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'KnowledgeBase HelpDesk is an advanced Knowledgebase plugin with helpdesk', 'woo-tabbed-category' ); ?><strong>, </strong><?php esc_html_e( 'glossary and FAQ features all in one. KnowledgeBase HelpDesk is extremely simple and easy to use.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
            
            
            <div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/express-shop/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/express-shop.png" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/express-shop/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Express Shop', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'Express Shop is a WooCommerce addon to show all products in one page. User can add products to cart and go to checkout. Filtering and search integrated in single page.', 'woo-tabbed-category' ); ?></p>
                        <br><br>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
			
			
			<div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/seo-help', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/seo-help.jpg" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/seo-help', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'SEO Help', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'SEO Help is a unique WordPress plugin to help you write better Link Bait titles. The included LinkBait title generator will take the 
                        WordPress post title as Subject and generate alternative ClickBait titles for you to choose from.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
			
			
			<div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/ichart/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/ichart-300x300 (1).jpg" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/ichart/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'iChart – Easy Charts and Graphs', 'woo-tabbed-category' ); ?></a></h4>
                        <p> <?php esc_html_e( 'Charts and graphs are now easy to build and add to any WordPress page with just a few clicks and shortcode generator.
                        iChart is a Google chartjs implementation to add graphs &', 'woo-tabbed-category' ); ?> 
						<strong><?php esc_html_e( 'charts', 'woo-tabbed-category' ); ?></strong> <?php esc_html_e( '– directly from WordPress Visual editor.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->
			
			
			<div class="qc-column-4"><!-- qc-column-4 -->
                <!-- Feature Box 1 -->
                <div class="support-block ">
                    <div class="support-block-img">
                        <a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/comment-link-remove/', 'woo-tabbed-category' ); ?>" target="_blank"> <img src="<?php echo plugin_dir_url(__FILE__); ?>images/Comment-Link-Remove-300x300 (1).jpg" alt=""></a>
                    </div>
                    <div class="support-block-info">
                        <h4><a href="<?php echo esc_url( 'https://www.quantumcloud.com/products/comment-link-remove/', 'woo-tabbed-category' ); ?>" target="_blank"><?php esc_html_e( 'Comment Link Remove', 'woo-tabbed-category' ); ?></a></h4>
                        <p><?php esc_html_e( 'All in one solution to fight comment spammers. Tired of deleting useless spammy comments from your WordPress blog posts? Comment Link Remove WordPress 
                        plugin removes author link and any other links from the user comments.', 'woo-tabbed-category' ); ?></p>

                    </div>
                </div>
            </div><!--/qc-column-4 -->

        </div>
        <!--qc row-->
    </div>
    
    
    
    

</div><!--qc_support_container-->
				
			<?php
		} //End of qcpromo_support_page_callback_function
	}
		
