<?php 

defined('ABSPATH') or die("No direct script access!");

/* Ajax search */
add_action('wp_ajax_qcld_woo_tabbed_products_ajax_search', 'qcld_woo_tabbed_products_ajax_search');
add_action('wp_ajax_nopriv_qcld_woo_tabbed_products_ajax_search', 'qcld_woo_tabbed_products_ajax_search');


function qcld_woo_tabbed_products_ajax_search()
{


    $show_per_page              = isset($_POST['offset'])               ? sanitize_text_field( $_POST['offset'] ) :'';
    $theme_id                   = isset($_POST['theme_id'])             ? sanitize_text_field( $_POST['theme_id'] ) :'';
    $offset                     = isset($_POST['offset'])               ? sanitize_text_field( $_POST['offset'] ) :'';
    $show_sale                  = isset($_POST['show_sale'])            ? sanitize_text_field( $_POST['show_sale'] ) :'';
    $feature_only               = isset($_POST['feature_only'])         ? sanitize_text_field( $_POST['feature_only'] ) :'';
    $sorting_val                = isset($_POST['sorting_val'])          ? sanitize_text_field( $_POST['sorting_val'] ) :'';
    $qc_shortcode_parameters    = isset($_POST['data_cat_parameter'])   ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $category_ids               = isset($_POST['data_cat_parameter'])   ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $link_title_to_modal        = isset($_POST['link_title_to_modal'])  ? sanitize_text_field( $_POST['link_title_to_modal'] ) :'';

    $query                      = isset($_REQUEST['s'])                 ? sanitize_text_field($_REQUEST['s']) :'';

    $tax_query = array(
        array(
            'taxonomy' => 'product_visibility',
            'field' => 'name',
            'terms' => 'featured',
            'operator' => 'IN'
        ),);

        $show_sale_products_only = array('relation' => 'OR', array(
            // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
        array(
            // Variable products type
            'key' => '_min_variation_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ));


    
    $product_categories = unserialize(get_option('selected_categories'));

    $category_orders = get_option('category_order');
    if($category_orders == 'menu_order'){
        $args = array(
        'hide_empty'    => 1,
        'order'         => 'asc',
        'exclude'       => $product_categories,
        'include'       => $category_ids,
        );

    }else{

         $args = array(
        'hide_empty'    => 1,
        'order'         => get_option('category_order'),
        'orderby'       => 'title',
        'exclude'       => $product_categories,
        'include'       => $category_ids,
        );

    }
    $product_categoriess = get_terms('product_cat', $args);

    $categories_all = '';

    if (!empty($qc_shortcode_parameters) ) {
        $category_ids = $qc_shortcode_parameters;
        $categories_all = explode(',', $category_ids);

    }else {
        $categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }
    }

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    $args = array(
        'post_type'             => 'product',
        'post_status'           => 'publish',
        'posts_per_page'        => $show_per_page,
        's'                     => $query, 
        'meta_key'              => $sorting,
        'orderby'               => $orderBy,
        'order'                 => get_option('qc_product_sort_order'),
        'tax_query'             => array(
                                'relation' => 'OR',
                                array(
                                    'taxonomy' => 'product_cat',
                                    'field' => 'term_id',
                                    'terms' => $categories_all,
                                    'operator' => 'IN'
                        ),
                    )
                );
        



    if ($show_sale == 1) {
        $args = array_merge($args, array('meta_query' => $show_sale_products_only));
    }


    if ($feature_only == 1) {

                $show_featured_only = array('relation' => 'OR', array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                    array(
                        'taxonomy' => 'product_visibility',
                        'field' => 'name',
                        'terms' => 'featured',
                        'operator' => 'IN'
                    )
                ));
        $args = array_merge($args, array('tax_query' => $show_featured_only));
    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();
    $products_num = $product_query->post_count;
    if($products_num == $show_per_page) {
        $nextOffset = intval($offset + $show_per_page);
    }else{
        $nextOffset = -1;
    }
    $html = '';

    if($products_num > 0){

    if ($theme_id == 'theme-one') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="product-box"><div class="product-img">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">';
            }else{
                $html .= '<a href="'. $product->get_permalink() .'">';
            }
            $html .= $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</a><div class="one-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div>';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">' . $product->get_title() . '</a></h2>';
            }else{
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
            endif;

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_one">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+">';

                        }else{
                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+">';
                        }
                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }



                } else {
                    $html .= '<a class="product_out_of_stock" href="#"><i class="fa" aria-hidden="true"></i></a>';
                }


            endif;


            $html .= '</div >';

            $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;
    } else if ($theme_id == 'theme-two') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="product-box"><div class="product-img">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">';
            }else{
                $html .= '<a href="'. $product->get_permalink() .'">';
            }
            $html .= $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()) .'</a></div>';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">' . $product->get_title() . '</a></h2>';
            }else{
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }

            endif;

                    
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_two">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+">';

                        }else{
                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+">';
                        }
                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }



                } else {
                    $html .= '<a class="product_out_of_stock" href="#"><i class="fa" aria-hidden="true"></i></a>';
                }
            endif;
            $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';

        endwhile;

    } else if ($theme_id == 'theme-three') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery(get_the_ID()).'">';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;


            $html .= '<div class="wootabs_img">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</div>';

            if ($product_stock_status != 'outofstock') {


                $html .= '<div class="qc_pro_details">';

                $html .= '<ul>';
                if (get_option('add_cart_link') == 1):

                    
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                        $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                    }else{ 
                       $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                    }

                endif;

                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{

                            $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+"></div></li>';
                        }


                    endif;
                endif;

                if (get_option('add_cart_link') == 1):
                    
                    if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{
                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;


                $html .= '</ul>
             </div>';
            } else {
                $html .= '<div class="qc_pro_details">';

                $html .= '<ul>';

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                }else{ 
                   $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                }


               


                if (get_option('add_cart_link') == 1):

                    $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';

                endif;


                $html .= '</ul>
             </div>';
            }
            if (get_option('product_title')):
                 if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){

                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a> </h2>';
                    }else{ 

                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a> </h2>';
                    }
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }

                $html .= '</div>';
            endif;
            $html .= '<div class="woo_price" style="font-size:' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';


            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();
            endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            $html .= '</div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</li>';
        endwhile;

    } else if ($theme_id == 'theme-eleven') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();

            $html .= '<li class="'.qcld_product_product_has_gallery(get_the_ID()).'"><div class="product-box">';

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<a href="#" class="woo_tab_product_details too_tab_single_link" product-id="'.$product->get_id().'">';
                }else{ 
                    $html .= '<a href="' . $product->get_permalink() . '">';
                }

            $html .= '<div class="product-img">';
            if ( has_post_thumbnail() ):
            $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()) .'';
            elseif(empty(has_post_thumbnail()) && empty(get_the_excerpt(get_the_ID()))):
            $html .= ''. $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()) .'';
            else:
            $html .= ''. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>') .'';
            endif;
            $html .= '<div class="eleven-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div></a>';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

                                            

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_one">';
            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+">';

                        }else{

                                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity"
                                   name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+">';
                        }


                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }

                } else {

                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }
            endif;


            $html .= '</div>';

            $html .= '<div class="clear"></div></div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;

    } else if ($theme_id == 'theme-nine') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();


            $html .= '<li class="ilist-25">
                                    <div class="qc-wootabs-col-4">
                                        <div class="ilist-item-main">';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img
            src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="feature-img-box valign-center '.qcld_product_product_has_gallery(get_the_ID()).'">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</a>';
            }else{
                $html .= '<a href="' . $product->get_permalink() . '">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</a>';
            }
            $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            $html .= '<div class="item-desc-text">';
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):

                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png"alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png"alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png"alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png"alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png"alt="">';
                }

            endif;
            if (get_option('product_title') == 1):
               
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){

                    $html .= '<h3 class="item-list-title"><a
                        style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                        style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                        href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a>
                </h3>';
                }else{ 
                    $html .= '<h3 class="item-list-title"><a
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                href="' . $product->get_permalink() . '">' . $product->get_title() . '</a>
                    </h3>';
                }

            endif;

            $html .= '<div class="tpl_nine_short_desc" style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ' !important;">' . strip_tags($product->get_short_description()) . '</div></div><div class="item-title-text">';

            if (get_option('display_price') == 1):
                $html .= '<div class="price_tabs"
             style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';">' . $product->get_price_html() . '</div>';
            endif;

            $html .= '<div class="qc_quantity qc_qat_style_nine">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                    if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                                <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                                <input class="qc_plus" type="button" value="+">';

                        }else{
                        $html .= '<input class="qc_minus" type="button" value="-">
                                <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                                <input class="qc_plus" type="button" value="+">';
                            }

                    endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                if ($product->get_type() != 'variable'){
                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                }else{

                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }

                } else {
                    $html .= '<a class="woo_tab_s_p_add_to_carts" data-p-price="'.$product->get_price().'" data-p-id="'.$product->get_id().'" href="'.$product->get_permalink().'"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }
            endif;


            $html .= '</div></div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></div></li>';

        endwhile;

    } else if ($theme_id == 'theme-four') {
        $add_to_cart_text = get_option('change_add_to_cart_button_text');
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li style="background-color:' . get_option('container_background_color') . '">
                                    <div class="qc-product-list">';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="qc-product-details-left '.qcld_product_product_has_gallery(get_the_ID()).'"><a href="'. $product->get_permalink() .'">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</a></div>
                                        <div class="qc-product-details-right">';

            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{ 
                $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;

               $html .= '<h3 style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';
            if (get_option('display_price') == 1):
                $html .=  $product->get_price_html();
            endif;


            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

                $html .= '</h3>';
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {
                    if (!empty($add_to_cart_text)) {
                        $anchorText = esc_html( $add_to_cart_text, 'woo-tabbed-category' );
                    } else {
                        $anchorText = esc_html( "Add To Cart", "woo-tabbed-category" );
                    }


                    if (get_option('add_quantity_select') == 1):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= ' <div class="qc_quantity">';
                            $html .= '<input class="qc_minus" type="button" value="-">           
                             <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                             <input class="qc_plus" type="button" value="+">';

                        }else{

                            $html .= ' <div class="qc_quantity">';
                            $html .= '<input class="qc_minus" type="button" value="-">           
                             <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                             <input class="qc_plus" type="button" value="+">';
                         }
                    endif;

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                 $html .='</div>';


                $html .= '</div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
                    $html .= '</div>';


                } else {

                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->get_permalink() . '"
                                               class="qc-cart-btn">Out Of Stock</a>';
                }
            endif;

            $html .= '</li>';
        endwhile;
        wp_reset_query();

    } else if ($theme_id == 'theme-five') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="">';
            $html .= '<div class="qc_tabs_10_style_box">';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img
                        src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

            if (get_option('display_price') == 1):
                $html .= '<div class="qc_price">' . $product->get_price_html() . '</div>';
            endif;

            $html .= '<div class="qc_ratting">';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }

            endif;
            $html .= '</div>
            <div class="divider"></div>
            <div class="pro_img '.qcld_product_product_has_gallery(get_the_ID()).'">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</div>';
                        $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

        $html .= '</div>';


            if ($product_stock_status != 'outofstock') {
                $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">';
                if (get_option('product_title') == 1):
                    $html .= '<h2>
                            <a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;"
                               href="' . $product->get_permalink() . '">' . $product->get_title() . '</a>
                        </h2>';
                endif;
                
                $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';"
                             class="qc_price">';
                if (get_option('display_price') == 1):
                    $html .= $product->get_price_html();
                endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 
                
                $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }


                $html .= '<div class="qc_ratting">';
                $average = $product->get_average_rating();

                if (get_option('display_rating') == 1):
                    if ($average == 1) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                    } else if ($average == 0) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                    } else if ($average <= 2) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                    } else if ($average <= 3) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                    } else if ($average <= 4) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                    } else if ($average <= 5) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                    }

                endif;
                $html .= '</div><div class="qc_tabs_10_style_box_icon">';
                $html.='<ul>';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i
                                            class="fa fa-link" aria-hidden="true"></i></a>
                                </li>';

                endif;


                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                            $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity"
                                           value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                                    <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{

                            $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                            $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity"
                                           value="1">
                                    <input class="qc_plus" type="button" value="+"></div></li>';
                            }

                    endif;
                endif;
                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-plus" aria-hidden="true"></i>   </a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{

                        $html .= '<li><a class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;


                $html .= '</ul></div></div></div>';

            } else {
                $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">

                    <div class="qc_tabs_10_style_box_icon">
                        <ul>';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="'.$product->get_permalink().'"><i class="fa fa-link" aria-hidden="true"></i></a>
                                </li>';

                endif;

                $html .= '<li><div class="qc_quantity qc_qat_style_five qc_out_of_stock_container">';


                $html .= ' <a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>

                            </div></li>
                        </ul>
                    </div>
                </div>
            </div>';
            }


            $html .= '</li>';
        endwhile;
    } else if ($theme_id == 'theme-six') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<div class="pro_list_04">
                    <div class="slider">
                <div class="pro_item_list '.qcld_product_product_has_gallery(get_the_ID()).'">';
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .='<a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">';   
                }else{
                    $html .='<a href="'. $product->get_permalink() .'">';  
                }
                $html.= $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()). '</a></div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
       
            $average = $product->get_average_rating();


            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;
            $html .= '</div>';


            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="meta">';


            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h3>';
                }else{ 
                    $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h3>';
                }
            endif;

            $html .= '<span style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_price_04">';
            if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
            endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            $html .= '</span>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div>';
            if ($product_stock_status != 'outofstock') {
                $html .= '<ul class="pro_icon action action_button action_buy">';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';

                endif;

                $html .= '<div class="qc_quantity qc_qat_style_six">';
          

                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'"><input class="qc_plus" type="button" value="+">';

                        }else{
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                    value="1"><input class="qc_plus" type="button" value="+">';
                                }
                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }


                endif;

                $html .= '</ul>';
            } else {
                $html .= '<ul class="pro_icon action action_button action_buy">';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                   
                endif;

                $html .= '<div class="qc_quantity qc_qat_style_six">';
           

                if (get_option('add_cart_link') == 1):

                    $html .= '<a class="woo_tab_s_p_add_to_carts" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="'.$product->get_permalink().'"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';

                endif;

                $html .= '</ul>';
            }

            $html .= '</div>';
            $html .= '</div>';
        endwhile;
    } else if ($theme_id == 'theme-seven') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery(get_the_ID()).'"><div class="pro_list_12_box">
                    <div class="pro_list_12_img">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()). '</div>';
            if ($product->is_on_sale()) {
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            }

            if (get_option('product_title') == 1):

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '"  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
                $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }

            endif;

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {

                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;
            
            $html .= '<div style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_list_12_price">';

            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();
            endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 
                $html .= '</div>';
            if ($product_stock_status != 'outofstock') {


                if ($product->is_on_sale()):
                    $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
                endif;
                $html .= '<div class="pro_list_12_box_icon"><ul>';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i aria-hidden="true" class="fa fa-link"></i></a></li>';
                endif;


                if (get_option('add_quantity_select') == 1):

                    if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<li><div class="qc_quantity qc_qat_style_seven">';    
                        $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{
                        $html .= '<li><div class="qc_quantity qc_qat_style_seven">';    
                        $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+"></div></li>';
                        }
                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{

                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;

                $html .= '</ul></div>';

            } else {

                if ($product->is_on_sale()):
                    $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
                endif;
                $html .= '<div class="pro_list_12_box_icon"><ul>';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i aria-hidden="true" class="fa fa-link"></i></a></li>';
                endif;


                $html .= '<li><div class="qc_variable_quantity">';


                if (get_option('add_cart_link') == 1):

                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';

                endif;

                $html .= '</div></li></ul>';
            }
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div>';
        endwhile;
    } else if ($theme_id == 'theme-eight') {
        $add_to_cart_text = get_option('change_add_to_cart_button_text');
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery(get_the_ID()).'"> <div class="qc_tabs_10_style_box">
                            <div class="pro_img">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()) .'</div>';

            if ($product->is_on_sale()):
                $html .= '<label class="qc_on_sale" for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
                $html .= ' <div class="qc-tabs-style13-hover">
                            <div class="pro_img">' . $product->get_image('shop_catalog') . '</div>';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

            $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . ' !important;" class="qc_price">';
            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();

            endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 
                $html .= '</div>';
                
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            if (get_option('display_rating') == 1):

                $html .= '<div class="qc_ratting">';
                $average = $product->get_average_rating();
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_eight">';
            if ($product_stock_status != 'outofstock') {
                    if ($product->get_type() != 'variable'):
                    if (get_option('add_quantity_select') == 1):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                              <input class="qc_plus" type="button" value="+">';

                        }else{
                        $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                     value="1">
                              <input class="qc_plus" type="button" value="+">';
                        }
                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" >';
                            if (!empty($add_to_cart_text)) {
                                $html .= esc_html( $add_to_cart_text, 'woo-tabbed-category' );
                            } else {
                                $html .= esc_html( 'Add To Cart', 'woo-tabbed-category' );
                            }
                            $html .= '</a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart">';
                            if (!empty($add_to_cart_text)) {
                                $html .= esc_html( $add_to_cart_text, 'woo-tabbed-category' );
                            } else {
                                $html .= esc_html( 'Add To Cart', 'woo-tabbed-category' );
                            }
                            $html .= '</a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#">Product Details</a>';
                    }

                endif;
            } else {

                if (get_option('add_cart_link') == 1):

                    $html .= '<a class="product_out_of_stock" data-p-price="' . $product->get_price() . '" data-p-id="' . $product->get_id() . '" href="'.$product->get_permalink().'">';

                    $html .= 'Product Details</a>';
                endif;
            }
            $html .= '</div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;
    } else if ($theme_id == 'theme-default') {
        $product_number  = get_option('product_number');
        //$column_number = 4;
        $column_number = get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number'): 4;

        $product_ids = array();
        while ($product_query->have_posts()) : $product_query->the_post();
            $product_id = get_the_ID();
            array_push($product_ids,$product_id);
        endwhile;
        $product_ids = implode(',', $product_ids);

        $html = do_shortcode('[products ids="'.$product_ids.'"  limit='.$product_number.' columns='.$column_number.'  orderby="'.esc_attr(get_option('qc_product_sort_type')) . '" order="'.esc_attr(get_option('qc_product_sort_order')) . '"]');
        
    }
    } else {
        $html .= '<span class="no-result">'.esc_html__('No matches found.', 'woo-tabbed-category').'</span>';
    }
    wp_reset_query();
    $response = array(
        'show_per_page' => $show_per_page,
        'product_num' => $products_num,
        'html' => $html,
        'offset' => $nextOffset,
        'show_sale' => $show_sale
    );
    echo wp_send_json($response);
    wp_die();

}