<?php

defined('ABSPATH') or die("No direct script access!");

function qcld_woo_tabbeds_cart_fragments( $fragments ) {
	global $woocommerce;

    ob_start();
    qcld_woo_tabbeds_cart_count();
    $fragments['span.qcld_woo_tabbeds_cart_total'] = ob_get_clean();

    ob_start();
    qcld_woo_tabbeds_checkout_inner();
    $fragments['div.qcld-woo-tabbeds-checkout-inner'] = ob_get_clean();
    
    return $fragments;
    
}
add_filter( 'woocommerce_add_to_cart_fragments', 'qcld_woo_tabbeds_cart_fragments', 10, 100 );

/**
 * Cart Count function 
 */
if ( ! function_exists( 'qcld_woo_tabbeds_cart_count' ) ) {
	function qcld_woo_tabbeds_cart_count() { ?>		
		<span class="qcld_woo_tabbeds_cart_total">
			<script type='text/javascript'>
			/* <![CDATA[ */
				var wiCartTotal = <?php echo WC()->cart->get_cart_contents_count(); ?>;
			/* ]]> */
			</script>
			<?php if ( WC()->cart->get_cart_contents_count() == 0 ) : ?>
				<style type="text/css" version="1.0">
					.qcld-woo-tabbeds-container{
					    right: -50% !important;
					}
					.qcld-woo-tabbeds-cart-header.hascart {
					    left: -70px !important;
					}
					@media (max-width: 767px){
					    .qcld-woo-tabbeds-container{
					        right: -100% !important;
					    }
					}
				</style>
			<?php endif; ?>
			<?php echo WC()->cart->get_cart_contents_count(); ?>
		</span> <?php
	}
}

/**
 * Cart Area function
 */
if ( ! function_exists( 'qcld_woo_tabbeds_cart_inner' ) ) {
	function qcld_woo_tabbeds_cart_inner() { 
		include plugin_dir_path( __FILE__ ) . '/inc/cart/cart.php';
	}
}

/**
 * Checkout Area function
 */
if ( ! function_exists( 'qcld_woo_tabbeds_checkout_inner' ) ) {
	function qcld_woo_tabbeds_checkout_inner() { ?>
		<div class="qcld-woo-tabbeds-checkout-inner">
			<button type="button" class="button alt" id="back_to_cart"><?php echo esc_attr('Back to cart','woo-tabbed-category'); ?></button>
			<?php echo do_shortcode('[woocommerce_checkout]');  ?>
		</div> <?php
	}
}

/**
 * Add wooinstant-active class to body
 */
function qcld_woo_tabbeds_body_classes( $classes ) {
	$classes[] = 'wooinstant-active';
	
	return $classes;
}
add_filter( 'body_class', 'qcld_woo_tabbeds_body_classes' );

/**
 * Calculate Shipping on Update Order Review
 */
function qcld_woo_tabbeds_action_woocommerce_checkout_update_order_review( $posted_data ) {
    WC()->cart->calculate_shipping();
}
add_action( 'woocommerce_checkout_update_order_review', 'qcld_woo_tabbeds_action_woocommerce_checkout_update_order_review', 10, 1 );

/**
 *	WooInstant Ajax functions
 */
// variable product quick view ajax actions
add_action('wp_ajax_qcld_woo_tabbeds_variable_product_quick_view', 'qcld_woo_tabbeds_ajax_quickview_variable_products');
add_action('wp_ajax_nopriv_qcld_woo_tabbeds_variable_product_quick_view', 'qcld_woo_tabbeds_ajax_quickview_variable_products');

// variable product quick view ajax function
function qcld_woo_tabbeds_ajax_quickview_variable_products(){
	global $post, $product, $woocommerce;
	check_ajax_referer( 'qcld_woo_tabbeds_ajax_nonce', 'security', false );

	add_action( 'wcqv_product_data', 'woocommerce_template_single_add_to_cart');

	$product_id = $_POST['product_id'];
    $wiqv_loop = new WP_Query(
        array(
            'post_type' => 'product',
            'p' => $product_id,
        )
    );

    ob_start();
	if( $wiqv_loop->have_posts() ) :
		while ( $wiqv_loop->have_posts() ) : $wiqv_loop->the_post(); ?>
			<?php wc_get_template( 'single-product/add-to-cart/variation.php' ); ?>
			<script>    
	            jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");
	 	    </script> <?php 
			do_action( 'wcqv_product_data' );
	 	endwhile;
	endif;

	echo ob_get_clean();

	wp_die();
}

// single product ajax add to cart actions
add_action('wp_ajax_qcld_woo_tabbeds_single_ajax_add_to_cart', 'qcld_woo_tabbeds_single_ajax_add_to_cart');
add_action('wp_ajax_nopriv_qcld_woo_tabbeds_single_ajax_add_to_cart', 'qcld_woo_tabbeds_single_ajax_add_to_cart');

// single product ajax add to cart actions
function qcld_woo_tabbeds_single_ajax_add_to_cart() {

    $product_id = apply_filters('woocommerce_add_to_cart_product_id', absint($_POST['product_id']));
    $quantity = empty($_POST['quantity']) ? 1 : wc_stock_amount($_POST['quantity']);
    $variation_id = absint($_POST['variation_id']);
    //$passed_validation = apply_filters('woocommerce_add_to_cart_validation', true, $product_id, $quantity);
    $passed_validation = apply_filters('woocommerce_add_to_cart_validation', true, $product_id, $quantity);
    $product_status = get_post_status($product_id);


    if ($passed_validation && WC()->cart->add_to_cart($product_id, $quantity, $variation_id) && 'publish' === $product_status) {

    	if($variation_id){
        do_action('woocommerce_ajax_added_to_cart', $variation_id);
    		
    	}else{
        do_action('woocommerce_ajax_added_to_cart', $product_id);
    		
    	}

        if ('yes' === get_option('woocommerce_cart_redirect_after_add')) {
            wc_add_to_cart_message(array($product_id => $quantity), true);
        }

        WC_AJAX::get_refreshed_fragments();
    } else {

        $data = array(
            'error' => true,
            'product_url' => apply_filters('woocommerce_cart_redirect_after_error', get_permalink($product_id), $product_id));

        echo wp_send_json($data);
    }

    wp_die();
    
}


//remove_action( 'woocommerce_external_add_to_cart', 'woocommerce_external_add_to_cart', 30 );
// Add the open in a new browser tab WooCommerce external product Buy Product button.
function qcld_woo_tabbeds_remove_addcart() {
   	// $product = get_product();
   	if (!class_exists('WooCommerce')){
   		return false;
   	}
    $product = wc_get_product();
    remove_action( 'woocommerce_external_add_to_cart', 'woocommerce_external_add_to_cart', 30 );
}
add_action( 'init', 'qcld_woo_tabbeds_remove_addcart' );

add_action( 'woocommerce_external_add_to_cart', 'qcld_woo_tabbeds_external_add_to_cart', 30 );
function qcld_woo_tabbeds_external_add_to_cart() {
	global $product;

	if ( ! $product->add_to_cart_url() ) {
		return;
	}

	$product_url = $product->add_to_cart_url();
	$button_text = $product->single_add_to_cart_text();
	do_action( 'woocommerce_before_add_to_cart_button' ); 
	?>
	<p class="cart">
	<a href="<?php echo esc_url( $product_url ); ?>" rel="nofollow" class="product_type_external button alt">
	<?php echo esc_html($button_text ); ?></a>
	</p>

	<?php  

	do_action( 'woocommerce_after_add_to_cart_button' );

}