<?php

defined('ABSPATH') or die("No direct script access!");

add_action('wp_head', 'qcld_woo_tabbed_ajaxurl');
function qcld_woo_tabbed_ajaxurl()
{

    $qcld_express_options = get_option('qcld_express_options');
    //$qcld_express_cart_mode_info=$qcld_express_options['qcld_express_cart_mode'];
    $qcld_express_cart_mode_info='all';
    echo '<script type="text/javascript">
           var ajaxurl = "' . admin_url('admin-ajax.php') . '";
           var currency_symbol = "' . get_woocommerce_currency_symbol() . '" ;
           var cart_mode_info = "' . $qcld_express_cart_mode_info . '" ;
         </script>';
}



$qc_woo_tabbed_cart_summary_position = get_option('qc_woo_tabbed_cart_summary_position');

if(isset($qc_woo_tabbed_cart_summary_position) && $qc_woo_tabbed_cart_summary_position == 'leftfloat' ){
    function qcld_woo_tabbed_float_cart_global(){

        global $woocommerce;
        $items = $woocommerce->cart->get_cart();
        $itemCount = count($items);
        ?>
        <div class="qcld-woo-tabbed-shop-float-cart">
            <button type="button" id="float-cart-btn"> <i class="fa fa-shopping-cart"></i> <small class="qcld-woo-tabbed-cart-item-num"><?php if($itemCount >= 1) { echo $itemCount;  } else{ echo '0';}?></small> </button>
            <div class="qcld-woo-tabbed-shop-cart" id="qcld-woo-tabbed-cart-container">
                <div class="qcld-woo-tabbed-show-cart-wrapper">
                    <div class="qcld-woo-tabbed-cart-heading">
                        <h3>
                        <?php esc_html_e( get_option('qcld_lan_cart_summary'), 'woo-tabbed-category' ); ?>
                        </h3><button type="button"  id="show-float-cart-close" class="fa fa-times"></button>
                    </div>
                    <div class="qcld-woo-tabbed-show-cart-data">
                        <?php
                        if ($itemCount >= 1) { ?>
                            <div class ="qcld-woo-tabbed-table">
                                <div class="qcld-woo-tabbed-row">
                                    <div class="qcld-woo-tabbed-cell qcl-cel-01">
                                        <?php esc_html_e( 'Title', 'woo-tabbed-category' ); ?>
                                    </div>
                                    <div class="qcld-woo-tabbed-cell qcl-cel-02">
                                        <?php esc_html_e( 'Quantity', 'woo-tabbed-category' ); ?>
                                    </div>
                                    <div class="qcld-woo-tabbed-cell qcl-cel-03">
                                        <?php esc_html_e( 'Price', 'woo-tabbed-category' ); ?>
                                    </div>
                                </div>
                                <?php
                                foreach ($items as $item => $values) {
                                    $_product = apply_filters('woocommerce_cart_item_product', $values['data'], $values, $item);
                                    $getProductDetail = wc_get_product($values['product_id']);
                                    $price = get_post_meta($values['product_id'], '_price', true); ?>

                                    <div class="qcld-woo-tabbed-row">
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-title-cell"> <h3 class="qcld-woo-tabbed-title">
                                            <?php
                                               
                                                $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $values ) : '', $values, $item );
                                                $product_name =  apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $_product->get_title() ), $values, $item );

                                                echo '<p>'.$product_name.'</p>';

                                                $attributes = '';

                                                //Variation
                                                $attributes .= $_product->is_type('variable') || $_product->is_type('variation') ? wc_get_formatted_variation($_product) : '';
                                               

                                                if($attributes){
                                                    echo $attributes;
                                                }
                                            ?>
                                            
                                        </h3></div>
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-quantity-cell">
                                                <input class="qcld-cart-item-qnty" data-cart-item="<?php echo $item ?>" type="number" min="1" value="<?php echo $values['quantity'];?>">
                                        </div>
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-price-cell"> <span><?php echo apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($_product), $values, $item) ;?> </span> <span data-cart-item="<?php echo $item ?>" class="qcld-remove-cart-item"> <i class="fa fa-trash"></i> </span></div>
                                    </div>

                                <?php } ?>
                                <div class="qcld-woo-tabbed-row">
                                    <div class="qcld-woo-tabbed-cell"><strong>
                                    <?php echo esc_html('Total', 'woo-tabbed-category'); ?>  
                                    </strong></div>
                                    <div class="qcld-woo-tabbed-cell"> <?php if($itemCount >= 1) { echo esc_html($itemCount).' '. esc_html('items', 'woo-tabbed-category');  }?></div>
                                    <div class="qcld-woo-tabbed-cell"><strong><?php echo $woocommerce->cart->get_cart_total(); ?></strong></div>
                                </div>
                            </div>
                        <?php } else{ ?>
                            <div class="qcld_no_cartprods">
                                 <?php echo esc_html('No products in the cart', 'woo-tabbed-category'); ?> 
                            </div>


                        <?php } ?>
                    </div>
                    <div class="qcld-woo-tabbed-cart-footer">
                        <a href="<?php echo wc_get_cart_url();?>">
                            <?php  echo esc_html('Edit on  Cart', 'woo-tabbed-category'); ?> 
                        </a>
                        <a class="qcld-woo-tabbed-checkout-link" href="<?php echo wc_get_checkout_url();?>">
                            <?php echo esc_html('Checkout', 'woo-tabbed-category'); ?> 
                        </a>
                    </div>
                </div>

            </div>
        </div>
        <?php
    }//End of function
} //End of if condition.
if(isset($qc_woo_tabbed_cart_summary_position) && $qc_woo_tabbed_cart_summary_position == 'rightfloat' ){

    function qcld_woo_tabbed_float_cart_global(){

        global $woocommerce;
        $items = $woocommerce->cart->get_cart();
        $itemCount = count($items);
        ?>
        <div class="qcld-woo-tabbed-shop-right-float-cart">
            <button type="button" id="right-float-cart-btn"> <i class="fa fa-shopping-cart"></i> <small class="qcld-woo-tabbed-cart-item-num"><?php if($itemCount >= 1) { echo $itemCount;  } else{ echo '0';}?></small> </button>
            <div class="qcld-woo-tabbed-shop-cart" id="qcld-woo-tabbed-cart-container">
                <div class="qcld-woo-tabbed-show-cart-wrapper">
                    <div class="qcld-woo-tabbed-cart-heading">
                        <h3> 
                        <?php esc_html_e( get_option('qcld_lan_cart_summary'), 'woo-tabbed-category' ); ?>
                        </h3><button type="button"  id="right-show-float-cart-close" class="fa fa-times"></button>
                    </div>
                    <div class="qcld-woo-tabbed-show-cart-data">
                        <?php
                        if ($itemCount >= 1) { ?>
                            <div class ="qcld-woo-tabbed-table">
                                <div class="qcld-woo-tabbed-row">
                                    <div class="qcld-woo-tabbed-cell qcl-cel-01">
                                    <?php esc_html_e( 'Title', 'woo-tabbed-category' ); ?>
                                    </div>
                                    <div class="qcld-woo-tabbed-cell qcl-cel-02">
                                    <?php esc_html_e( 'Quantity', 'woo-tabbed-category' ); ?>
                                    </div>
                                    <div class="qcld-woo-tabbed-cell qcl-cel-03">
                                    <?php esc_html_e( 'Price', 'woo-tabbed-category' ); ?>
                                    </div>
                                </div>
                                <?php
                                foreach ($items as $item => $values) {
                                    $_product = apply_filters('woocommerce_cart_item_product', $values['data'], $values, $item);
                                    $getProductDetail = wc_get_product($values['product_id']);
                                    $price = get_post_meta($values['product_id'], '_price', true); ?>

                                    <div class="qcld-woo-tabbed-row">
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-title-cell"> <h3 class="qcld-woo-tabbed-title">
                                            <?php 
                                               
                                                $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $values ) : '', $values, $item );
                                                $product_name =  apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $_product->get_title() ), $values, $item );

                                                echo '<p>'.$product_name.'</p>';

                                                $attributes = '';

                                                //Variation
                                                $attributes .= $_product->is_type('variable') || $_product->is_type('variation') ? wc_get_formatted_variation($_product) : '';
                                               

                                                if($attributes){
                                                    echo $attributes;
                                                }

                                            ?>
                                        </h3></div>
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-quantity-cell">
                                                <input class="qcld-cart-item-qnty" data-cart-item="<?php echo $item ?>" type="number" min="1" value="<?php echo $values['quantity'];?>">
                                        </div>
                                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-price-cell"> <span><?php echo apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($_product), $values, $item) ;?> </span> <span data-cart-item="<?php echo $item ?>" class="qcld-remove-cart-item"> <i class="fa fa-trash"></i> </span></div>
                                    </div>

                                <?php } ?>
                                <div class="qcld-woo-tabbed-row">
                                    <div class="qcld-woo-tabbed-cell"><strong>
                                    <?php echo esc_html('Total', 'woo-tabbed-category'); ?> 
                                   
                                    </strong></div>
                                    <div class="qcld-woo-tabbed-cell"> <?php if($itemCount >= 1) { echo esc_html($itemCount.' '.'items', 'woo-tabbed-category');  }?></div>
                                    <div class="qcld-woo-tabbed-cell"><strong><?php echo $woocommerce->cart->get_cart_total(); ?></strong></div>
                                </div>
                            </div>
                        <?php } else{ ?>
                            <div class="qcld_no_cartprods">
                                <?php echo esc_html('No products in the cart', 'woo-tabbed-category'); ?> 
                            </div>
                        <?php } ?>
                    </div>
                    <div class="qcld-woo-tabbed-cart-footer">
                        <a href="<?php echo wc_get_cart_url();?>">
                            <?php esc_html_e( 'Edit on  Cart', 'woo-tabbed-category' ); ?>

                        </a>
                        <a class="qcld-woo-tabbed-checkout-link" href="<?php echo wc_get_checkout_url();?>">
                            <?php esc_html_e( 'Checkout', 'woo-tabbed-category' ); ?>
                        </a>
                    </div>
                </div>

            </div>
        </div>
        <?php
    }//End of function.
} //End of if condition.

if(isset($qc_woo_tabbed_cart_summary_position) && $qc_woo_tabbed_cart_summary_position == 'wooinstantcart' ){

    function qcld_woo_tabbed_float_cart_global(){
        global $woocommerce;

    $qc_woo_tabbed_cart_summary_style = get_option('qc_woo_tabbed_cart_summary_style');
    if(isset($qc_woo_tabbed_cart_summary_style) && $qc_woo_tabbed_cart_summary_style == 'off'){
        return;
    }

    $qc_woo_tabbed_cart_summary_position = get_option('qc_woo_tabbed_cart_summary_position');
    if(isset($qc_woo_tabbed_cart_summary_position) && $qc_woo_tabbed_cart_summary_position != 'wooinstantcart' ){
        return;
    }

        if ( class_exists('Woocommerce') ): ?>
            <div class="qcld-woo-tabbeds-container">
                <a id="qcld-woo-tabbeds-toggler" class="qcld-woo-tabbeds-cart-header hascart ">
                    <i class="fa fa-shopping-cart"></i>
                    <?php echo qcld_woo_tabbeds_cart_count(); ?>
                </a>
                <div class="qcld-woo-tabbeds-inner">
                    <h3><?php esc_html_e( get_option('qcld_lan_cart_summary'), 'woo-tabbed-category' ); ?></h3>
                    <div class="wooinstant-content woocommerce">
                        <div id="qcld-woo-tabbeds-cart-area">
                            <?php echo qcld_woo_tabbeds_cart_inner(); ?>
                        </div>
                        <div id="qcld-woo-tabbeds-checkout-area">
                            <?php echo qcld_woo_tabbeds_checkout_inner(); ?>
                        </div>
                    </div>
                </div>
            </div>
            <?php
        endif;
    }

}


//Show cart after adding product to cart.
add_action('wp_ajax_show_cart', 'qcld_woo_tabbled_show_cart');
add_action('wp_ajax_nopriv_show_cart', 'qcld_woo_tabbled_show_cart');
function qcld_woo_tabbled_show_cart(){
    $html = '';
    $qcld_express_options           = get_option('qcld_express_options');
    $qcld_express_lang_title        = $qcld_express_options['qcld_express_lang_title'];
    $qcld_express_lang_quantity     = $qcld_express_options['qcld_express_lang_quantity'];
    $qcld_express_lang_price        = $qcld_express_options['qcld_express_lang_price'];
    $qcld_express_lang_no_products  = $qcld_express_options['qcld_express_lang_no_products'];
    $qcld_express_lang_cart_total   = $qcld_express_options['qcld_express_lang_cart_total'];
    $qcld_express_lang_items        = $qcld_express_options['qcld_express_lang_items'];

    global $woocommerce;
    $items = $woocommerce->cart->get_cart();
    $itemCount = count($items);
    if ($itemCount >= 1) {
        $html .= '<div class ="qcld-woo-tabbed-table">';
        $html .= '<div class="qcld-woo-tabbed-row"><div class="qcld-woo-tabbed-cell">';
        if(isset($qcld_express_lang_title) && $qcld_express_lang_title != '' ){
            $html .= esc_html($qcld_express_lang_title, 'woo-tabbed-category');
        }else{
            $html .= esc_html('Title', 'woo-tabbed-category');
        }
        $html .='</div><div class="qcld-woo-tabbed-cell">';
        if(isset($qcld_express_lang_quantity) && $qcld_express_lang_quantity != '' ){
            $html .= $qcld_express_lang_quantity;
        }else{
            $html .= esc_html('Quantity', 'woo-tabbed-category');
        }
        $html .='</div><div class="qcld-woo-tabbed-cell">';
        if(isset($qcld_express_lang_price) && $qcld_express_lang_price != '' ){
            $html .= $qcld_express_lang_price;
        }else{
            $html .= esc_html('Price', 'woo-tabbed-category');
        }
        $html .='</div></div>';
        foreach ($items as $item => $values) {
            $_product = apply_filters('woocommerce_cart_item_product', $values['data'], $values, $item);
            //product image
            $getProductDetail = wc_get_product($values['product_id']);
            $price = get_post_meta($values['product_id'], '_price', true);

            $html .= '<div class="qcld-woo-tabbed-row">
                        <div class="qcld-woo-tabbed-cell qcld-woo-tabbed-title-cell"> <h3 class="qcld-woo-tabbed-title">';
                            
                                               
                        $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $values ) : '', $values, $item );
                        $product_name =  apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $_product->get_title() ), $values, $item );

                        $html .= '<p>'.$product_name.'</p>';

                        $attributes = '';

                        //Variation
                        $attributes .= $_product->is_type('variable') || $_product->is_type('variation') ? wc_get_formatted_variation($_product) : '';
                       

                        if($attributes){
                           $html .= $attributes;
                        }
                        $html.='</h3></div>';
                        $html .= '<div class="qcld-woo-tabbed-cell qcld-woo-tabbed-quantity-cell">';
            $html .= '<input class="qcld-cart-item-qnty" data-cart-item="'.$item.'" type="number" min="1" value="'.$values['quantity'].'"></div>';
            $html .= '<div class="qcld-woo-tabbed-cell qcld-woo-tabbed-price-cell"><span>' . apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($_product), $values, $item) . '</span> <span data-cart-item="'.$item.'" class="qcld-remove-cart-item"> <i class="fa fa-trash"></i> </span></div> </div>';
        }
        if(isset($qcld_express_lang_items) && $qcld_express_lang_items != ''){
            $qcld_cart_items = esc_html($qcld_express_lang_items, 'woo-tabbed-category'); 
        }else{
            $qcld_cart_items = esc_html('items', 'woo-tabbed-category');
        }
            
        $html.='<div class="qcld-woo-tabbed-row">
                            <div class="qcld-woo-tabbed-cell"><strong>';
                            if(isset($qcld_express_lang_cart_total) && $qcld_express_lang_cart_total != '' ){
                                $html .= esc_html($qcld_express_lang_cart_total, 'woo-tabbed-category');
                            }else{
                                $html .= esc_html('Total', 'woo-tabbed-category');
                            }
                        $html .='</strong></div>
                            <div class="qcld-woo-tabbed-cell">'. $itemCount.' '. $qcld_cart_items.'</div>
                            <div class="qcld-woo-tabbed-cell"><strong>'.$woocommerce->cart->get_cart_total().'</strong></div>
                        </div>';
        $html .= ' </div>';
    } else {
        // qcld_express_lang_cart_total
        if(isset($qcld_express_lang_no_products) && $qcld_express_lang_no_products != '' ){
            $html .= '<div class="qcld_no_cartprods">'.esc_html($qcld_express_lang_no_products, "woo-tabbed-category").'</div>';
        }else{
            $html .= '<div class="qcld_no_cartprods">'.esc_html("No products in the cart", "woo-tabbed-category").'</div>';
        }
    }
    $response=array('html'=>$html,'items'=>$itemCount);
    echo wp_send_json($response);
    wp_die();
}
//Show item after removing from cart page.
add_action('wp_ajax_remove_item_numbers_from_cart', 'qcld_woo_tabbled_remove_item_numbers_from_cart');
add_action('wp_ajax_nopriv_remove_item_numbers_from_cart', 'qcld_woo_tabbled_remove_item_numbers_from_cart');
function qcld_woo_tabbled_remove_item_numbers_from_cart(){
    //getting cart items number getting.
    global $woocommerce;
    $items = $woocommerce->cart->get_cart();
    $itemCount = count($items);
    //$itemCount = $woocommerce->cart->get_cart_contents_count();
    if($itemCount>1){
        $html='( '.$itemCount.' items )';
    } else if($itemCount==1){
        $html='( '.$itemCount.' item)';
    }else if($itemCount==0){
        $html='( No item )';
    }
    echo wp_send_json($html);
    wp_die();
}

//Cart item number update from global cart.
add_action('wp_ajax_update_cart_item_number', 'qcld_woo_tabbled_update_cart_item_number');
add_action('wp_ajax_nopriv_update_cart_item_number', 'qcld_woo_tabbled_update_cart_item_number');
function qcld_woo_tabbled_update_cart_item_number(){
    //getting cart items n
    $cart_item_key  = $_POST['cart_item_key'];

    $qnty = empty( $_POST['qnty'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['qnty'] );
    global $woocommerce;
    $result         = $woocommerce->cart->set_quantity($cart_item_key, $qnty);
    echo wp_send_json($result);
    wp_die();
}

//Add to cart for simple product.
add_action('wp_ajax_sp_add_to_cart', 'qcld_woo_tabbled_sp_add_to_cart');
add_action('wp_ajax_nopriv_sp_add_to_cart', 'qcld_woo_tabbled_sp_add_to_cart');


function qcld_woo_tabbled_sp_add_to_cart()
{

    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['p_id'] ) );
    $product_quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    global $woocommerce;
    $result = $woocommerce->cart->add_to_cart($product_id,$product_quantity);
    if ($result != false) {
        echo wp_send_json('simple');
    } else {
        echo wp_send_json('error');
    }
    wp_die();
}

//Add to cart for variable product.
add_action('wp_ajax_vp_add_to_cart', 'qcld_woo_tabbled_vp_add_to_cart');
add_action('wp_ajax_nopriv_vp_add_to_cart', 'qcld_woo_tabbled_vp_add_to_cart');


function qcld_woo_tabbled_vp_add_to_cart()
{
    ob_start();
        
    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
    $quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    $variation_id = $_POST['variation_id'];
    $variation  = $_POST['variation'];
    $passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );

    if ( $passed_validation && WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variation  ) ) {
        do_action( 'woocommerce_ajax_added_to_cart', $product_id );
        if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
            wc_add_to_cart_message( $product_id );
        }

        // Return fragments
        WC_AJAX::get_refreshed_fragments();
    } else {
        $this->json_headers();

        // If there was an error adding to the cart, redirect to the product page to show any errors
        $data = array(
            'error' => true,
            'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
            );
        echo json_encode( $data );
    }


    wp_die();

}
