<?php 
defined('ABSPATH') or die("No direct script access!");


function woo_tabbed_product_tag_menu($show_sale, $featured_only, $categories_all_pera, $link_title_to_modal, $theme_name){


    $qc_woo_tabbed_enable_product_tag_filter  = get_option('qc_woo_tabbed_enable_product_tag_filter');

    if(!empty($qc_woo_tabbed_enable_product_tag_filter)){

    // get product_tags of the current product
    $current_tags = get_terms( 'product_tag' );

        //only start if we have some tags
        if ( $current_tags && ! is_wp_error( $current_tags ) ) {

            $html = '';

            //create a list to hold our tags
            $html .='<div> ';
            $html .='<ul class="qcld_product_tags ">';

            $html .= '<li data-tag="">Tags:</li>';

            //for each tag we create a list item
            foreach ($current_tags as $tag) {

                $tag_title = $tag->name; // tag name
                $tag_link = get_term_link( $tag ); // tag archive link

                //echo '<li><a href="'.$tag_link.'">'.$tag_title.'</a></li>';
                $html .= '<li data-feature-only="'.$featured_only.'" data-show-sale="'.$show_sale.'"  data-cat-id="all" data-offset="'.get_option('product_number').'" data-cat-attr="'.$categories_all_pera.'" title-modal="'.$link_title_to_modal.'" data-tag="'.$tag_title.'" data-theme="'.$theme_name.'" >'.$tag_title.'</li>';

            }

            $html .= '</ul></div>';

            echo $html;
        }
        
    }

}

/***********************************************
 * Theme One tag pro
************************************************/



/***********************************************
 * Ajax load products sorting theme default
************************************************/

add_action('wp_ajax_get_products_by_product_tag_theme_default', 'get_products_by_product_tag_theme_default');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_default', 'get_products_by_product_tag_theme_default');

function get_products_by_product_tag_theme_default(){
    
    $column_number = get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number'): 4;


    $post_per_page  = get_option('product_number');
    $cat_id         = $_POST['cat_id'];
    $offset         = $_POST['offset'];
    $show_sale      = $_POST['show_sale'];
    $show_feature   = $_POST['feature_only'];
    $qc_shortcode_parameters  = $_POST['data_cat_parameter'];
    $link_title_to_modal      = $_POST['link_title_to_modal'];
    $category_ids             = $_POST['data_cat_parameter'];


    $product_tags = $_POST['data_tag'];
    $qcld_order_by = esc_attr(get_option('qc_product_sort_type'));

    $product_categories = unserialize(get_option('selected_categories'));
    $product_number     = get_option('product_number');

    $category_orders    = get_option('category_order');

    if($category_orders == 'menu_order'){
        $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
        );

    }else{

        $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
        );

    }
    $product_categories = get_terms('product_cat', $argss);


    $categories_all = '';

    if (!empty($qc_shortcode_parameters) ) {
        $category_ids = $qc_shortcode_parameters;
        // convert the string into php array
        $categories_all = explode(',', $category_ids);

    } else {
        $categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }
    }


    $args = array(
        'post_type'         => 'product',
        'post_status'       => 'publish',
        'posts_per_page'    => $post_per_page,
        'product_tag'       => $product_tags,
        'orderby'           => get_option('qc_product_sort_type'),
        'order'             => get_option('qc_product_sort_order'),
        'tax_query'     => array(
            'relation'  => 'AND',
            array(
                'taxonomy'  => 'product_cat',
                'field'     => 'term_id',
                'terms'     => $categories_all,
                'operator'  => 'IN'
            ),
        )
    );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }
      

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }


    $html = sprintf(  __( '%s' ), do_shortcode('[products tag="'.$product_tags.'"  limit='.get_option('product_number').' columns='.$column_number.'  orderby="'.esc_attr($qcld_order_by) . '" order="'.esc_attr(get_option('qc_product_sort_order')) . '"]') );

    $response = array(
        'cat_id'    => $cat_id,
        'html'      => $html,
        'offset'    => $nextOffset
    );

    echo wp_send_json($response);
    wp_die();

}

/***********************************************
 * Ajax load products on shorting theme one and two
************************************************/

add_action('wp_ajax_get_products_by_product_tag_theme_two', 'get_products_by_product_tag_theme_two');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_two', 'get_products_by_product_tag_theme_two');


function get_products_by_product_tag_theme_two(){

    $post_per_page  = get_option('product_number');
    $cat_id         = $_POST['cat_id'];
    $offset         = $_POST['offset'];
    $show_sale      = $_POST['show_sale'];
    $show_feature   = $_POST['feature_only'];
    $qc_shortcode_parameters  = $_POST['data_cat_parameter'];
    $link_title_to_modal      = $_POST['link_title_to_modal'];
    $category_ids             = $_POST['data_cat_parameter'];


    $product_tags = $_POST['data_tag'];


    $product_categories = unserialize(get_option('selected_categories'));
    $product_number     = get_option('product_number');

    $category_orders    = get_option('category_order');

    if($category_orders == 'menu_order'){
        $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
        );

    }else{

        $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
        );

    }
    $product_categories = get_terms('product_cat', $argss);


    $categories_all = '';

    if (!empty($qc_shortcode_parameters) ) {
        $category_ids = $qc_shortcode_parameters;
        // convert the string into php array
        $categories_all = explode(',', $category_ids);

    } else {
        $categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }
    }


    $args = array(
        'post_type'         => 'product',
        'post_status'       => 'publish',
        'posts_per_page'    => $post_per_page,
        'product_tag'       => $product_tags,
        'orderby'           => get_option('qc_product_sort_type'),
        'order'             => get_option('qc_product_sort_order'),
        'tax_query' => array(
            'relation' => 'AND',
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $categories_all,
                'operator' => 'IN'
            ),
        )
    );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }
      

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }

    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<li><div class="product-box"><div class="product-img"><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') . '</a><div class="one-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div>';
        }else{

            $html .= '<li><div class="product-box"><div class="product-img"><a href="'. $product->get_permalink() .'">' . $product->get_image('shop_catalog') . '</a><div class="one-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div>';
        }

        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_two">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                    <input class="qc_plus" type="button" value="+">';

                }else{
                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="1">
                    <input class="qc_plus" type="button" value="+">';
                }
            }
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {

                if ($product->get_type() != 'variable'){

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                }else{
                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }

            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
            }
        endif;
        $html .= '<div class="clear"></div></div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();

}



/***********************************************
 * Ajax load products sorting theme three
************************************************/

add_action('wp_ajax_get_products_by_product_tag_theme_three', 'get_products_by_product_tag_theme_three');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_three', 'get_products_by_product_tag_theme_three');


function get_products_by_product_tag_theme_three(){

    $post_per_page  = get_option('product_number');
    $cat_id         = $_POST['cat_id'];
    $offset         = $_POST['offset'];
    $show_sale      = $_POST['show_sale'];
    $show_feature   = $_POST['feature_only'];
    $qc_shortcode_parameters  = $_POST['data_cat_parameter'];
    $link_title_to_modal      = $_POST['link_title_to_modal'];
    $category_ids             = $_POST['data_cat_parameter'];


    $product_tags             = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }

    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li>';

        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;


        $html .= '<div class="wootabs_img">' . $product->get_image('shop_catalog') . '</div>';

        if ($product_stock_status != 'outofstock') {


            $html .= '<div class="qc_pro_details">';

            $html .= '<ul>';
                    
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
        
                $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
            }else{ 
               $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
            }

            if (get_option('add_quantity_select') == 1):
           
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+"></div></li>';

                }else{
                $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+"></div></li>';
                    }
                }
            endif;

            if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{
                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }
            endif;


            $html .= '</ul>
             </div>';
        } else {
            $html .= '<div class="qc_pro_details">';

            $html .= '<ul>';
                    
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
        
                $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
            }else{ 
               $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
            }


            $html .= '<div class="qc_out_of_stock_container qc_quantity qc_qat_style_three ">';


            if (get_option('add_cart_link') == 1):

                $html .= '<a data-p-id="' . $product->get_id() . '" class="product_out_of_stock" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
            endif;


            $html .= '</ul>
             </div>';
        }
        if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';"  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
             }else{ 
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            $html .= '<div class="qcld_woo_product_rating">';
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }

            $html .= '</div>';
        endif;
        $html .= '<div class="woo_price" style="font-size:' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';


        if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
        $html .= '</div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}

/***********************************************
 * Ajax  products sorting theme five
************************************************/

add_action('wp_ajax_get_products_by_product_tag_theme_five', 'get_products_by_product_tag_theme_five');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_five', 'get_products_by_product_tag_theme_five');


function get_products_by_product_tag_theme_five(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
                'hide_empty'    => 1,
                'order'         => 'asc',
                'exclude'       => $product_categories,
                'include'       => $category_ids,
            );

        }else{

            $argss = array(
                'hide_empty'    => 1,
                'order'         => get_option('category_order'),
                'orderby'       => 'title',
                'exclude'       => $product_categories,
                'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }
    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li class="">';
        $html .= '<div class="qc_tabs_10_style_box">';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img
                        src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;
        if (get_option('product_title') == 1):
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;"  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
             }else{ 
            $html .= '<h2><a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;

        if (get_option('display_price') == 1):
            $html .= '<div class="qc_price">' . $product->get_price_html() . '</div>';
        endif;
        
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

        $html .= '<div class="qc_ratting">';
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }

        endif;
        $html .= '</div>
            <div class="divider"></div>
            <div class="pro_img">' . $product->get_image('shop_catalog') . '</div>';

                $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

        $html .= '</div>';


        if ($product_stock_status != 'outofstock') {
            $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">';
            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;"  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
                $html .= '<h2><a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

            $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';"
                             class="qc_price">';

            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();
            endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

            $html .= '<div class="qc_ratting">';
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }

            endif;
            if ($product->get_type() != 'variable'){
            $html .= '</div><div class="qc_tabs_10_style_box_icon">';
            }else{
            $html .= '</div><div class="qc_tabs_10_style_box_icon">';
            }
            $html.='<ul>';

            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<li><a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'"><i  class="fa fa-link" aria-hidden="true"></i></a></li>';
                 }else{ 
                $html .= '<li><a href="' . $product->get_permalink() . '"><i  class="fa fa-link" aria-hidden="true"></i></a></li>';
                }
            endif;


            if (get_option('add_quantity_select') == 1):
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity"
                                           value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                                    <input class="qc_plus" type="button" value="+"></div></li>';

                }else{

                $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity"
                                           value="1">
                                    <input class="qc_plus" type="button" value="+"></div></li>';
                    }
                }

            endif;
            if (get_option('add_cart_link') == 1):

                if ($product->get_type() != 'variable'){

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= '<li> <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    else:
                    $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    endif;

                    }else{
                        $html .= '<li><a class="woo_tab_product_details woo_tab_paddings" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }
            endif;


            $html .= '</ul>
                    </div>
                </div>
            </div>';

        } else {
            $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">

                    <div class="qc_tabs_10_style_box_icon qc_theme_five_stock_out">
                        <ul>';

            if (get_option('product_title') == 1):
                $html .= '<li><a href="'.$product->get_permalink().'"><i
                                            class="fa fa-link"
                                            aria-hidden="true"></i></a>
                                </li>';

            endif;


            $html .= '<li><div class="qc_quantity qc_qat_style_five qc_out_of_stock_container">';


            $html .= ' <a class="product_out_of_stock"
                                   data-p-price="' . $product->get_price() . '"
                                   data-p-id="' . $product->get_id() . '"
                                   href="#"><i
                                        class="fa fa-cart-arrow-down"
                                        aria-hidden="true"></i></a>
                            </div></li>


                        </ul>
                    </div>
                </div>
            </div>';
        }


                                           
        
        $html .= '</li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}



// Ajax  products sorting theme six

add_action('wp_ajax_get_products_by_product_tag_theme_six', 'get_products_by_product_tag_theme_six');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_six', 'get_products_by_product_tag_theme_six');


function get_products_by_product_tag_theme_six(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags               = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number     = get_option('product_number');

        $category_orders    = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }

    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();


        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
        $html .= '<div class="pro_list_04"><div class="slider"><div class="pro_item_list"><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') . '</a></div>';
            }else{ 
        $html .= '<div class="pro_list_04"><div class="slider"><div class="pro_item_list"><a href="' . $product->get_permalink() . '">' . $product->get_image('shop_catalog') . '</a></div>';
            }


            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
               
        $average = $product->get_average_rating();


        if (get_option('display_rating') == 1):
            $html .= '<div class="qcld_woo_product_rating">';
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
            $html .= '</div>';

        endif;
        $html .= '</div>';


        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;
        $html .= '<div class="meta">';


        if (get_option('product_title') == 1):


        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h3>';
            }else{ 
            $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h3>';
            }
        endif;
           
            $html .= '<span style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_price_04">';

        if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            $html .= '</span>'; 
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div>';
        if ($product_stock_status != 'outofstock') {
            $html .= '<ul class="pro_icon action action_button action_buy">';

            if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }


            endif;

            $html .= '<div class="qc_quantity qc_qat_style_six">';

            if (get_option('add_quantity_select') == 1):
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];
                $html .= '<input class="qc_minus" type="button" value="-">
                             <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                    value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                             <input class="qc_plus" type="button" value="+">';

                }else{
                $html .= '<input class="qc_minus" type="button" value="-">
                             <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                    value="1">
                             <input class="qc_plus" type="button" value="+">';
                    }
                }
            endif;

            if (get_option('add_cart_link') == 1):

                if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{
                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }

            endif;

            $html .= '</ul>';
        } else {
            $html .= '<ul class="pro_icon action action_button action_buy">';

                $html .= '<ul>';
            if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }


            endif;

            $html .= '<div class="qc_quantity qc_qat_style_six">';


            if (get_option('add_cart_link') == 1):

                $html .= '<a class="product_out_of_stock" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';


            endif;

            $html .= '</ul>';
        }

        $html .= '</div>';                            
           
        $html .= '</div>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}




// Ajax load products into tab for theme seven

add_action('wp_ajax_get_products_by_product_tag_theme_seven', 'get_products_by_product_tag_theme_seven');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_seven', 'get_products_by_product_tag_theme_seven');

function get_products_by_product_tag_theme_seven(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }

    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li> <div class="pro_list_12_box">
                                            <div class="pro_list_12_img">' . $product->get_image('shop_catalog') . '</div>';
        if ($product->is_on_sale()) {
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        }

        if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '"  href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }

        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            $html .= '<div class="qcld_woo_product_rating">';
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {

                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
            $html .= '</div>';

        endif;
            $html .= '<div style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_list_12_price">';

        if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            $html .='</div>';
        if ($product_stock_status != 'outofstock') {


            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            $html .= '<div class="pro_list_12_box_icon"><ul>';
            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                }else{
                $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                }

            endif;

            if (get_option('add_quantity_select') == 1):
            if ($product->get_type() != 'variable'):
            $html .= '<li><div class="qc_quantity qc_qat_style_seven">';
            else:
            //$html .= '<li><div class="qc_variable_quantity">';
            endif;

                 if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                $html .= '<input class="qc_minus" type="button" value="-"><input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'"><input class="qc_plus" type="button" value="+"></div></li>';

                }else{

                $html .= '<input class="qc_minus" type="button" value="-"><input type="text" class="qc_product_quantity" name="qcld_quantity" value="1"><input class="qc_plus" type="button" value="+"></div></li>';


                    }
                }
            endif;

            if (get_option('add_cart_link') == 1):

                 if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{
                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true" ></i></a></li>';
                    }

            endif;

            $html .= '</ul></div>';

        }else{

            $html .= '<div class="pro_list_12_box_icon"><ul>';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                }else{
                $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                }

            endif;

            if (get_option('add_cart_link') == 1):
            $html .= '<li><div class="qc_out_of_stock_container qc_quantity qc_qat_style_seven">';
                $html .= '<a class="product_out_of_stock" data-p-price="'.$product->get_price().'" data-p-id="' . $product->get_id() . '" href="#"><i aria-hidden="true" class="fa  fa-cart-arrow-down"></i></a></div></li>';
            endif;

            $html .= '</ul></div>';
        }
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}


// Ajax products sorting theme eight

add_action('wp_ajax_get_products_by_product_tag_theme_eight', 'get_products_by_product_tag_theme_eight');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_eight', 'get_products_by_product_tag_theme_eight');

function get_products_by_product_tag_theme_eight(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }
    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li><div class="qc_tabs_10_style_box">
                    <div class="pro_img">' . $product->get_image('shop_catalog') . '</div>';
            if ($product->is_on_sale()):
                $html .= '<label class="qc_on_sale" for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= ' <div class="qc-tabs-style13-hover">
                                            <div class="pro_img">' . $product->get_image('shop_catalog') . '</div>';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
        endif;

        $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . ' !important;" class="qc_price">';

        if (get_option('display_price') == 1):
            $html .= $product->get_price_html();

        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

        if (get_option('display_rating') == 1):

            $html .= '<div class="qc_ratting">';
            $average = $product->get_average_rating();
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_eight">';
        if ($product_stock_status != 'outofstock') {
            if (get_option('add_quantity_select') == 1):
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                              <input class="qc_plus" type="button" value="+">';

                }else{
                $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                     value="1">
                              <input class="qc_plus" type="button" value="+">';
                    }
                }
            endif;

            if (get_option('add_cart_link') == 1):

                if ($product->get_type() != 'variable'){

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" >';
                            if (!empty($add_to_cart_text)) {
                                $html .= esc_html($add_to_cart_text, 'woo-tabbed-category' );
                            } else {
                                $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                            }
                        $html .= '</a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart">';
                        if (!empty($add_to_cart_text)) {
                            $html .=  esc_html($add_to_cart_text, 'woo-tabbed-category' );
                        } else {
                            $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                        }
                    $html .= '</a>';
                    endif;


                }else{
                $html .= '<ul><li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                }


            endif;
        } else {


            if (get_option('add_cart_link') == 1):

                $html .= '<a class="product_out_of_stock" data-p-price="' . $product->get_price() . '" data-p-id="' . $product->get_id() . '"
                                                            href="#">';

                $html .= 'Out Of Stock</a>';



            endif;
        }
        $html .= '</div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}




// Ajax load products into tab for theme nine

add_action('wp_ajax_get_products_by_product_tag_theme_nine', 'get_products_by_product_tag_theme_nine');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_nine', 'get_products_by_product_tag_theme_nine');

function get_products_by_product_tag_theme_nine(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }

    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();


        $html .= '<li class="ilist-25">
                                    <div class="qc-wootabs-col-4">
                                        <div class="ilist-item-main">';

        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img
            src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
        $html .= '<div class="feature-img-box valign-center"><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') . '</a></div>';
        }else{ 
        $html .= '<div class="feature-img-box valign-center"><a href="' . $product->get_permalink() . '">' . $product->get_image('shop_catalog') . '</a></div>';
        }
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

        $html .= '<div class="item-desc-text">';
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):

            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png"alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png"alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png"alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png"alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png"alt="">';
            }

        endif;
        if (get_option('product_title') == 1):

        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h3 class="item-list-title"><a
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h3>';
        }else{ 
            $html .= '<h3 class="item-list-title"><a
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h3>';
        }

        endif;

        $html .= '<div class="tpl_nine_short_desc"
         style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ' !important;">' . strip_tags($product->get_short_description()) . '</div>
</div>
<div class="item-title-text">';

        if (get_option('display_price') == 1):
            $html .= '<div class="price_tabs"
             style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';">' . $product->get_price_html() . '</div>';
        endif;

        $html .= '<div class="qc_quantity qc_qat_style_nine">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                   if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                    $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity" name="qcld_quantity"
                    value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                }else{
                    $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity" name="qcld_quantity"
                   value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }
                }
            endif;
        endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {
                   if ($product->get_type() != 'variable'){
                    
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{
                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }
                } else {
                    $html .= '<a class="product_out_of_stock"
               data-p-price="' . $product->get_price() . '"
               data-p-id="' . $product->get_id() . '"
               href="#"><i
                        class="fa"
                        aria-hidden="true"></i></a>';
                }
            endif;


        $html .= '</div></div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></div></li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();
}


// Ajax products sorting theme eleven
add_action('wp_ajax_get_products_by_product_tag_theme_eleven', 'get_products_by_product_tag_theme_eleven');
add_action('wp_ajax_nopriv_get_products_by_product_tag_theme_eleven', 'get_products_by_product_tag_theme_eleven');


function get_products_by_product_tag_theme_eleven(){
    
    $post_per_page              = get_option('product_number');
    $cat_id                     = $_POST['cat_id'];
    $offset                     = $_POST['offset'];
    $show_sale                  = $_POST['show_sale'];
    $show_feature               = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids               = $_POST['data_cat_parameter'];
    $link_title_to_modal        = $_POST['link_title_to_modal'];


    $product_tags = $_POST['data_tag'];


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $argss = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $argss = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $argss);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

 
        $args = array(
            'post_type'         => 'product',
            'post_status'       => 'publish',
            'posts_per_page'    => $post_per_page,
            'product_tag'       => $product_tags,
            'orderby'           => get_option('qc_product_sort_type'),
            'order'             => get_option('qc_product_sort_order'),
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
            )
        );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }
    
    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $number_of_product = $product_query->post_count;
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $post_per_page) {
        $nextOffset = $offset;
    } else {
        $nextOffset = -1;
    }
    $html = '';

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        
        $html .= '<li><div class="product-box">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<a href="#" class="woo_tab_product_details too_tab_single_link" product-id="'.$product->get_id().'">';
            }else{ 
            $html .= '<a href="'. $product->get_permalink() .'">';
            }
        $html .= '<div class="product-img">';
        if ( has_post_thumbnail() ):
        $html .= ''. $product->get_image('shop_catalog') .'';
        elseif(empty(has_post_thumbnail()) && empty(get_the_excerpt(get_the_ID()))):
        $html .= ''. $product->get_image('shop_catalog') .'';
        else:
        $html .= ''. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>') .'';
        endif;
        $html .= '<div class="eleven-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div></a>';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
               if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }

        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_one">';

        if(get_option('qc_quick_view_on_off') != 'off'): 
        $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
        endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'): 

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{
                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }
                endif;
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                if ($product->get_type() != 'variable'): 

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="' . $product->add_to_cart_url() . '"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a>';

                    endif;

                else:
                $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                endif;
            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
            }
        endif;


        $html .= '</div >';

        $html .= '</div><div class="clear"></div></div>';                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';
    endwhile;
    $html .= '</li>';
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $nextOffset,
        'product_number' => $number_of_product
    );
    echo wp_send_json($response);
    wp_die();
}



function woo_tabbed_product_tags_by_id( $product_id ){


    $qc_woo_tabbed_display_product_tag  = get_option('qc_woo_tabbed_display_product_tag');

    if(!empty($qc_woo_tabbed_display_product_tag) && ($qc_woo_tabbed_display_product_tag == 'enable')){

        $output = array();

        // get an array of the WP_Term objects for a defined product ID
        $terms = wp_get_post_terms( $product_id, 'product_tag' );

        // Loop through each product tag for the current product
        if( count($terms) > 0 ){
            foreach($terms as $term){
                $term_id = $term->term_id; // Product tag Id
                $term_name = $term->name; // Product tag Name
                $term_slug = $term->slug; // Product tag slug
                $term_link = get_term_link( $term, 'product_tag' ); // Product tag link

                // Set the product tag names in an array
                $output[] = '<a href="#">'.$term_name.'</a>';
            }
            // Set the array in a coma separated string of product tags for example
            $output = implode( ', ', $output );

            // Display the coma separated string of the product tags
            echo '<div class="qcld_woo_pro_tags">'.$output.'</div>';
        }else{
          echo '<div class="qcld_woo_pro_tags"></div>';  
        }


    }

}

function woo_tabbed_product_tags_by_id_ajax($product_id){

    $qc_woo_tabbed_display_product_tag  = get_option('qc_woo_tabbed_display_product_tag');

    if(!empty($qc_woo_tabbed_display_product_tag) && ($qc_woo_tabbed_display_product_tag == 'enable')){

        $output = array();

        // get an array of the WP_Term objects for a defined product ID
        $terms = wp_get_post_terms( $product_id, 'product_tag' );

        // Loop through each product tag for the current product
        if( count($terms) > 0 ){
            foreach($terms as $term){
                $term_id = $term->term_id; // Product tag Id
                $term_name = $term->name; // Product tag Name
                $term_slug = $term->slug; // Product tag slug
                $term_link = get_term_link( $term, 'product_tag' ); // Product tag link

                // Set the product tag names in an array
                $output[] = '<a href="#">'.$term_name.'</a>';
            }
            // Set the array in a coma separated string of product tags for example
            $output = implode( ', ', $output );

            // Display the coma separated string of the product tags
            return '<div class="qcld_woo_pro_tags">'.$output.'</div>';
        }else{
          return '<div class="qcld_woo_pro_tags"></div>';  
        }


    }

}