<?php 
defined('ABSPATH') or die("No direct script access!");

/***********************************************
 * Ajax load products sorting theme three
************************************************/

add_action('wp_ajax_get_products_by_cat_short_theme_default', 'get_products_by_cat_short_theme_default');
add_action('wp_ajax_nopriv_get_products_by_cat_short_theme_default', 'get_products_by_cat_short_theme_default');

function get_products_by_cat_short_theme_default(){
    
    $post_per_page              = get_option('product_number');
    $product_number             = get_option('product_number');
    $cat_id                     = isset($_POST['cat_id'])                   ? sanitize_text_field( $_POST['cat_id'] ) :'';
    $offset                     = isset($_POST['offset'])                   ? sanitize_text_field( $_POST['offset'] ) :'';
    $show_sale                  = isset($_POST['show_sale'])                ? sanitize_text_field( $_POST['show_sale'] ) :'';
    $show_feature               = isset($_POST['feature_only'])             ? sanitize_text_field( $_POST['feature_only'] ) :'';
    $sorting_val                = isset($_POST['sorting_val'])              ? sanitize_text_field( $_POST['sorting_val'] ) :'';
    
    $qc_shortcode_parameters    = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $category_ids               = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $link_title_to_modal        = isset($_POST['link_title_to_modal'])      ? sanitize_text_field( $_POST['link_title_to_modal'] ) :'';


    //$column_number = 4;
    $column_number = get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number'): 4;

    if ($cat_id == 'all') {

        $nextOffset = $offset;

    }else{

        $args = array(
        'post_type'             => 'product',
        'post_status'           => 'publish',
        'posts_per_page'        => $post_per_page,
        'offset'                => $offset,
        'orderby'               => get_option('qc_product_sort_type'),
        'order'                 => get_option('qc_product_sort_order'),
        'tax_query'             => array(
                                'relation' => 'OR',
                                array(
                                    'taxonomy' => 'product_cat',
                                    'field' => 'term_id',
                                    'terms' => $qc_shortcode_parameters,
                                    'operator' => 'IN'
                        ),
                    )
                );

        

        if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

            $args = array_merge($args, array( 'meta_query' => array(
                        array(
                            'key'       => '_stock_status',
                            'value'     => 'instock',
                        ),
                )));
        }

        $product_query = new WP_Query($args);

        $products_num = $product_query->post_count;
        if ($products_num == $post_per_page) {
            $nextOffset = intval($offset + $post_per_page);
        } else {
            $nextOffset = -1;
        }

    }

    $qcld_order_by = esc_attr(get_option('qc_product_sort_type'));

    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $qcld_order_by = '_price';
    }

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }
    

    $qcld_order_by = esc_attr(get_option('qc_product_sort_type'));
    $qcld_order_type = esc_attr(get_option('qc_product_sort_order'));

    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $qcld_order_by = '_price';
        $qcld_order_type = $qcld_order_type;

        if(!function_exists('woocommerce_shortcode_products_orderby')){

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                if( isset( $args['orderby'] ) ) {
                    $args['meta_key']   = '_price';
                    $args['orderby']    = 'meta_value_num';
                    $args['order']      = esc_attr(get_option('qc_product_sort_order')); 
                }

                return $args;

            }
        }

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        add_filter( 'woocommerce_shortcode_products_query', function( $query_args, $atts, $loop_name ){
            
                $query_args['meta_query'] = array( array(
                    'key'     => '_stock_status',
                    'value'   => 'outofstock',
                    'compare' => 'NOT LIKE',
                ) );
            
            return $query_args;
        }, 10, 3);
    }


    $html = sprintf(  __( '%s' ), do_shortcode('[products category="'.$qc_shortcode_parameters.'"  limit='.get_option('product_number').' columns='.$column_number.'  orderby="'.esc_attr($qcld_order_by) . '" order="'.esc_attr(get_option('qc_product_sort_order')) . '"]') );

    $response = array(
        'cat_id'    => $cat_id,
        'html'      => $html,
        'offset'    => $nextOffset
    );

    echo wp_send_json($response);
    wp_die();

}




/***********************************************
 * Ajax load products on shorting theme one and two
************************************************/

add_action('wp_ajax_products_by_catalog_short_theme_default', 'products_by_catalog_short_theme_default');
add_action('wp_ajax_nopriv_products_by_catalog_short_theme_default', 'products_by_catalog_short_theme_default');


function products_by_catalog_short_theme_default()
{
    $post_per_page              = get_option('product_number');
    $product_number             = get_option('product_number');
    $cat_id                     = isset($_POST['cat_id'])                   ? sanitize_text_field( $_POST['cat_id'] ) :'';
    $offset                     = isset($_POST['offset'])                   ? sanitize_text_field( $_POST['offset'] ) :'';
    $show_sale                  = isset($_POST['show_sale'])                ? sanitize_text_field( $_POST['show_sale'] ) :'';
    $show_feature               = isset($_POST['feature_only'])             ? sanitize_text_field( $_POST['feature_only'] ) :'';
    $sorting_val                = isset($_POST['sorting_val'])              ? sanitize_text_field( $_POST['sorting_val'] ) :'';
    
    $qc_shortcode_parameters    = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $category_ids               = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $link_title_to_modal        = isset($_POST['link_title_to_modal'])      ? sanitize_text_field( $_POST['link_title_to_modal'] ) :'';


    //$column_number = 4;
    $column_number = get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number'): 4;

        if($sorting_val == 'popularity'){

           $qcld_order_by = 'total_sales';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

		    function woocommerce_shortcode_products_orderby( $args ) {

		        if( isset( $args['orderby'] ) ) {
		            $args['meta_key'] = 'total_sales';
		            $args['orderby'] = 'meta_value_num';
		            $args['order'] = 'DESC';
		        }

		        return $args;

		    }


        }else if($sorting_val == 'rating'){

           $qcld_order_by = 'meta_value_num';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

		    function woocommerce_shortcode_products_orderby( $args ) {

		        if( isset( $args['orderby'] ) ) {
		            $args['meta_key'] = '_wc_average_rating';
		            $args['orderby'] = 'meta_value_num';
		            $args['order'] = 'DESC';
		        }

		        return $args;

		    }

        }else if($sorting_val == 'date'){

           $qcld_order_by = 'date';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

		    function woocommerce_shortcode_products_orderby( $args ) {

		        if( isset( $args['orderby'] ) ) {
		            $args['orderby'] = 'date';
		            $args['order'] = 'DESC';
		        }

		        return $args;

		    }

        }else if($sorting_val == 'price'){

           $qcld_order_by = '_price';
           $qcld_order_type = 'ASC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

		    function woocommerce_shortcode_products_orderby( $args ) {

		        if( isset( $args['orderby'] ) ) {
		            $args['meta_key'] = '_price';
		            $args['orderby'] = 'meta_value_num';
		            $args['order'] = 'ASC'; 
		        }

		        return $args;

		    }


        }else if($sorting_val == 'price-desc'){

           $qcld_order_by = '_price';
           $qcld_order_type = 'DESC';

           add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

		    function woocommerce_shortcode_products_orderby( $args ) {

		        $standard_array = array('menu_order','title','date','rand','id');

		        if( isset( $args['orderby'] ) && !in_array( $args['orderby'], $standard_array ) ) {
		            $args['meta_key'] = '_price';
		            $args['orderby'] = 'meta_value_num';
		            $args['order'] = 'DESC'; 
		        }

		        return $args;

		    }


        }else{

            $qcld_order_by = esc_attr(get_option('qc_product_sort_type'));
            $qcld_order_type = esc_attr(get_option('qc_product_sort_order'));

            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                $qcld_order_by = '_price';
                $qcld_order_type = $qcld_order_type;

                if(!function_exists('woocommerce_shortcode_products_orderby')){

                    add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

                    function woocommerce_shortcode_products_orderby( $args ) {

                        if( isset( $args['orderby'] ) ) {
                            $args['meta_key']   = '_price';
                            $args['orderby']    = 'meta_value_num';
                            $args['order']      = esc_attr(get_option('qc_product_sort_order')); 
                        }

                        return $args;

                    }
                }

            }


        }


        $args = array(
            'post_type'             => 'product',
            'post_status'           => 'publish',
            'posts_per_page'        => $post_per_page,
            'offset'                => $offset,
            'orderby'               => get_option('qc_product_sort_type'),
            'order'                 => get_option('qc_product_sort_order'),
            'tax_query'             => array(
                                    'relation' => 'OR',
                                    array(
                                        'taxonomy' => 'product_cat',
                                        'field' => 'term_id',
                                        'terms' => $qc_shortcode_parameters,
                                        'operator' => 'IN'
                            ),
                        )
                    );

        $product_query = new WP_Query($args);

        $products_num = $product_query->post_count;
        if ($products_num == $post_per_page) {
            $nextOffset = intval($offset + $post_per_page);
        } else {
            $nextOffset = -1;
        }
    

    $html = do_shortcode('[products category="'.$qc_shortcode_parameters.'"  limit='.$product_number.' columns='.$column_number.' orderby="'.$qcld_order_by.'" order="'.$qcld_order_type.'"]');


    wp_reset_query();

    $response = array(
        'cat_id'    => $cat_id,
        'html'      => $html,
        'offset'    => $nextOffset
    );

    echo wp_send_json($response);
    wp_die();

}


/***********************************************
 * Theme One Load More 
************************************************/

add_action('wp_ajax_woo_load_more_theme_default', 'qcld_wootab_woo_load_more_theme_default');
add_action('wp_ajax_nopriv_woo_load_more_theme_default', 'qcld_wootab_woo_load_more_theme_default');

function qcld_wootab_woo_load_more_theme_default()
{

    //$column_number = 4;
    $column_number = get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number'): 4;

    $show_per_page              = get_option('product_number');
    $cat_id                     = isset($_POST['product_cat_id'])           ? sanitize_text_field( $_POST['product_cat_id'] ) :'';
    $offset                     = isset($_POST['offset'])                   ? sanitize_text_field( $_POST['offset'] ) :'';
    $show_sale                  = isset($_POST['show_sale'])                ? sanitize_text_field( $_POST['show_sale'] ) :'';
    $show_feature               = isset($_POST['feature_only'])             ? sanitize_text_field( $_POST['feature_only'] ) :'';
    $sorting_val                = isset($_POST['sorting_val'])              ? sanitize_text_field( $_POST['sorting_val'] ) :'';
    
    $qc_shortcode_parameters    = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $category_ids               = isset($_POST['data_cat_parameter'])       ? sanitize_text_field( $_POST['data_cat_parameter'] ) :'';
    $link_title_to_modal        = isset($_POST['link_title_to_modal'])      ? sanitize_text_field( $_POST['link_title_to_modal'] ) :'';

    $categories_all = '';

    if (!empty($qc_shortcode_parameters) ) {
        $category_ids = $qc_shortcode_parameters;
        $categories_all = explode(',', $category_ids);

    } else {
        $categories_all = $cat_id;
    }

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

     if($sorting_val == 'popularity'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );


           $qcld_order_by = 'total_sales';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                if( isset( $args['orderby'] ) ) {
                    $args['meta_key'] = 'total_sales';
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'DESC';
                }

                return $args;

            }


        }else if($sorting_val == 'rating'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );



           $qcld_order_by = 'meta_value_num';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                if( isset( $args['orderby'] ) ) {
                    $args['meta_key'] = '_wc_average_rating';
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'DESC';
                }

                return $args;

            }


        }else if($sorting_val == 'date'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'                => $offset,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );



           $qcld_order_by = 'date';
           $qcld_order_type = 'DESC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                if( isset( $args['orderby'] ) ) {
                    $args['orderby'] = 'date';
                    $args['order'] = 'DESC';
                }

                return $args;

            }

        }else if($sorting_val == 'price'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );



           $qcld_order_by = '_price';
           $qcld_order_type = 'ASC';

            add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                if( isset( $args['orderby'] ) ) {
                    $args['meta_key'] = '_price';
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'ASC'; 
                }

                return $args;

            }


        }else if($sorting_val == 'price-desc'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );



           $qcld_order_by = '_price';
           $qcld_order_type = 'DESC';

           add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

            function woocommerce_shortcode_products_orderby( $args ) {

                $standard_array = array('menu_order','title','date','rand','id');

                if( isset( $args['orderby'] ) && !in_array( $args['orderby'], $standard_array ) ) {
                    $args['meta_key'] = '_price';
                    $args['orderby'] = 'meta_value_num';
                    $args['order'] = 'DESC'; 
                }

                return $args;

            }

        }else{

          $args = array(
                'post_type'             => 'product',
                'post_status'           => 'publish',
                'posts_per_page'        => $show_per_page,
                'offset'                => $offset,
                'meta_key'              => $sorting,
                'orderby'               => $orderBy,
                'order'                 => get_option('qc_product_sort_order'),
                'tax_query'             => array(
                                        'relation' => 'OR',
                                        array(
                                            'taxonomy' => 'product_cat',
                                            'field' => 'term_id',
                                            'terms' => $categories_all,
                                            'operator' => 'IN'
                                ),
                            )
                        );

            $qcld_order_by = esc_attr(get_option('qc_product_sort_type'));
            $qcld_order_type = esc_attr(get_option('qc_product_sort_order'));

            if(get_option('qc_product_sort_type') == 'meta_value_num'){
                $qcld_order_by = '_price';
                $qcld_order_type = $qcld_order_type;

                if(!function_exists('woocommerce_shortcode_products_orderby')){

                    add_filter( 'woocommerce_shortcode_products_query', 'woocommerce_shortcode_products_orderby' );

                    function woocommerce_shortcode_products_orderby( $args ) {

                        if( isset( $args['orderby'] ) ) {
                            $args['meta_key']   = '_price';
                            $args['orderby']    = 'meta_value_num';
                            $args['order']      = esc_attr(get_option('qc_product_sort_order')); 
                        }

                        return $args;

                    }
                }

            }


        }

    

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                    array(
                        'key'       => '_stock_status',
                        'value'     => 'instock',
                    ),
            )));
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }



    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $show_per_page) {
        $nextOffset = intval($offset + $show_per_page);
    } else {
        $nextOffset = -1;
    }
    $html = '';

    
    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        add_filter( 'woocommerce_shortcode_products_query', function( $query_args, $atts, $loop_name ){
            
                $query_args['meta_query'] = array( array(
                    'key'     => '_stock_status',
                    'value'   => 'outofstock',
                    'compare' => 'NOT LIKE',
                ) );
            
            return $query_args;
        }, 10, 3);
    }

    $html = do_shortcode('[products category="'.$qc_shortcode_parameters.'" limit='.$nextOffset.' columns='.$column_number.' orderby="'.$qcld_order_by.'" order="'.$qcld_order_type.'"]');

    wp_reset_query();
    $response = array(
        'show_per_page' => $show_per_page,
        'product_num'   => $products_num,
        'html'          => $html,
        'offset'        => $nextOffset
    );

    echo wp_send_json($response);
    wp_die();

}