<?php 
defined('ABSPATH') or die("No direct script access!");

/***********************************************
 * Ajax load products theme thirteen
************************************************/

add_action('wp_ajax_get_products_by_cat_theme_thirteen', 'get_products_by_cat_theme_thirteen');
add_action('wp_ajax_nopriv_get_products_by_cat_theme_thirteen', 'get_products_by_cat_theme_thirteen');


function get_products_by_cat_theme_thirteen(){

    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids    = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

         $args =  array_merge($args, array( 'tax_query' => array(
                            array(
                                'taxonomy' => 'product_visibility',
                                'field'    => 'name',
                                'terms'    => 'exclude-from-catalog',
                                'operator' => 'NOT IN',
                            ),
                    )));


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {

            $show_featured_only = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
                array(
                    'taxonomy' => 'product_visibility',
                    'field' => 'name',
                    'terms' => 'featured',
                    'operator' => 'IN'
                )
            ));
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));


    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

   
        $html = '<div class="qc-product-content-wrapper"><ul>';


    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();

        $html .= '<li product-id="'.$product->get_id().'">
              <div class="qc-product-content-wrap">
                <div class="qc-product-img-box">
                  <a href="">
                    '.$product->get_image('shop_catalog').'
                  </a>
                </div>
                <div class="qc-product-content-box">
                  <h2>'.$product->get_title().'</h2>
                  <p>'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</p>
                </div>
              </div>
              </li>';

        endwhile;
        wp_reset_query();
        $html .= '</ul></div>';
    wp_reset_query();
    $response = array( 'html' => $html );
    echo wp_send_json($response);
    wp_die();

}


/***********************************************
 * theme thirteen single product load
************************************************/

add_action('wp_ajax_get_products_by_thirteen_single_product', 'get_products_by_thirteen_single_product');
add_action('wp_ajax_nopriv_get_products_by_thirteen_single_product', 'get_products_by_thirteen_single_product');


function get_products_by_thirteen_single_product(){


    $product_id = $_POST['product_id'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $product = wc_get_product($product_id);
    global $woocommerce;
    global $post;

    $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id($product_id), 'shop_thumbnail');
    $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( $product_id ), 'single-post-thumbnail' );

    if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
    } else {
        $image[0] = QC_WOO_TAB_IMAGE_URL . '/placeholder.png';
        $image_large[0]=QC_WOO_TAB_IMAGE_URL.'/placeholder.png';
    }
    ob_start();
    ?>


        <div class="qc-product-single-img-box">
            <?php 
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){ 
            ?>
                <a href="#" class="woo_tab_product_details" product-id="<?php echo $product->get_id(); ?>">
                    <img  src="<?php echo $image_large[0]; ?>" alt="<?php echo $product->get_title(); ?>" />
                </a>
            <?php }else{  ?>
                <a href="<?php echo $product->get_permalink(); ?>">
                    <img  src="<?php echo $image_large[0]; ?>" alt="<?php echo $product->get_title(); ?>" /> 
                </a>
            <?php } ?>
        </div>

            <div class="qc-product-single-content-box">

                <h2>
                    <?php 
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){ 
                    ?>
                        <a href="#" class="woo_tab_product_details" product-id="<?php echo $product->get_id(); ?>"><?php echo $product->get_title(); ?></a>
                    <?php }else{  ?>
                        <a href="<?php echo $product->get_permalink(); ?>"> <?php echo $product->get_title(); ?> </a>
                    <?php } ?>
                </h2>
                <p><?php echo $product->get_price_html(); ?></p>
                <p> 
                <?php  echo  wc_get_product_category_list( $product->get_id(), ', ', '<span class="posted_in">' . _n( 'Category:', 'Categories:', count( $product->get_category_ids() ), 'woocommerce' ) . ' ', '</span>' ); ?>
                </p>
                <?php if ($average = $product->get_average_rating()) : ?>
                <ul class="woocommerce">
                    <li>
                    <div class="star-rating" title="<?php echo sprintf(__( 'Rated %s out of 5', 'woocommerce' ), $average); ?>"><span style="width:<?php echo ( ( $average / 5 ) * 100 ); ?>%"><strong itemprop="ratingValue" class="rating"><?php echo $average; ?></strong><?php echo __( 'out of 5', 'woocommerce' ); ?></span></div>
                    </li>
                </ul>
                <?php  endif; ?>
            <?php 
                 if(intval($product_id)) {

               wp('p=' . $product_id . '&post_type=product');
               
                while (have_posts()) : the_post();

                    //thirteen_category_read_more_btn
                ?>
                <div class="qcld_the_content">
                   <div class="qcld_read_more_wrap">
                    <?php 

                        $maxWords = get_option('thirteen_category_rm_max_word') ? get_option('thirteen_category_rm_max_word') : 20; // Change this to your preferences 
                        $description = strip_tags(get_the_content()); // Remove HTML to get the plain text
                        $words = explode(' ', $description);
                        $trimmedWords = array_slice($words, 0, $maxWords);
                        $trimmedText = join(' ', $trimmedWords);

                        if(strlen($trimmedText) < strlen($description)){
                            $thirteen_category_read_more_btn = get_option('thirteen_category_read_more_btn') ? get_option('thirteen_category_read_more_btn') : '';

                            if( $thirteen_category_read_more_btn == 1){

                                $trimmedText .= ' &mdash; <a href="'.$product->get_permalink().'" class="qcld_read_mores">'.esc_html('Read More').'</a>';
                            }else if( $thirteen_category_read_more_btn == 2){

                                $trimmedText = get_the_content() . ' &mdash; <a href="'.$product->get_permalink().'" class="qcld_read_mores">'.esc_html('Read More').'</a>';
                            }else{

                                $trimmedText .= ' &mdash; <a href="#" class="qcld_read_more">'.esc_html('Read More').'</a>';
                            }

                        }

                        echo $trimmedText; 

                   ?>
                    </div>
                    <div class="qcld_the_content_wrap" style="display: none">
                        <p><?php  echo get_the_content();  ?></p>
                    </div> 
                </div>

                    <script>
                        var wc_add_to_cart_variation_params = {"ajax_url": "\/wp-admin\/admin-ajax.php"};
                        jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");

                    </script>
                    <div class="qc-product-variation-container">
                         <div class="product">
                            <div id="product-<?php the_ID(); ?>" <?php post_class('product'); ?>>
                                <?php 
                                    do_action('qcld_express_product_variations'); 
                                ?>

                            </div>
                        </div>
                    </div>

             <?php

                endwhile;
                wp_reset_query();
            }

            ?>    
        </div>
        <?php

    echo  ob_get_clean();
    exit();

}

remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_excerpt', 20 );
add_action( 'woocommerce_single_product_summary', 'bbloomer_template_single_long_description', 20 );
 
function bbloomer_template_single_long_description() {
   strip_tags( get_the_excerpt() );
}

add_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_excerpt', 20 );