<?php 
defined('ABSPATH') or die("No direct script access!");

/***********************************************
 * Ajax load products sorting theme three
************************************************/

add_action('wp_ajax_get_products_by_cat_short_theme_slider', 'get_products_by_cat_short_theme_slider');
add_action('wp_ajax_nopriv_get_products_by_cat_short_theme_slider', 'get_products_by_cat_short_theme_slider');


function get_products_by_cat_short_theme_slider(){

    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];
    
    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids    = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

        $args = array_merge($args, array( 'tax_query' => array(
                    array(
                        'taxonomy' => 'product_visibility',
                        'field'    => 'name',
                        'terms'    => 'exclude-from-catalog',
                        'operator' => 'NOT IN',
                    ),
                )));


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {

                $show_featured_only = array('relation' => 'OR', array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                    array(
                        'taxonomy' => 'product_visibility',
                        'field' => 'name',
                        'terms' => 'featured',
                        'operator' => 'IN'
                    )
                ));

            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

       

    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {

            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();
    $html = '<div class="qcld_template_slide_wrapper">
                <div class="qcld_template_slide_carousel">';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();


        $html .= '<div>
        <div class="qcld_template_slide_card">
          <div class="qcld_template_slide_card-header '.qcld_product_product_has_gallery( get_the_ID() ).'">';
            
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){ 
            
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">';  

             }else{ 
                $html .= '<a href="'.$product->get_permalink().'">';
            } 
             $html .= $product->get_image('shop_catalog'); 
             $html .= qcld_product_second_product_thumbnail(get_the_ID()); 
           $html .= ' </a>
          </div>
          <div class="qcld_template_slide_card-body">
            <div class="qcld_template_slide_card-content">
              <div class="qcld_template_slide_card-title">';

                if (get_option('product_title') == 1): 
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){ 

                    $html .= '<a style="color: '.get_option('product_title_text_color').'; font-size: '.get_option('change_title_text_size').'px;" href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">'.$product->get_title().'</a>';  
                }else{ 

                    $html .= '<a style="color: '.get_option('product_title_text_color').'; font-size: '.get_option('change_title_text_size') . 'px;'.'" href="'.$product->get_permalink().'">'.$product->get_title().'</a>';

                } 
            endif; 

              $html .= '</div>
              <div class="qcld_template_slide_card-text">';

                $html .= '<div class="one-description"> '.strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), "<br>").' </div>';


                if (get_option('display_price') == 1):
                    $html .= '<div class="qc-woprice"
                         style="font-size: '.get_option('product_content_text_size').'px; color: '.get_option('product_content_text_color').';">'.$product->get_price_html().'</div>';
                endif; 

                if (get_option('add_cart_link') == 1): 
                    if ($product_stock_status != 'outofstock') { 
                           
                        if ($product->get_type() != 'variable'): 

                            $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                            if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):
                            $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                            
                            $html .= '<a class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart"
                               data-quantity="'.($min_qty ? $min_qty : 1).'" 
                               data-product_id="'.$product->get_id().'"
                               data-p-price="'.$product->get_price().'"
                               data-p-id="'.$product->get_id().'"
                               href="#">';
                                $add_to_cart_text = get_option('change_add_to_cart_button_text');
                                    if (!empty($add_to_cart_text)) {
                                        $html .= esc_html($add_to_cart_text, 'woo-tabbed-category' );
                                    } else {
                                        $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                                    } 
                               
                               $html .= '</a>';
                            else:
                            $html .= '<a class="woo_tab_s_p_add_to_cart"
                               data-p-price="'.$product->get_price().'"
                               data-p-id="'.$product->get_id().'"
                               href="'.$product->add_to_cart_url().'">'; 

                            
                                
                                $add_to_cart_text = get_option('change_add_to_cart_button_text');
                                    if (!empty($add_to_cart_text)) {
                                        $html .= esc_html($add_to_cart_text, 'woo-tabbed-category' );
                                    } else {
                                        $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                                    } 
                                
                                                
                               $html .= ' </a>';
                            endif;
                            else: 

                            $html .= '<a class="woo_tab_product_details" product-id="'.get_the_ID().'"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                            endif; 


                        } else { 
                            $html .='<a class="product_out_of_stock"
                               data-p-price="'.$product->get_price().'"
                               data-p-id="'.$product->get_id().'"
                               href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                         } 
                    endif;

 
        


        $html .= '</div></div></div></div></div>';
    endwhile;
        $html .= '</div></div>';
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $offset
    );
    echo wp_send_json($response);
    wp_die();

}